commit 4b73f2ec19a99ef465282fbce633e8deb33691b3
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2026-03-31 17:26:16 +0300

    Bump version and soname for 5.8.3

 src/liblzma/Makefile.am        | 2 +-
 src/liblzma/api/lzma/version.h | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 97b7440006d69a30048ff1ffc29fc7a0615e5d51
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2026-03-31 17:26:16 +0300

    Add NEWS for 5.8.3

 NEWS | 54 ++++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 54 insertions(+)

commit 8e1022cfb1d177e482e487c202a0ab43dee761a3
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2026-03-31 17:10:47 +0300

    Translations: Run "make -C po update-po"
    
    Update the PO files to contain the comment fix from 4e76651dbaf6.

 po/ca.po    | 148 ++++++++++++++++++++++++++++++------------------------------
 po/cs.po    | 148 ++++++++++++++++++++++++++++++------------------------------
 po/da.po    | 148 ++++++++++++++++++++++++++++++------------------------------
 po/de.po    | 148 ++++++++++++++++++++++++++++++------------------------------
 po/eo.po    | 148 ++++++++++++++++++++++++++++++------------------------------
 po/es.po    | 148 ++++++++++++++++++++++++++++++------------------------------
 po/fi.po    | 148 ++++++++++++++++++++++++++++++------------------------------
 po/fr.po    | 148 ++++++++++++++++++++++++++++++------------------------------
 po/hr.po    | 148 ++++++++++++++++++++++++++++++------------------------------
 po/hu.po    | 148 ++++++++++++++++++++++++++++++------------------------------
 po/it.po    | 148 ++++++++++++++++++++++++++++++------------------------------
 po/ka.po    | 148 ++++++++++++++++++++++++++++++------------------------------
 po/ko.po    | 148 ++++++++++++++++++++++++++++++------------------------------
 po/nl.po    | 148 ++++++++++++++++++++++++++++++------------------------------
 po/pl.po    | 148 ++++++++++++++++++++++++++++++------------------------------
 po/pt.po    | 148 ++++++++++++++++++++++++++++++------------------------------
 po/pt_BR.po | 148 ++++++++++++++++++++++++++++++------------------------------
 po/ro.po    | 148 ++++++++++++++++++++++++++++++------------------------------
 po/sr.po    | 148 ++++++++++++++++++++++++++++++------------------------------
 po/sv.po    | 148 ++++++++++++++++++++++++++++++------------------------------
 po/tr.po    | 148 ++++++++++++++++++++++++++++++------------------------------
 po/uk.po    | 148 ++++++++++++++++++++++++++++++------------------------------
 po/vi.po    | 148 ++++++++++++++++++++++++++++++------------------------------
 po/zh_CN.po | 148 ++++++++++++++++++++++++++++++------------------------------
 po/zh_TW.po | 148 ++++++++++++++++++++++++++++++------------------------------
 25 files changed, 1850 insertions(+), 1850 deletions(-)

commit a3ea8832bec11128597c454f5d14d05ef6010e3f
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2026-03-29 20:29:40 +0300

    Tests: Add a test for the lzma_index_prealloc() + lzma_index_append() bug

 tests/test_index.c | 35 +++++++++++++++++++++++++++++++++++
 1 file changed, 35 insertions(+)

commit c8c22869e780ff57c96b46939c3d79ff99395f87
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2026-03-29 19:11:21 +0300

    liblzma: Fix a buffer overflow in lzma_index_append()
    
    If lzma_index_decoder() was used to decode an Index that contained no
    Records, the resulting lzma_index had an invalid internal "prealloc"
    value. If lzma_index_append() was called on this lzma_index, too
    little memory would be allocated and a buffer overflow would occur.
    
    While this combination of the API functions is meant to work, in the
    real-world apps this call sequence is rare or might not exist at all.
    
    This bug is older than xz 5.0.0, so all stable releases are affected.
    
    Reported-by: GitHub user christos-spearbit

 src/liblzma/common/index.c | 21 +++++++++++++++++++++
 1 file changed, 21 insertions(+)

commit a37658bec72ed581a683b7498a75a70122b831b0
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2026-03-27 21:15:12 +0200

    CMake: Adjust warnings with MSVC and clang-cl
    
    When using clang-cl, avoid the long list of warning options used with
    GCC and Clang because, for MSVC compatibility, clang-cl's -Wall behaves
    like -Weverything.
    
    Add warning options for MSVC. Use them with clang-cl too.

 CMakeLists.txt | 21 ++++++++++++++++++++-
 1 file changed, 20 insertions(+), 1 deletion(-)

commit 9e499f714cade4beade31c86dcb0de9fc72d0562
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2026-03-27 21:14:50 +0200

    CI: Don't disable individual warnings with clang-cl

 .github/workflows/msvc.yml | 13 -------------
 1 file changed, 13 deletions(-)

commit 1e00837f72e0551ab73927642a8f61aad80c958d
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2026-03-22 12:02:48 +0200

    CI: Add Haiku

 .github/workflows/haiku.yml | 38 ++++++++++++++++++++++++++++++++++++++
 1 file changed, 38 insertions(+)

commit 8082851b7848ac32fea7bc7cfb84d9b3ef5537b0
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2026-03-22 11:30:20 +0200

    Update THANKS

 THANKS | 1 +
 1 file changed, 1 insertion(+)

commit 3cdd412bcea6bb5b4c5d41d2b4104230a5a9569c
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2026-03-22 11:29:30 +0200

    CI: Update MSYS2
    
    Closes: https://github.com/tukaani-project/xz/pull/213

 .github/workflows/msys2.yml | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit e38a4af340ca9738923a511b7e35b6390c03ec50
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2026-03-22 11:29:23 +0200

    CI: Update Solaris
    
    Closes: https://github.com/tukaani-project/xz/pull/213

 .github/workflows/solaris.yml | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 40b1599217cc4f7cca6f48e0c32e709b9abd3639
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2026-03-22 11:29:14 +0200

    CI: Update OpenBSD
    
    Closes: https://github.com/tukaani-project/xz/pull/213

 .github/workflows/openbsd.yml | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 3aaf2f136c3fcf1140b9dfa584640778be789abc
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2026-03-22 11:29:08 +0200

    CI: Update NetBSD
    
    Closes: https://github.com/tukaani-project/xz/pull/213

 .github/workflows/netbsd.yml | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit b5c26a249d21d293b441b21d22a1a81e7eec436a
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2026-03-22 11:28:58 +0200

    CI: Update FreeBSD
    
    Closes: https://github.com/tukaani-project/xz/pull/213

 .github/workflows/freebsd.yml | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 1a73f4f917f25d19ae557f49af2fddd9ef9f0a4a
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2026-03-22 11:28:47 +0200

    CI: Update DragonFly BSD
    
    Closes: https://github.com/tukaani-project/xz/pull/213

 .github/workflows/dragonflybsd.yml | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 5d61c5a3cf3be88b16179900ac5be82011a3a6bb
Author: Salman Muin Kayser Chishti <13schishti@gmail.com>
Date:   2026-02-28 09:10:46 +0000

    CI: Upgrade GitHub Actions for Node 24 compatibility
    
    Signed-off-by: Salman Muin Kayser Chishti <13schishti@gmail.com>
    Closes: https://github.com/tukaani-project/xz/pull/212

 .github/workflows/ci.yml           | 4 ++--
 .github/workflows/cifuzz.yml       | 2 +-
 .github/workflows/coverity.yml     | 2 +-
 .github/workflows/dragonflybsd.yml | 2 +-
 .github/workflows/freebsd.yml      | 2 +-
 .github/workflows/msvc.yml         | 2 +-
 .github/workflows/msys2.yml        | 4 ++--
 .github/workflows/netbsd.yml       | 2 +-
 .github/workflows/openbsd.yml      | 2 +-
 .github/workflows/solaris.yml      | 2 +-
 10 files changed, 12 insertions(+), 12 deletions(-)

commit 0ac3b93387c0191919ffa38de5f49f6b28164b35
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2026-03-25 19:03:00 +0200

    xz: Prevent an integer overflow in --files and --files0
    
    This requires a filename (or something that pretends to be a filename)
    of at least 2 GiB on a 32-bit platform, and that realloc() to
    SIZE_MAX / 2 + 1 bytes has succeeded.
    
    Fixes: https://github.com/tukaani-project/xz/pull/218

 src/xz/main.c | 10 ++++++++++
 1 file changed, 10 insertions(+)

commit 2faa141bdb47be94da2eae6df6f08858999a5911
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2026-03-23 23:43:56 +0200

    tuklib_integer: Fix inefficient aligned_writeXXne
    
    The __builtin_assume_aligned was applied to the wrong argument which
    made aligned writes worse on strict-align archs.
    
    Aligned writes aren't used in liblzma, so this bug didn't matter in
    this package; tuklib_integer.h is meant to be usable elsewhere too.

 src/common/tuklib_integer.h | 19 +++++++++----------
 1 file changed, 9 insertions(+), 10 deletions(-)

commit 685538271e3e213a18c5a925654aaa32c0b69f1e
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2026-03-22 10:22:09 +0200

    Build: Remove -Wpre-c2x-compat
    
    It makes clang -std=gnu23 noisy about bool. It's also noisy about
    [[__fallthrough__]] which is only used in C23 mode.
    
    Reported-by: Collin Funk <collin.funk1@gmail.com>

 CMakeLists.txt | 1 -
 configure.ac   | 1 -
 2 files changed, 2 deletions(-)

commit 3a78a82bd380c26bc7afda7565216c3383cedefe
Author: Collin Funk <collin.funk1@gmail.com>
Date:   2026-03-15 23:24:59 -0700

    xz: Don't fsync directories on QNX
    
    On QNX calling fsync on a directory fails with EINVAL. This causes the
    following test failure:
    
        $ cat tests/test_suffix.sh.log
        /data/home/root/xz-5.8.2/src/xz/.libs/lt-xz: suffix_temp: Synchronizing the directory of the file failed: Invalid argument
        Failed to decompress a file with a suffix set in raw format
        FAIL test_suffix.sh (exit status: 1)
    
    Closes: https://github.com/tukaani-project/xz/pull/216

 src/xz/file_io.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit bfc5f12a84a2a9df774ed16cd6eb58fd5ab24646
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2026-02-25 17:33:42 +0200

    Update THANKS

 THANKS | 1 +
 1 file changed, 1 insertion(+)

commit 5553509f1a53ee160ea3bc871c716a75ba0b1ea0
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2026-02-25 00:00:49 +0200

    liblzma: Fix a copy-paste error in commented-out code
    
    Fixes: https://github.com/dotnet/runtime/pull/124003#discussion_r2841960994
    Fixes: 96b663f67c0e ("liblzma: Refactor CRC comments.")

 src/liblzma/check/crc32_fast.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 4e76651dbaf6a0159f2117482d778ff69127fdea
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2026-02-24 18:34:19 +0200

    Fix typos and grammar in comments and docs
    
    Fixes: https://github.com/dotnet/runtime/pull/124003#discussion_r2789354505
    Fixes: https://github.com/dotnet/runtime/pull/124003#discussion_r2789354515
    Fixes: https://github.com/dotnet/runtime/pull/124003#discussion_r2820960196

 po/Makevars                                      | 2 +-
 src/common/tuklib_gettext.h                      | 4 ++--
 src/common/tuklib_mbstr_wrap.h                   | 4 ++--
 src/common/w32_application.manifest.comments.txt | 2 +-
 4 files changed, 6 insertions(+), 6 deletions(-)

commit cd8a6231d084ee9ce0a7a285f99dc5721d1f4317
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2026-02-24 18:24:29 +0200

    tuklib_open_stdxxx: Fix a typo in macro name
    
    It doesn't matter in this package, but it's good to fix it still.
    
    Fixes: https://github.com/dotnet/runtime/pull/124003#discussion_r2782313660

 src/common/tuklib_open_stdxxx.h | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit bf5d32f489fd7f33b2a629f9b78f5157301b49d8
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2026-02-24 18:22:25 +0200

    CMake: Fix a wrong #define
    
    HAVE_SYS_PARAM_H was misspelled HAVE_PARAM_H. This might have broken
    the build on systems where sysctl() is used to detect the amount of RAM
    or the number of processor cores/threads.
    
    The cpuset code for FreeBSD doesn't need the macro it so it was removed.
    
    Fixes: https://github.com/dotnet/runtime/pull/124003#discussion_r2782313680
    Fixes: https://github.com/dotnet/runtime/pull/124003#discussion_r2782313704
    Fixes: 7e3493d40eac ("Build: Add very limited experimental CMake support.")

 cmake/tuklib_cpucores.cmake | 4 ++--
 cmake/tuklib_physmem.cmake  | 2 +-
 2 files changed, 3 insertions(+), 3 deletions(-)

commit b0f3b64a25bcd3a6a4cebc00866dea86590fac3e
Author: Radek Zikmund <r.zikmund.rz@gmail.com>
Date:   2026-02-12 15:24:15 +0100

    liblzma/MSVC: Add a cast to fix a warning (C4057) with __cpuid()
    
    __cpuid from MSVC (and also the old Intel ICC) use int[], while
    __get_cpuid from <cpuid.h> in GCC and Clang use unsigned int[].
    Adding a cast is the simplest fix.
    
    Link: https://github.com/tukaani-project/xz/pull/208

 src/liblzma/check/crc_x86_clmul.h | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit b51d67f4a95f41ae3a64973acc0e44b9f078512f
Author: Radek Zikmund <r.zikmund.rz@gmail.com>
Date:   2026-02-23 17:50:00 +0100

    CMake: Guard script configure_file() calls with ENABLE_SCRIPTS
    
    The configure_file() calls for xzdiff, xzgrep, xzmore, and xzless
    were running unconditionally within the if(UNIX) block, even when
    ENABLE_SCRIPTS was OFF. This would cause a build failure if the
    src/scripts/*.in files were not present. Deleting those files can
    simplify license compliance when the scripts aren't needed.
    
    Move the foreach loop and related code inside if(ENABLE_SCRIPTS) guard
    so that configure_file() is only called when scripts are actually needed.
    This is mostly whitespace changes to adjust the indentation.
    
    Co-authored-by: Lasse Collin <lasse.collin@tukaani.org>
    Closes: https://github.com/tukaani-project/xz/pull/210

 CMakeLists.txt | 68 ++++++++++++++++++++++++++++------------------------------
 1 file changed, 33 insertions(+), 35 deletions(-)

commit 1007bf08b5fddf088b3131e692210af4b4b7fd8c
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2026-02-04 12:28:07 +0200

    Translations: Add Arabic man page translations
    
    Rendering of bidirectional text from man pages might not work perfectly
    in all cases.

 po4a/ar.po     | 3905 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 po4a/po4a.conf |    2 +-
 2 files changed, 3906 insertions(+), 1 deletion(-)

commit 54147ad65af12d9e4f60a8ce59094a8a30ad5919
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2026-01-25 13:51:09 +0200

    Update THANKS

 THANKS | 1 +
 1 file changed, 1 insertion(+)

commit d6bdb446f8da47ac2af8c309de8e7c80beae850e
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2026-01-25 13:30:46 +0200

    liblzma: Add the "License" property to liblzma.pc
    
    The "License" property is a pkgconf extension. See pc(5).
    pkg-config 0.29.2 (2017) ignores unrecognized properties so this
    commit shouldn't create compatibility issues.
    
    pkgconf provides bomtool which uses the "License" property to generate
    a software bill of materials. In pkgconf.git there is spdxtool for the
    same task but with different output format.
    
    The pkgconf extensions "Copyright" and "Maintainer" would also be
    used by bomtool and spdxtool, but I don't want to add those properties
    at least for now.
    
    Co-authored-by: Nobuhiro Iwamatsu <iwamatsu@nigauri.org>
    Closes: https://github.com/tukaani-project/xz/pull/178

 src/liblzma/liblzma.pc.in | 1 +
 1 file changed, 1 insertion(+)

commit 687bd3e30fbe54ae906d06a93e7f2aa8b121aa7b
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2026-01-25 12:14:46 +0200

    Update THANKS

 THANKS | 2 ++
 1 file changed, 2 insertions(+)

commit b80b6343a4b7df6bf56dcf07715f9f536af93306
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2026-01-25 12:14:25 +0200

    liblzma: Don't try to use x86-64 inline asm on ARM64EC
    
    Reported-by: Chase Knowlden
    Fixes: https://github.com/tukaani-project/xz/issues/206

 src/liblzma/rangecoder/range_decoder.h | 1 +
 1 file changed, 1 insertion(+)

commit 47fb9d84c052912ca10dc9843cb296c860b182ac
Author: Pino Toscano <toscano.pino@tiscali.it>
Date:   2025-12-30 19:59:55 +0100

    Autotools: Enable x86 assembler on Hurd by default
    
    It has been enabled in Debian GNU/Hurd for 15+ years with no issues.
    Hence, enable it by default also in the upstream sources.
    
    The CMake build already had it enabled.
    
    Link: https://salsa.debian.org/debian/xz-utils/-/blob/debian/5.8.2-2/debian/rules?ref_type=tags#L98
    Closes: https://github.com/tukaani-project/xz/pull/204

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 9f4c5a0d4817c9c7011cdfd00cfbe0ddda66a455
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-12-17 14:49:12 +0200

    doc/SHA256SUMS: Add 5.8.2

 doc/SHA256SUMS | 6 ++++++
 1 file changed, 6 insertions(+)

commit 3d078b52adbff566ccfc51067dfbf742ecf3ef86
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-12-17 13:36:42 +0200

    Bump version and soname for 5.8.2

 src/liblzma/Makefile.am        | 2 +-
 src/liblzma/api/lzma/version.h | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit fb14afd5c9bf14d8c67ee11e4139885072071ddd
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-12-17 13:36:35 +0200

    Add NEWS for 5.8.2

 NEWS | 72 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 72 insertions(+)

commit 590f4713b29f0236ab944487f40069355a515dbc
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-12-16 11:30:35 +0200

    CMake: Bump maximum policy version to 4.2
    
    CMP0186 is curious but we aren't affected.

 CMakeLists.txt | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 26d22ed16b6e38ce8ed45cb29076f454cd488762
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-12-10 19:20:05 +0200

    tuklib_integer/CMake: Log a message about unaligned access check

 cmake/tuklib_integer.cmake | 8 ++++++++
 1 file changed, 8 insertions(+)

commit f7381cf927576164c17be4e4c1edeec3cdaca7cf
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-12-10 19:11:27 +0200

    tuklib_integer/CMake: Don't run unaligned access checks unnecessarily
    
    If the cache variable TUKLIB_FAST_UNALIGNED_ACCESS is already set,
    the autodetection result isn't needed because the option() command
    does nothing when the cache variable is already set.
    
    This is largely white space change to indent the if...endif block.

 cmake/tuklib_integer.cmake | 226 +++++++++++++++++++++++----------------------
 1 file changed, 117 insertions(+), 109 deletions(-)

commit dc1a421ce35f10b9a0c00d1bd42f1fdac0c3e9eb
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-12-10 16:49:55 +0200

    tuklib_integer: Use CMAKE_C_COMPILER_ARCHITECTURE_ID when available
    
    CMake >= 4.1 sets CMAKE_<LANG>_COMPILER_ARCHITECTURE_ID on many
    platforms. The list of possible values are documented. Use this
    variable when available. On older CMake versions CMAKE_SYSTEM_PROCESSOR
    is still used, thus the regexes have to include values like ^amd64 still.
    
    With old CMake versions, checking CMAKE_C_COMPILER_ARCHITECTURE_ID
    is somewhat useful with MSVC because CMAKE_SYSTEM_PROCESSOR might
    not match the target architecture.

 cmake/tuklib_integer.cmake | 13 ++++++++++++-
 1 file changed, 12 insertions(+), 1 deletion(-)

commit c690101dddd784b75224a8935f56cd163d3e90a3
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-12-10 16:49:55 +0200

    tuklib_integer: Autodetect when -mstrict-align is used with GCC on ARM64
    
    On ARM64, support for fast unaligned memory access was autodetected by
    checking if __ARM_FEATURE_UNALIGNED is defined. However, at least GCC
    versions up to 15.2.0 define the macro even when -mstrict-align has
    been specified. Thus, autodetection with GCC doesn't work correctly,
    and binaries built using -mstrict-align can be much slower than they
    need to be, unless the user also passes --disable-unaligned-access
    to configure or -DTUKLIB_FAST_UNALIGNED_ACCESS=OFF to cmake.
    
    See the GCC bug:
    
        https://gcc.gnu.org/bugzilla/show_bug.cgi?id=111555
    
    Workaround the issue by using heuristics with GCC on ARM64.
    
    With Clang, the detection using __ARM_FEATURE_UNALIGNED works.
    It also works with GCC on 32-bit ARM.
    
    Fixes: e5f13a66567b ("tuklib_integer: Autodetect support for unaligned access on ARM.")

 cmake/tuklib_integer.cmake | 63 ++++++++++++++++++++++++++++++-------
 m4/tuklib_integer.m4       | 78 +++++++++++++++++++++++++++++++++++-----------
 2 files changed, 110 insertions(+), 31 deletions(-)

commit d9b318f5b8a3524e90ac17471e79db7de012caf5
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-12-09 18:02:23 +0200

    CI: Update MSYS2

 .github/workflows/msys2.yml | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 700e32f1b7dd6d674f12bbdabc35a3bc4a2860f5
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-12-09 18:02:05 +0200

    CI: Update DragonFly BSD

 .github/workflows/dragonflybsd.yml | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit a7b749389c64dfbee1c29d88e61e71186b472784
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-12-09 17:58:52 +0200

    CI: Update Solaris

 .github/workflows/solaris.yml | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit e0b3c6ee0ab3243e48291e5f9b6333c3d052311d
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-12-09 17:56:58 +0200

    CI: Update NetBSD

 .github/workflows/netbsd.yml | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit fbc1046248cfe3c730437ba7d98dde89b0eced3e
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-12-09 17:54:54 +0200

    CI: Update OpenBSD

 .github/workflows/openbsd.yml | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 8f0579ba5650bbbfa88a04adf8115b8fb4aff476
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-12-09 17:52:01 +0200

    CI: Update FreeBSD

 .github/workflows/freebsd.yml | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit f8424b0416266c393c84a315e3bdedbc19efa0a8
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-12-09 17:40:05 +0200

    Update THANKS

 THANKS | 1 +
 1 file changed, 1 insertion(+)

commit c4340692d4490ff80e897d4840fadc033c46d81a
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-12-09 13:01:36 +0200

    Translations: Add src/xz/sandbox.c to POTFILES.in
    
    There are no strings to translate in that file now, but it's good to
    list it anyway in case translatable strings are added in the future.
    
    Fixes: 374868d81d47 ("xz: Move sandboxing code to sandbox.c and improve Landlock sandbox.")

 po/POTFILES.in | 1 +
 1 file changed, 1 insertion(+)

commit b8af36920b0857c0329f61414df5989093386db1
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-12-09 12:55:45 +0200

    xz: Never translate "Failed to enable the sandbox"
    
    This was already the case in practice because I had forgotten to list
    src/xz/sandbox.c in po/POTFILES.in. However, it seems better to never
    translate this particular error message. It should almost never occur
    and if it does, an untranslated message is should make it easier to
    find bug reports about it.

 src/xz/sandbox.c | 24 +++++++++++++++---------
 1 file changed, 15 insertions(+), 9 deletions(-)

commit 5a7fc1af3d9ec115f796cba110eb78e63ff1df5c
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-12-09 12:27:15 +0200

    Translations: Update the Swedish man page translations

 po4a/sv.po | 15 +++++----------
 1 file changed, 5 insertions(+), 10 deletions(-)

commit 88531e5463d9f028387a11b78d53c9c269e6a3a0
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-12-09 12:26:24 +0200

    Translations: Update the Romanian man page translations

 po4a/ro.po | 18 +++++++-----------
 1 file changed, 7 insertions(+), 11 deletions(-)

commit 8a817277192e6379a8c6f2eefbaed65c6b7d92fa
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-12-09 12:13:36 +0200

    Update THANKS

 THANKS | 1 +
 1 file changed, 1 insertion(+)

commit 1ec43aa7810d159ed76a6188b17c0bb474ca5ab5
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-12-09 12:13:36 +0200

    CMake: Autodetect unaligned access support on LoongArch
    
    This still relies on CMAKE_SYSTEM_PROCESSOR. CMake 4.1 added more
    CMAKE_<LANG>_COMPILER_ARCHITECTURE_ID values to detect the arch in
    a more defined manner, but 4.1 is too new to require for now.
    
    Thanks-to: Li Chenggang <lichenggang@deepin.org>
    Closes: https://github.com/tukaani-project/xz/pull/186

 cmake/tuklib_integer.cmake | 81 ++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 81 insertions(+)

commit 7971566247914ec1854b125ff99c2a617f5c1e3a
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-12-09 12:13:36 +0200

    Autotools: Autodetect unaligned access support on LoongArch
    
    According to [1] sections 7.4, 8.1, and 8.2, desktop and server
    processors support fast unaligned access, but embedded systems likely
    don't.
    
    It's important that TUKLIB_FAST_UNALIGNED_ACCESS isn't defined when
    -mstrict-align is in use because it will result in slower binaries
    even if running on a processor that supports fast unaligned access.
    It's because compilers will translate multibyte memcpy() to multiple
    byte-by-byte instructions instead of wider loads and stores. The
    compression times from [2] show this well:
    
        Unaligned access    CFLAGS                     Compression time
            enabled         -O2 -mno-strict-align          66.1 s
            disabled        -O2 -mno-strict-align          79.5 s
            disabled        -O2 -mstrict-align             79.9 s
            enabled         -O2 -mstrict-align            129.1 s
    
    There currently (GCC 15.2) is no preprocessor macro on LoongArch
    to detect if -mstrict-align or -mno-strict-align is in effect (the
    default is -mno-strict-align). Use heuristics to detect which of the
    flags is in effect.
    
    [1] https://github.com/loongson/la-softdev-convention/blob/v0.2/la-softdev-convention.adoc
    [2] https://github.com/tukaani-project/xz/pull/186#issuecomment-3494570304
    
    Thanks-to: Li Chenggang <lichenggang@deepin.org>
    Thanks-to: Xi Ruoyao
    See: https://github.com/tukaani-project/xz/pull/186

 m4/tuklib_integer.m4 | 68 ++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 68 insertions(+)

commit 338f952c0039b153a1fbdf6a535c4bd6a61f33cd
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-11-26 13:50:57 +0200

    xz: Silence clang -Wunreachable-code-break
    
    Fixes: a165d7df1964 ("xz: Add a new --filters-help option.")

 src/xz/args.c | 1 -
 1 file changed, 1 deletion(-)

commit 723cee44d076281bce9c3d7bd2c17b0680bd8884
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-11-26 13:50:57 +0200

    liblzma: Remove unwanted semicolons
    
    These didn't affect control flow.

 src/liblzma/common/vli_decoder.c       | 2 +-
 src/liblzma/lzma/lzma_common.h         | 4 ++--
 src/liblzma/rangecoder/range_decoder.h | 6 +++---
 3 files changed, 6 insertions(+), 6 deletions(-)

commit 524f6a7384f15e52ec13c72adbdf18ddeecbc735
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-11-26 13:50:57 +0200

    Tests: Remove an unwanted semicolon from a macro definition
    
    It didn't affect control flow.
    
    Fixes: fe3bd438fb11 ("Tests: Fix memory leaks in test_block_header.")

 tests/test_block_header.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 0f41a28bfab98d1f5171ee5c9da6dfdc15f62549
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-11-26 13:50:57 +0200

    Build: Use -Wextra-semi-stmt when supported

 CMakeLists.txt | 1 +
 configure.ac   | 1 +
 2 files changed, 2 insertions(+)

commit 91170c8cab72b94a697f5228f4df13483ef5be91
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-11-26 13:50:57 +0200

    CI: Add clang-cl
    
    Fixes: https://github.com/tukaani-project/xz/issues/18#issuecomment-3577456136

 .github/workflows/msvc.yml | 46 ++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 46 insertions(+)

commit a3c6cb09113de978b971cbdacf5c4890d4237c28
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-11-26 13:50:57 +0200

    xz/Windows: Add a missing #include to fix the build with clang-cl
    
    Fixes: https://github.com/tukaani-project/xz/issues/18#issuecomment-1986829734
    Fixes: https://github.com/tukaani-project/xz/issues/18#issuecomment-3577456136

 src/xz/util.c | 4 ++++
 1 file changed, 4 insertions(+)

commit c410ccc62511ec95b20639defb10650ef9b75e8c
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-11-25 21:05:37 +0200

    xz: Check return value of sigaction() before calling raise()
    
    Fixes: Coverity CID 456022

 src/xz/signals.c | 10 ++++++++--
 1 file changed, 8 insertions(+), 2 deletions(-)

commit 6cc2da0a4b180b71cb6e781c897052def103ad3e
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-11-02 12:57:00 +0200

    liblzma: Refactor a loop in lzma_filters_copy()
    
    Arguably it's nicer if i doesn't wrap around when the loop terminates.
    
    Fixes: Coverity CID 464589
    Fixes: 6d118a0b9def ("Add lzma_filters_copy().")

 src/liblzma/common/filter_common.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 90b67853d57562c5ad4fdb3215ceb9b9bd3958bf
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-11-02 12:17:50 +0200

    liblzma: Silence two Coverity warnings
    
    lzma_lzma_decoder_memusage() returns UINT64_MAX if lc/lp/pb aren't
    valid. alone_decoder.c and lzip_decoder.c didn't check the return
    value because in both it is known that lc/lp/pb are valid. Make them
    call the _nocheck() variant instead which skips the validation (it
    already existed for LZMA2's internal use).
    
    Fixes: Coverity CID 464658
    Fixes: Coverity CID 897069

 src/liblzma/common/alone_decoder.c |  6 ++++--
 src/liblzma/common/lzip_decoder.c  |  3 ++-
 src/liblzma/lzma/lzma_decoder.h    | 11 ++++++-----
 3 files changed, 12 insertions(+), 8 deletions(-)

commit be365b701024b9acbfef4035c6433a0fbb4be823
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-11-02 12:17:50 +0200

    liblzma: Fix a harmless read of shared variable without mutex
    
    The partial_update_mode enumeration had three states, _DISABLED,
    _START, and _ENABLED. Main thread changed it from _DISABLED to _START
    while holding a mutex. Once set to _START, worker thread changed it
    to _ENABLED without a mutex. Later main thread read it without a mutex,
    so it could see either _START or _ENABLED. However, it made no
    difference because the main thread checked for != _DISABLED, so
    it didn't matter if it saw _START or _ENABLED.
    
    Nevertheless, such things must not be done. It's clear it was a mistake
    because there were two comments that directly contradicted each
    other about how the variable was accessed.
    
    Split the enumeration into two booleans:
    
      - partial_update_enabled: A worker thread locks the mutex to read
        this variable and the main thread locks the mutex to change the
        value. Because only the main thread modifies the variable, the
        main thread can read the value without locking the mutex.
        This variable replaces the _DISABLED -> _START transition.
    
      - partial_update_started is for worker thread's internal use and thus
        needs no mutex. This replaces the _START -> _ENABLED transition.
    
    Fixes: Coverity CID 456025
    Fixes: bd93b776c1bd ("liblzma: Fix a deadlock in threaded decoder.")

 src/liblzma/common/stream_decoder_mt.c | 79 +++++++++++++++-------------------
 1 file changed, 34 insertions(+), 45 deletions(-)

commit 2686554da0103580a472919220931c397b1d1f7a
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-11-02 12:17:50 +0200

    CI: Add Coverity Scan
    
    Co-authored-by: Lasse Collin <lasse.collin@tukaani.org>
    Fixes: https://github.com/tukaani-project/xz/issues/198

 .github/workflows/coverity.yml | 38 ++++++++++++++++++++++++++++++++++++++
 1 file changed, 38 insertions(+)

commit 1b30734c9c08a3f628574d172f1a6034277a2163
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-11-25 13:55:35 +0200

    Change the sorting order in THANKS
    
    In short, sort the names with this command (-k1,1 isn't needed because
    the lines with names start with "  -"):
    
        LC_ALL=en_US.UTF-8 sort -k2,2 -k3,3 -k4,4 -k5,5
    
    When THANKS was created, I wrote the names as "First Last" and attempted
    to keep them sorted by last name / surname / family name. This works
    with many names in THANKS, but it becomes complicated with names that
    don't fit that pattern. For example, names that are written as
    "Last First" can be manually sorted by family name, but only if one
    knows which part of the name is the family name.[*] And of course,
    the concept of first/last name doesn't apply to all names.
    
    [*] xz had a co-maintainer who could help me with such names,
        but fortunately he isn't working on the project anymore.
    
    Adding the names in chronological order could have worked too, although
    if something is contributed by multiple people, one would still have to
    decide how to sort the names within the batch. Another downside would
    be that if THANKS is updated in more than one work-in-progress branch,
    merge conflicts would occur more often.
    
    Don't attempt to sort by last name. Let's be happy that people tend to
    provide names that can be expressed in a reasonable number of printable
    Unicode characters. In practice, people have been even nicer: if the
    native language doesn't use a Latin script alphabet, people often provide
    a transliterated name (only or in addition to the original spelling),
    which is very much appreciated by those who don't know the native script.
    
    Treat the names as opaque strings or space-separated strings for sorting
    purposes. This means that most names will now be sorted by first name.
    There still are many choices how to sort:
    
    (1) LC_ALL=en_US.UTF-8 sort
    
        The project is in English, so this may sound like a logical choice.
        However, spaces have a lower weight than letters, which results in
        this order:
    
            - A Ba
            - Ab C
            - A Bc
            - A Bd
    
    (2) LC_ALL=en_US.UTF-8 sort -k2,2
    
        This first sorts by the first word and then by the rest of the
        string. It's -k2,2 instead of -k1,1 to skip the leading dash.
    
            - A Ba
            - A Bc
            - A Bd
            - Ab C
    
        I like this more than (1). One could add -k3,3 -k4,4 -k5,5 ... too.
        With current THANKS it makes no difference but it might some day.
    
        NOTE: The ordering in en_US.UTF-8 can differ between libc versions
        and operating systems. Luckily it's not a big deal in THANKS.
    
    (3) LC_ALL=en_US.UTF-8 sort -f -k2,2
    
        Passing -f (--ignore-case) to sort affects sorting of single-byte
        characters but not multibyte characters (GNU coreutils 9.9):
    
            No -f       With -f     LC_ALL=C
            Aa          A.A         A.A
            A.A         Aa          Aa
            Ää          Ää          Ä.Ä
            Ä.Ä         Ä.Ä         Ää
    
        In GNU coreutils, the THANKS file is sorted using "sort -f -k1,1".
        There is also a basic check that the en_US.UTF-8 locale is
        behaving as expected.
    
    (4) LC_ALL=C sort
    
        This sorts by byte order which in UTF-8 is the same as Unicode
        code point order. With the strings in (1) and (2), this produces
        the same result as in (2). The difference in (3) can be seen above.
    
        The results differ from en_US.UTF-8 when a name component starts
        with a lower case ASCII letter (like "von" or "de"). Worse, any
        non-ASCII characters sort after ASCII chars. These properties might
        look weird in English language text, although it's good to remember
        that en_US.UTF-8 sorting can appear weird too if one's native
        language isn't English.
    
    The choice between (2) and (4) was difficult but I went with (2).
    
    ;-)

 THANKS | 414 ++++++++++++++++++++++++++++++++---------------------------------
 1 file changed, 207 insertions(+), 207 deletions(-)

commit 8bb516887c1912106a72db96216cab46954e6190
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-11-23 20:39:28 +0200

    Landlock: Add missing #ifdefs
    
    The build was broken on distros that have an old <sys/landlock.h>.
    
    Fixes: 2b2652e914b1 ("Landlock: Workaround a bug in RHEL 9 kernel")

 src/common/my_landlock.h | 6 ++++++
 1 file changed, 6 insertions(+)

commit 23c95c6a7c374962103dbd35cb79fdd5a6fe8b52
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-11-23 20:13:50 +0200

    Update THANKS

 THANKS | 2 ++
 1 file changed, 2 insertions(+)

commit 2b2652e914b1c38d4c009a8dcac11dfee9c7e008
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-11-23 20:13:49 +0200

    Landlock: Workaround a bug in RHEL 9 kernel
    
    If one runs xz 5.8.0 or 5.8.1 from some other distribution in a container
    on RHEL 9, xz will fail with the message "Failed to enable the sandbox".
    
    RHEL 9 kernel since 5.14.0-603.el9 (2025-07-30) claims to support
    Landlock ABI version 6, but it lacks support for LANDLOCK_SCOPE_SIGNAL.
    The issue is still present in 5.14.0-643.el9 (2025-11-22). Red Hat is
    aware of the issue, but I don't know when it will be fixed.
    
    The sandbox is meant to be transparent to users, thus there isn't and
    won't be a command line option to disable it. Instead, add a workaround
    to keep xz working on the buggy RHEL 9 kernels.
    
    Reported-by: Richard W.M. Jones
    Thanks-to: Pavel Raiskup
    Tested-by: Orgad Shaneh
    Tested-by: Richard W.M. Jones
    Fixes: https://github.com/tukaani-project/xz/issues/199
    Link: https://issues.redhat.com/browse/RHEL-125143
    Link: https://bugzilla.redhat.com/show_bug.cgi?id=2407105
    Link: https://lists.fedoraproject.org/archives/list/devel@lists.fedoraproject.org/message/65BDSY56R5ZJRTUC4B6CIVCVLY4LG4ME/

 src/common/my_landlock.h | 27 ++++++++++++++++++++++++++-
 1 file changed, 26 insertions(+), 1 deletion(-)

commit ee75c76958dd891906745125590563ab64e85995
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-11-23 20:13:37 +0200

    Landlock: Cache the ABI version
    
    In xz it can avoid up to two syscalls that query the ABI version.

 src/common/my_landlock.h | 14 +++++++++++++-
 1 file changed, 13 insertions(+), 1 deletion(-)

commit f57b1716cd0853474980c90a892204dee9bdea1a
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-11-03 14:52:45 +0200

    Update THANKS

 THANKS | 1 +
 1 file changed, 1 insertion(+)

commit 211cde09236165dbd379644753337be1de64b151
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-11-03 12:41:31 +0200

    mythread.h: Fix the build on Emscripten when threading is disabled
    
    To make a non-threaded liblzma-only build work with WASI SDK, <signal.h>
    and mythread_sigmask() were omitted from mythread.h in the commit
    81db3b889830. This broke non-threaded full build with Emscripten because
    src/xz/signals.c needs mythread_sigmask() (liblzma-only build was fine).
    
    If __wasm__ is defined, omit <signal.h> and mythread_sigmask() in
    non-threaded builds only when __EMSCRIPTEN__ isn't defined.
    
    Reported-by: Marcus Tillmanns
    Thanks-to: ChanTsune
    Fixes: https://github.com/tukaani-project/xz/issues/161
    Fixes: 81db3b889830 ("mythread.h: Disable signal functions in builds targeting Wasm + WASI.")

 src/common/mythread.h | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit cbf50a99e3f0c2735fd573e166baf37df063b37b
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-11-03 11:56:32 +0200

    Translations: Update the Serbian man page translations
    
    The earlier bug fixes are now included in the Translation Project.

 po4a/sr.po | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 68d1591187512d8872615c8a904d43073440d93f
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-11-02 19:40:55 +0200

    xz: Silence a compiler warning when signals_block_count is unused
    
    Move the static variable signals_block_count to the #ifndef block
    that already has the functions that need the variable.

 src/xz/signals.c | 7 ++++---
 1 file changed, 4 insertions(+), 3 deletions(-)

commit beca015891fbd22657663ec23809184dda0677cd
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-11-02 17:45:20 +0200

    xz: Silence a warning from Clang on glibc systems
    
    Fixes: e8838b2f5922 ("xz: Look at resource limits when determining the default memlimit")

 src/xz/hardware.c | 13 +++++++++++++
 1 file changed, 13 insertions(+)

commit 3e394278ed537575b5db43c09989c6ca99f762de
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-11-02 14:37:52 +0200

    Translations: Update the Serbian man page translations
    
    Preserve the bug fixes made in 71ad5e82888f and 4f52e7387012 because
    upstream hasn't included them.

 po4a/sr.po | 17 ++++++-----------
 1 file changed, 6 insertions(+), 11 deletions(-)

commit ace28e35732fc43f58ea1aac146fdb73084f2548
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-11-02 14:27:10 +0200

    Translations: Update the Korean man page translations

 po4a/ko.po | 17 ++++++-----------
 1 file changed, 6 insertions(+), 11 deletions(-)

commit ffd14a099f0d8c92d4f74018d3a52bd2327df4db
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-11-02 14:24:43 +0200

    Translations: Update the Italian man page translations

 po4a/it.po | 15 +++++----------
 1 file changed, 5 insertions(+), 10 deletions(-)

commit 6f3152874ee375b581aa858fccab7865dcbf6403
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-11-02 14:12:23 +0200

    Translations: Update the Ukrainian man page translations

 po4a/uk.po | 15 +++++----------
 1 file changed, 5 insertions(+), 10 deletions(-)

commit ef67e051d71938a23713d9782a3f0c470ac51b1e
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-09-28 18:32:05 +0300

    liblzma: Fix build on old Linux/glibc on ARM64
    
    getauxval() can be available even if HWCAP_CRC32 isn't #defined, so
    both have to be checked. HWCAP_CRC32 was added in glibc 2.24 (2016).
    
    Fixes: https://github.com/tukaani-project/xz/issues/190

 CMakeLists.txt                  | 7 +++++++
 configure.ac                    | 6 +++++-
 src/liblzma/check/crc32_arm64.h | 5 +++--
 src/liblzma/check/crc_common.h  | 3 ++-
 4 files changed, 17 insertions(+), 4 deletions(-)

commit 71c2ede383f6dc6661b8a9d844f4bcf81c563643
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-10-31 14:36:26 +0200

    CI: Update Solaris

 .github/workflows/solaris.yml | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 02da8de0edddd31a3e9818c2200b97c446d6eb5b
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-10-31 14:32:47 +0200

    CI: Update DragonFly BSD

 .github/workflows/dragonflybsd.yml | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit 75b18d325f6a993eac2d5f44c7aad941aa20df94
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-10-31 14:30:24 +0200

    CI: Update NetBSD

 .github/workflows/netbsd.yml | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 0102072915f38e747ee55aa9c52351dfe81b8c14
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-10-31 14:21:37 +0200

    CI: Update FreeBSD

 .github/workflows/freebsd.yml | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 83419783a67a6097c7d5ed5663734c04eb8c8b55
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-10-31 14:17:30 +0200

    CI: Update OpenBSD

 .github/workflows/openbsd.yml | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 3b5f5af9bcd9b5752608a099fcfab331c0c613b3
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-10-26 12:07:34 +0200

    Update THANKS

 THANKS | 2 ++
 1 file changed, 2 insertions(+)

commit e8838b2f59221f46bf34c79431d286e8ac34fb8b
Author: Kirill A. Korinsky <kirill@korins.ky>
Date:   2025-10-26 12:07:34 +0200

    xz: Look at resource limits when determining the default memlimit
    
    When no memory usage limits have been set by the user, the default
    for multithreaded mode has been 1/4 of total RAM. If this limit is
    too high and memory allocation fails, liblzma (and xz) fail. Perhaps
    liblzma should handle it better by reducing the number of threads
    and continuing with the amount of memory it can allocate, but currently
    that isn't the case.
    
    If resource limits were set to about 1/4 of RAM or lower, then xz
    could fail for the above reason. This commit makes xz look at
    RLIMIT_DATA, RLIMIT_AS, and RLIMIT_VMEM when they are available,
    and set the limit 64 MiB below the lowest of those limits. This is
    more or less a hack just like the 1/4-of-RAM method is, but this is
    simple and quick to implement.
    
    On Linux, there are other limits like cgroup v2 memory.max which
    can still make xz fail. The same is likely possible with FreeBSD's
    rctl(8).
    
    Co-authored-by: Lasse Collin <lasse.collin@tukaani.org>
    Thanks-to: Fangrui Song
    Fixes: https://github.com/tukaani-project/xz/issues/195
    Closes: https://github.com/tukaani-project/xz/pull/196

 CMakeLists.txt    |  3 +++
 configure.ac      |  4 ++--
 src/xz/hardware.c | 59 +++++++++++++++++++++++++++++++++++++++++++++++++++++++
 3 files changed, 64 insertions(+), 2 deletions(-)

commit 8d26b72915e0d373f898b55935505857c30dbdb3
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-10-01 12:46:26 +0300

    CI: Remove windows-2019 (which had VS 2019)
    
    GitHub has removed the runner image.
    
    A breakage with CLMUL CRC code occurred with VS 2019 but not 2022,
    see b5a5d9e3f702. MS supports VS 2019 for a few more years, so it's
    unfortunate that it can no longer be tested on GitHub.

 .github/workflows/msvc.yml | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 32412bd2a42fda639765c3046e91f964e286b6d9
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-09-29 19:34:58 +0300

    Update THANKS

 THANKS | 3 +++
 1 file changed, 3 insertions(+)

commit eaa150df9803c982adf28d4533c7a4264ea17757
Author: Lakshmi-Surekha <Lakshmi.Kovvuri@ibm.com>
Date:   2025-07-17 23:27:06 -0500

    xz: Don't fsync() directories on AIX
    
    It fails with EBADF.
    
    Fixes: https://github.com/tukaani-project/xz/issues/188
    Closes: https://github.com/tukaani-project/xz/pull/189

 src/xz/file_io.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 61b114e92f53b7977aad69f8a7130fc25d8a80e5
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-09-29 18:37:19 +0300

    liblzma: Document that lzma_allocator.free(opaque, NULL) is possible
    
    It feels better to fix the docs than change the code because this
    way newly-written applications will be forced to be compatible with
    the lzma_allocator behavior of old liblzma versions. It can matter
    if someone builds the application against an older liblzma version.
    
    Fixes: https://github.com/tukaani-project/xz/issues/183

 src/liblzma/api/lzma/base.h | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit 6d287a3ae90e1b990294f3d5264003d81e853c5e
Author: Simon Josefsson <simon@josefsson.org>
Date:   2025-08-26 09:41:02 +0200

    Update GPLv2 and LGPLv2.1 copies from gnu.org
    
    Closes: https://github.com/tukaani-project/xz/pull/194

 COPYING.GPLv2    | 9 ++++-----
 COPYING.LGPLv2.1 | 9 ++++-----
 2 files changed, 8 insertions(+), 10 deletions(-)

commit 41a421dbadf13af2a59aaafa43836026b83340a7
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-05-24 12:07:13 +0300

    tests/test_suffix.sh: Avoid variables in printf format string

 tests/test_suffix.sh | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit a2c6aa8764a2e5248572d461305bd05c5950bf94
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-05-24 12:02:09 +0300

    build-aux/manconv.sh: Add quotes

 build-aux/manconv.sh | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit 8e4153253eea2b5a9466467b2ce0249e56277c9a
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-05-24 12:01:35 +0300

    windows/build.bash: Add quotes
    
    In this case they aren't needed but it's better style.

 windows/build.bash | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 37a57a926dd1ae6cde1544d8487e27982d2db4a4
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-05-24 12:00:13 +0300

    po4a/update-po: Ensure that a glob won't expand to a command line option

 po4a/update-po | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit e3ba73034a3f8e414882af39d62f479e9717e061
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-05-24 11:57:23 +0300

    liblzma: validate_map.sh: Catch some unlikely errors

 src/liblzma/validate_map.sh | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 067cecdea69067973e44dc1afb9be763faccecb2
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-05-24 11:55:59 +0300

    CI: Catch unsupported arguments in ci_build.bash

 build-aux/ci_build.bash | 4 ++++
 1 file changed, 4 insertions(+)

commit 4fc6208abebfe6b8c8348c412b4bcc594ae11c88
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-05-13 20:42:26 +0300

    Scripts: Add shellcheck directives to silence warnings
    
    Set also shell because the xz*.in files start with '#!@POSIX_SHELL@'.
    
    SC1003 and SC2016 are only info messages, not warnings. Several other
    shellcheck info messages remain. They are safe to ignore, but I didn't
    want to disable them now.
    
    Partially-fixes: https://github.com/tukaani-project/xz/issues/174

 src/scripts/xzdiff.in | 4 ++++
 src/scripts/xzgrep.in | 2 ++
 src/scripts/xzless.in | 2 ++
 src/scripts/xzmore.in | 2 ++
 4 files changed, 10 insertions(+)

commit 7844aff1a838362403b332c3a68d5732a192923a
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-05-03 22:45:15 +0300

    Scripts: Silence two shellcheck warnings

 src/scripts/xzdiff.in | 2 +-
 src/scripts/xzmore.in | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 4d439aaeed5c991fbc1ff78d7616e179c30fca1d
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-09-29 17:29:23 +0300

    Translations: Add Swedish man page translations

 po4a/po4a.conf |    2 +-
 po4a/sv.po     | 3909 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 3910 insertions(+), 1 deletion(-)

commit dd4a1b259936880e04669b43e778828b60619860
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-05-23 13:09:14 +0300

    CI: Add timeout-minutes
    
    Sometimes the VM workflows (like FreeBSD VM on Ubuntu) get stuck
    and the default timeout is six hours. While at it, set a sensible
    timeout for all workflows.

 .github/workflows/ci.yml           | 1 +
 .github/workflows/cifuzz.yml       | 1 +
 .github/workflows/dragonflybsd.yml | 1 +
 .github/workflows/freebsd.yml      | 1 +
 .github/workflows/msvc.yml         | 1 +
 .github/workflows/msys2.yml        | 1 +
 .github/workflows/netbsd.yml       | 1 +
 .github/workflows/openbsd.yml      | 1 +
 .github/workflows/solaris.yml      | 1 +
 9 files changed, 9 insertions(+)

commit d660fe5d56a804b0ef3eea550fdcd51dbe17e45b
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-05-23 12:25:36 +0300

    liblzma: Fix grammar in API docs
    
    Fixes: a27920002dbc ("liblzma: Add generic support for input seeking (LZMA_SEEK).")

 src/liblzma/api/lzma/base.h | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit ab45bdf4322879dc2859b1f66f1f8cf89cdebe2c
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-05-21 16:07:01 +0300

    Update THANKS

 THANKS | 1 +
 1 file changed, 1 insertion(+)

commit f0239936532d40be05e75384c37fb8d6c1bb4ff6
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-05-21 16:07:01 +0300

    CMake: With symbol versioning, try to pass --undefined-version to linker
    
    Fixes: https://github.com/tukaani-project/xz/issues/180
    Fixes: https://bugs.gentoo.org/956119

 CMakeLists.txt | 22 ++++++++++++++++++++++
 1 file changed, 22 insertions(+)

commit 377be0ea7a1d0ec3572a7f9a5f9ed42adeaa4503
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-05-21 16:07:01 +0300

    Build: With symbol versioning, try to pass --undefined-version to linker
    
    Fixes: https://github.com/tukaani-project/xz/issues/180
    Fixes: https://bugs.gentoo.org/956119

 configure.ac            | 23 +++++++++++++++++++++++
 src/liblzma/Makefile.am |  2 ++
 2 files changed, 25 insertions(+)

commit ff49c82176ca53646a1cbbbb4efc35a542745812
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-05-21 14:48:18 +0300

    CMake: Fix comments

 CMakeLists.txt | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 71ad5e82888fdfa0fe11defa4f46cb0fc90dc326
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-05-21 13:14:04 +0300

    Translations: Update Serbian man page translations
    
    Compared to the file in the Translation Project, I still had to apply
    a few fixes that were needed with the previous (5.7.1-dev1) version too:
    
      - Remove two extra '<' characters that break the build with po4a.
    
      - Don't translate XZ_DEFAULTS and XZ_OPT environment variable names.

 po4a/sr.po | 70 ++++++++++++++++++++------------------------------------------
 1 file changed, 22 insertions(+), 48 deletions(-)

commit 31a983ad4774054074b300f55ff519484ff182c2
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-05-21 12:55:28 +0300

    Update po/.gitignore

 po/.gitignore | 1 +
 1 file changed, 1 insertion(+)

commit d9e70da25ac761544146bc2fbab6443e1a080bf4
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-05-21 12:54:42 +0300

    Translations: Update the Spanish translation

 po/es.po | 10 +++++-----
 1 file changed, 5 insertions(+), 5 deletions(-)

commit dbfb925c8198087afb3527e6c57b66fae1a980bb
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-05-03 12:37:28 +0300

    Tests: Silence a warning from GCC 15.1
    
    It was (probably) intentionally without the null terminator, but the test
    works with null terminator too (the test still fails with xz <= 5.0.3),
    so simply omit one character to silence the warning.
    
    tests/test_bcj_exact_size.c:30:32: error: initializer-string for array of ‘unsigned char’ truncates NUL terminator but destination lacks ‘nonstring’ attribute (17 chars into 16 available) [-Werror=unterminated-string-initialization]
       30 |         const uint8_t in[16] = "0123456789ABCDEF";
          |                                ^~~~~~~~~~~~~~~~~~
    
    Fixes: d8db706acb83 ("liblzma: Fix possibility of incorrect LZMA_BUF_ERROR.")
    Fixes: https://github.com/tukaani-project/xz/issues/176

 tests/test_bcj_exact_size.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 7c12726c51b2b7d77329dd72a29ecb1ec262b918
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-28 18:16:14 +0300

    Update THANKS

 THANKS | 2 ++
 1 file changed, 2 insertions(+)

commit 1bd7361a043bd652ee5d0ebafd23459c57f57993
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-25 17:32:03 +0300

    Update THANKS

 THANKS | 1 +
 1 file changed, 1 insertion(+)

commit 5cc2e479eb447a444f5ab005fc36b7f275c75eb5
Author: Guillaume Outters <guillaume-installs@outters.eu>
Date:   2025-04-25 02:55:08 +0200

    xz, xzdec: Capsicum sandbox: Fix incorrect use of cap_rights_clear()
    
    cap_rights_clear() with no additional arguments acts as a no-op, so
    instead of removing all capability rights from STDIN_FILENO, the same
    rights were allowed for STDIN_FILENO as were allowed for src_fd.
    
    Fixes: a0eecc235d3b ("xz: Make Capsicum sandbox more strict with stdin and stdout.")
    (The commit message says "stdout". It should have said "stderr".)

 src/xz/sandbox.c  | 2 +-
 src/xzdec/xzdec.c | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 56aa9a07968a6a73fada6f9b96122c5165829f3b
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-22 21:12:50 +0300

    CI: Valgrind: Improve the skipping of traced child processes
    
    Use --trace-children-skip instead of --trace-children-skip-by-arg
    so that the skipping is only done based on the executable names.
    (--trace-children-skip-by-arg can match other args than argv[0].)
    
    Update the list of executables to skip to match what the scripts run.
    
    Do not skip bash or sh. If Valgrind didn't trace the shell, then the
    xz and xzdec programs run by the shell wouldn't be analyzed either.
    
    Fixes: 7e99856f66c0 ("CI: Speed up Valgrind job by using --trace-children-skip-by-arg=...")

 .github/workflows/ci.yml | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit f33da20b75a45caad25c9a4daf7906e4f056ce91
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-22 21:12:50 +0300

    CI: Valgrind: Test with static liblzma
    
    If shared liblzma is built, tests/test_* and src/xz/xz are wrapper
    scripts created by Libtool. The wrappers set library search path
    so that the freshly-built shared library is found.
    
    With a static liblzma, no wrapper scripts are needed, and Libtool
    places the real executables to the aforementioned locations. This
    speeds up the tests under Valgrind dramatically.
    
    Fixes: 6c095a98fbec ("ci: test Valgrind")

 .github/workflows/ci.yml | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 5606fa89f91ca1d0d53e339d88f574fc731049c1
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-22 21:12:50 +0300

    CI: Add Ubuntu on ARM64

 .github/workflows/ci.yml | 27 ++++++++++++++++-----------
 1 file changed, 16 insertions(+), 11 deletions(-)

commit ec047a65a068087cc6f71133df414858f6886121
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-22 16:21:50 +0300

    Doxygen: Update the comment about tested versions

 doxygen/Doxyfile | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 4f86e77bef8918b0c64183590609357a275558d8
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-22 16:21:50 +0300

    Doxygen: Set HAVE_DOT = NO
    
    Debian and Ubuntu have a patch that changes the upstream default to
    HAVE_DOT = YES. Undo it to have more consistent results across distros.
    
    This was noticed in Ubuntu CI runner where "doxygen" tried to run "dot"
    but that failed due to "dot" not being installed. "doxygen" still
    finished with exit status 0 until the commit that turned warnings to
    errors with WARN_AS_ERROR = FAIL_ON_WARNINGS.

 doxygen/Doxyfile | 4 ++++
 1 file changed, 4 insertions(+)

commit ff96542d1c78f744d992be5890c95d90b2d19047
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-22 16:21:50 +0300

    Doxygen: Treat warnings as errors
    
    Also set WARN_IF_UNDOCUMENTED = NO because even the API headers have
    a few things that won't have their own docs.

 doxygen/Doxyfile | 2 ++
 1 file changed, 2 insertions(+)

commit a6711d1c4ad681aad985372d01a7deb21b4a1b8b
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-22 16:21:50 +0300

    Doxygen: Fix errors and some warnings in internal docs

 src/liblzma/check/crc32_fast.c | 2 +-
 src/liblzma/check/crc64_fast.c | 2 +-
 src/liblzma/common/outqueue.h  | 1 +
 src/xz/list.c                  | 2 ++
 src/xz/message.h               | 4 ++++
 5 files changed, 9 insertions(+), 2 deletions(-)

commit 8efd80adfcd65dfea086c1008452c6424b30b78c
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-22 16:21:50 +0300

    CI: Use --disable-sandbox instead of --enable-sandbox=no
    
    It's the same thing, just a style difference.

 build-aux/ci_build.bash | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit a2e47c7a59d835ba80beef53b986d45e99ecd94a
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-22 16:21:50 +0300

    CI: Support Doxygen in ci_build.bash

 build-aux/ci_build.bash | 4 ++++
 1 file changed, 4 insertions(+)

commit 9048e724945a3dfbf86d7f97437113f27ea41c63
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-22 16:21:50 +0300

    CI: Add Doxygen dependency to CMake builds on Ubuntu and macOS

 .github/workflows/ci.yml | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit d8e9dc63a6124336e72a849b8104ba60720f0fe2
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-22 16:21:50 +0300

    CI: Support XZ_NLS=OFF with CMake

 build-aux/ci_build.bash | 1 +
 1 file changed, 1 insertion(+)

commit ffa9fadecc85d21308aebac7b070fb5be791190f
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-22 16:21:50 +0300

    CI: Revise MSYS2
    
    Re-enable CLANG64 environment. Add CLANGARM64. Don't add MINGW64
    to slightly reduce the number of runner VMs needed.
    
    Install the required packages using the setup-msys2 action instead
    of running the commands separately.
    
    Test Autotools and CMake in the same job to reduce the number of VMs.
    This doesn't slow it down too much because the msys2-setup step is
    needed by both. However, do only the full builds on ARM64 because
    those runners seem to be slower.
    
    Test fewer build configurations. The point of testing on MSYS2 is to
    catch Windows-related issues. It should be enough that the more unusual
    build configurations are tested in ci.yml.
    
    Run the build commands directly instead of using ci_build.bash. This
    makes it easier to see what commands are run even if it is a little
    more verbose now.
    
    Run the workflow automatically when commit are pushed to master.
    With the fewer build variants it's not too slow.

 .github/workflows/msys2.yml | 197 +++++++++++++++++++++++++-------------------
 1 file changed, 110 insertions(+), 87 deletions(-)

commit 6f2aaa77daef7b408dc0d9c9a534373a30da7a50
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-22 16:21:50 +0300

    CI: Rename the MSYS2 workflow file

 .github/workflows/{windows-ci.yml => msys2.yml} | 0
 1 file changed, 0 insertions(+), 0 deletions(-)

commit 09110ad4c74f3ee1b4b0355d92b703525eddd3ff
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-22 16:21:50 +0300

    CI: Enable assertions on NetBSD + CMake

 .github/workflows/netbsd.yml | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 516b90f6e1beb243dd76adc82da0ee47e525f863
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-21 12:23:37 +0300

    liblzma: Update lzma_lzip_decoder() docs about trailing data
    
    Don't say that the .lz format allows trailing data. According to the
    lzip 1.25 manual, trailing data isn't part of the file format at all.
    However, tools are still expected to behave as usefully as possible
    when there is trailing data.
    
    Fix the description of lzip >= 1.20 behavior when some of the first
    bytes of trailing data match the magic bytes. While the lzip 1.25 manual
    recommends that none of the first four bytes in trailing data should
    match the magic bytes, the default behavior of lzip 1.25 treats
    trailing data as a corrupt member header only if two or three bytes
    match the magic bytes; one matching byte isn't enough.
    
    Reported-by: Antonio Diaz Diaz
    Link: https://www.mail-archive.com/xz-devel@tukaani.org/msg00702.html

 src/liblzma/api/lzma/container.h | 23 +++++++++++------------
 1 file changed, 11 insertions(+), 12 deletions(-)

commit c330220d47dc09a5bab805d22654c8c0a73d21a9
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-21 11:21:08 +0300

    Update THANKS

 THANKS | 1 +
 1 file changed, 1 insertion(+)

commit 6cc7672c2238e7fc66bba33cff50cecd30411063
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-17 20:36:33 +0300

    CI: Add DragonflyBSD

 .github/workflows/dragonflybsd.yml | 39 ++++++++++++++++++++++++++++++++++++++
 1 file changed, 39 insertions(+)

commit 07dc50913725496bd89178539190292a66e18710
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-17 20:36:33 +0300

    CI: Update Solaris

 .github/workflows/solaris.yml | 37 +++++++++++++++++++------------------
 1 file changed, 19 insertions(+), 18 deletions(-)

commit cfcaae1945c0c33df86477138746e68428972a53
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-17 20:36:33 +0300

    CI: Update OpenBSD
    
    Use --disable-nls --enable-external-sha256 because those are used
    in the xz Makefile in the OpenBSD ports tree.

 .github/workflows/openbsd.yml | 46 +++++++++++++++++++++++--------------------
 1 file changed, 25 insertions(+), 21 deletions(-)

commit 5240fcfee3b1386029a26629d75f1465b9e85ca3
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-17 20:36:33 +0300

    CI: Update NetBSD
    
    For variety, use CMake and Ninja.

 .github/workflows/netbsd.yml | 43 +++++++++++++++++++++++++------------------
 1 file changed, 25 insertions(+), 18 deletions(-)

commit 85ff0cf0ce11b017af21c040330f6a0c09ef7f77
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-17 20:36:33 +0300

    CI: Update FreeBSD
    
    ARM64 was left commented out because it's slow under both
    ubuntu-latest (x86-64) and ubuntu-24.04-arm (aarch64) hosts.

 .github/workflows/freebsd.yml | 61 +++++++++++++++++++++++++++++--------------
 1 file changed, 42 insertions(+), 19 deletions(-)

commit 907ac2215db1613312dc292219bac798d76394f4
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-11 17:25:53 +0300

    CI: Specify only the main version of the standard GH actions

 .github/workflows/ci.yml   | 4 ++--
 .github/workflows/msvc.yml | 2 +-
 2 files changed, 3 insertions(+), 3 deletions(-)

commit b0d0e624740b92415f78274702b5b5bfbffe4543
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-11 17:15:08 +0300

    CI: Add 'permissions' to ci.yml and msvc.yml

 .github/workflows/ci.yml   | 2 ++
 .github/workflows/msvc.yml | 2 ++
 2 files changed, 4 insertions(+)

commit 1edc14e8ca4fc1f25ee43f17f290c045df7f49e0
Author: Sam James <sam@gentoo.org>
Date:   2025-04-10 23:15:31 +0300

    CI: Add CIFuzz
    
    xz is already part of OSS-Fuzz, but OSS-Fuzz provides & encourages [0]
    its 'CIFuzz' service to test individual commits.
    
    [0] https://google.github.io/oss-fuzz/getting-started/continuous-integration/
    
    Co-authored-by: Lasse Collin <lasse.collin@tukaani.org>

 .github/workflows/cifuzz.yml | 54 ++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 54 insertions(+)

commit 35e06c4c426c6cc3866a9003e87a122eb78bccf2
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-12 15:31:01 +0300

    CMake: Don't check for optreset if using replacement getopt_long
    
    If <getopt.h> had optreset but not getopt_long, xz used optreset while
    the replacement getopt_long doesn't support optreset. I'm not aware of
    any relevant system where bug is possible. Autotools build didn't have
    this bug.
    
    Fixes: af66cd585902 ("CMake: Add support for replacement getopt_long (lib/getopt*).")

 CMakeLists.txt | 6 ++++--
 1 file changed, 4 insertions(+), 2 deletions(-)

commit 99f4b9db9dfc3dabad330df6242e4632c42393c6
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-17 18:33:10 +0300

    Update THANKS

 THANKS | 1 +
 1 file changed, 1 insertion(+)

commit dd006a67e593cb5d3dec5180face7e3010fe78da
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-17 18:30:26 +0300

    liblzma: Update the lzma_lzip_decoder() docs about sync flush marker

 src/liblzma/api/lzma/container.h | 15 +++++++--------
 1 file changed, 7 insertions(+), 8 deletions(-)

commit f59c5859600b5dfeaa618fcc04e9e3bb2b005f5c
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-17 18:16:40 +0300

    xz: Don't mention lzip's sync flush marker on the man page
    
    The sync flush marker isn't valid in .lz files. The sync flush marker
    may be used by lzlib, but the resulting streams are only meant to be
    decoded by lzlib itself. lzlib's docs make this clear.
    
    Reported-by: Antonio Diaz Diaz
    Link: https://www.mail-archive.com/xz-devel@tukaani.org/msg00700.html
    Link: https://www.mail-archive.com/xz-devel@tukaani.org/msg00701.html

 src/xz/xz.1 | 9 +--------
 1 file changed, 1 insertion(+), 8 deletions(-)

commit 49258439b4ead6866798c1ebf8a083ec9ec04520
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-17 18:15:48 +0300

    Update THANKS

 THANKS | 1 +
 1 file changed, 1 insertion(+)

commit a69fbd3aaebc15dc5912e64724e5abfcef09bcdf
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-10 20:13:07 +0300

    CI: MSVC: Use fewer runners for the same number of tests
    
    Using eight runners seems wasteful. Using only two runners isn't
    much slower due to the runner startup overhead.
    
    Also add a comment about the test that fails without b5a5d9e3f702.

 .github/workflows/msvc.yml | 66 ++++++++++++++++++++++++++++++++++++++--------
 1 file changed, 55 insertions(+), 11 deletions(-)

commit 8a300d1c4fc644af482fb679044794c3e3f6f3e5
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-10 20:10:31 +0300

    Update THANKS

 THANKS | 1 +
 1 file changed, 1 insertion(+)

commit b5a5d9e3f7022e546cdfd4ddc42fe4cc56839c05
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-07 22:36:58 +0300

    liblzma: Disable CLMUL CRC on old MSVC targeting 32-bit x86
    
    On GitHub runners, VS 2019 16.11 (MSVC 19.29.30158) results in
    test failures. VS 2022 17.13 (MSVC 19.43.34808) works.
    
    In xz 5.6.x there was a #pragma-based workaround for MSVC builds for
    32-bit x86. Another method was thought to work with the new rewritten
    CLMUL CRC. Apparently it doesn't. Keep it simple and disable CLMUL CRC
    with any non-recent MSVC when building for 32-bit x86.
    
    Fixes: 54eaea5ea49b ("liblzma: x86 CLMUL CRC: Rewrite")
    Fixes: https://github.com/tukaani-project/xz/issues/171
    Reported-by: Andrew Murray

 src/liblzma/check/crc_common.h | 16 +++++++++++++---
 1 file changed, 13 insertions(+), 3 deletions(-)

commit c5fd88dfc3d2b4178dc6da65b02a63a4ef9280c5
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-07 22:36:58 +0300

    liblzma: Remove MSVC hack from CLMUL CRC
    
    It's not enough with MSVC 19.29 (VS 2019) even if the hack was also
    applied to the CRC32 code. The tests crash when built for 32-bit x86.

 src/liblzma/check/crc64_fast.c | 8 --------
 1 file changed, 8 deletions(-)

commit 49ba8c69ea7f928aded77bd856085c85a8d26156
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-07 22:36:52 +0300

    CI: Test 32/64-bit x86 builds with Visual Studio 2019 and 2022

 .github/workflows/msvc.yml | 45 +++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 45 insertions(+)

commit 1176a19df6b1585b51131b0e2570e03f1fc14f46
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-04 20:08:37 +0300

    Tests: Add fuzz_decode_stream_mt.options

 tests/ossfuzz/config/fuzz_decode_stream_mt.options | 4 ++++
 1 file changed, 4 insertions(+)

commit c3cb1e53a114ac944f559fe7cac45dbf48cca156
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-03 15:06:07 +0300

    doc/SHA256SUMS: Add 5.8.1

 doc/SHA256SUMS | 7 +++++++
 1 file changed, 7 insertions(+)

commit a522a226545730551f7e7c2685fab27cf567746c
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-03 14:34:43 +0300

    Bump version and soname for 5.8.1

 src/liblzma/Makefile.am        | 2 +-
 src/liblzma/api/lzma/version.h | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 1c462c2ad86ff85766928638431029cd0b0dc995
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-03 14:34:43 +0300

    Add NEWS for 5.8.1

 NEWS | 30 ++++++++++++++++++++++++++++++
 1 file changed, 30 insertions(+)

commit 513cabcf7f5ce1c3ed0619e791393fc53d1dbbd0
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-03 14:34:43 +0300

    Tests: Call lzma_code() in smaller chunks in fuzz_common.h
    
    This makes it easy to crash fuzz_decode_stream_mt when tested
    against the code from 5.8.0.
    
    Obviously this might make it harder to reach some other code path now.
    The previous code has been in use since 2018 when fuzzing was added
    in 106d1a663d4b ("Tests: Add a fuzz test program and a config file
    for OSS-Fuzz.").

 tests/ossfuzz/fuzz_common.h | 31 ++++++++++++++++++++++++-------
 1 file changed, 24 insertions(+), 7 deletions(-)

commit 48440e24a25911ae59e8518b67a1e0f6f1c293bf
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-03 14:34:43 +0300

    Tests: Add a fuzzing target for the multithreaded .xz decoder
    
    It doesn't seem possible to trigger the CVE-2025-31115 bug with this
    fuzzing target at the moment. It's because the code in fuzz_common.h
    passes the whole input buffer to lzma_code() at once.

 tests/ossfuzz/fuzz_decode_stream_mt.c | 47 +++++++++++++++++++++++++++++++++++
 1 file changed, 47 insertions(+)

commit 0c80045ab82c406858d9d5bcea9f48ebc3d0a81d
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-03 14:34:42 +0300

    liblzma: mt dec: Fix lack of parallelization in single-shot decoding
    
    Single-shot decoding means calling lzma_code() by giving it the whole
    input at once and enough output buffer space to store the uncompressed
    data, and combining this with LZMA_FINISH and no timeout
    (lzma_mt.timeout = 0). This way the file is decoded with a single
    lzma_code() call if possible.
    
    The bug prevented the decoder from starting more than one worker thread
    in single-shot mode. The issue was noticed when reviewing the code;
    there are no bug reports. Thus maybe few have tried this mode.
    
    Fixes: 64b6d496dc81 ("liblzma: Threaded decoder: Always wait for output if LZMA_FINISH is used.")

 src/liblzma/common/stream_decoder_mt.c | 11 +++++++++--
 1 file changed, 9 insertions(+), 2 deletions(-)

commit 8188048854e8d11071b8a50d093c74f4c030acc9
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-03 14:34:42 +0300

    liblzma: mt dec: Don't modify thr->in_size in the worker thread
    
    Don't set thr->in_size = 0 when returning the thread to the stack of
    available threads. Not only is it useless, but the main thread may
    read the value in SEQ_BLOCK_THR_RUN. With valid inputs, it made
    no difference if the main thread saw the original value or 0. With
    invalid inputs (when worker thread stops early), thr->in_size was
    no longer modified after the previous commit with the security fix
    ("Don't free the input buffer too early").
    
    So while the bug appears harmless now, it's important to fix it because
    the variable was being modified without proper locking. It's trivial
    to fix because there is no need to change the value. Only main thread
    needs to set the value in (in SEQ_BLOCK_THR_INIT) when starting a new
    Block before the worker thread is activated.
    
    Fixes: 4cce3e27f529 ("liblzma: Add threaded .xz decompressor.")
    Reviewed-by: Sebastian Andrzej Siewior <sebastian@breakpoint.cc>
    Thanks-to: Sam James <sam@gentoo.org>

 src/liblzma/common/stream_decoder_mt.c | 6 ++++--
 1 file changed, 4 insertions(+), 2 deletions(-)

commit d5a2ffe41bb77b918a8c96084885d4dbe4bf6480
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-03 14:34:42 +0300

    liblzma: mt dec: Don't free the input buffer too early (CVE-2025-31115)
    
    The input buffer must be valid as long as the main thread is writing
    to the worker-specific input buffer. Fix it by making the worker
    thread not free the buffer on errors and not return the worker thread to
    the pool. The input buffer will be freed when threads_end() is called.
    
    With invalid input, the bug could at least result in a crash. The
    effects include heap use after free and writing to an address based
    on the null pointer plus an offset.
    
    The bug has been there since the first committed version of the threaded
    decoder and thus affects versions from 5.3.3alpha to 5.8.0.
    
    As the commit message in 4cce3e27f529 says, I had made significant
    changes on top of Sebastian's patch. This bug was indeed introduced
    by my changes; it wasn't in Sebastian's version.
    
    Thanks to Harri K. Koskinen for discovering and reporting this issue.
    
    Fixes: 4cce3e27f529 ("liblzma: Add threaded .xz decompressor.")
    Reported-by: Harri K. Koskinen <x64nop@nannu.org>
    Reviewed-by: Sebastian Andrzej Siewior <sebastian@breakpoint.cc>
    Thanks-to: Sam James <sam@gentoo.org>

 src/liblzma/common/stream_decoder_mt.c | 31 ++++++++++++++++++++++---------
 1 file changed, 22 insertions(+), 9 deletions(-)

commit c0c835964dfaeb2513a3c0bdb642105152fe9f34
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-03 14:34:42 +0300

    liblzma: mt dec: Simplify by removing the THR_STOP state
    
    The main thread can directly set THR_IDLE in threads_stop() which is
    called when errors are detected. threads_stop() won't return the stopped
    threads to the pool or free the memory pointed by thr->in anymore, but
    it doesn't matter because the existing workers won't be reused after
    an error. The resources will be cleaned up when threads_end() is
    called (reinitializing the decoder always calls threads_end()).
    
    Reviewed-by: Sebastian Andrzej Siewior <sebastian@breakpoint.cc>
    Thanks-to: Sam James <sam@gentoo.org>

 src/liblzma/common/stream_decoder_mt.c | 75 +++++++++++++---------------------
 1 file changed, 29 insertions(+), 46 deletions(-)

commit 831b55b971cf579ee16a854f177c36b20d3c6999
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-03 14:34:42 +0300

    liblzma: mt dec: Fix a comment
    
    Reviewed-by: Sebastian Andrzej Siewior <sebastian@breakpoint.cc>
    Thanks-to: Sam James <sam@gentoo.org>

 src/liblzma/common/stream_decoder_mt.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit b9d168eee4fb6393b4fe207c0aeb5faee316ca1a
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-03 14:34:30 +0300

    liblzma: Add assertions to lzma_bufcpy()

 src/liblzma/common/common.c | 6 ++++++
 1 file changed, 6 insertions(+)

commit c8e0a4897b4d0f906966f5d4d4f662221d64f3ae
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-04-02 16:40:22 +0300

    DOS: Update Makefile to fix the build

 dos/Makefile | 2 ++
 1 file changed, 2 insertions(+)

commit 307c02ed698a69763ef1c9c0df4ff24727442118
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-03-29 12:41:32 +0200

    sysdefs.h: Avoid <stdalign.h> even with C11 compilers
    
    Oracle Developer Studio 12.6 on Solaris 10 claims C11 support in
    __STDC_VERSION__ and supports _Alignas. However, <stdalign.h> is missing.
    We only need alignas, so define it to _Alignas with C11/C17 compilers.
    If something included <stdalign.h> later, it shouldn't cause problems.
    
    Thanks to Ihsan Dogan for reporting the issue and testing the fix.
    
    Fixes: c0e7eaae8d6eef1e313c9d0da20ccf126ec61f38

 src/common/sysdefs.h | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit 7ce38b318339d6c01378a77585e08169ca3a604e
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-03-29 12:32:05 +0200

    Update THANKS

 THANKS | 1 +
 1 file changed, 1 insertion(+)

commit 688e51bde4c987589717b2be1a1fde9576c604fc
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-03-29 12:21:51 +0200

    Translations: Update the Croatian translation

 po/hr.po | 14 +++++++-------
 1 file changed, 7 insertions(+), 7 deletions(-)

commit 173fb5c68b08a8c1369550267be258132b7760c6
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-03-25 18:23:57 +0200

    doc/SHA256SUMS: Add 5.8.0

 doc/SHA256SUMS | 6 ++++++
 1 file changed, 6 insertions(+)

commit db9258e828bc2cd96e3954f1ddcc9d3530589025
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-03-25 15:18:32 +0200

    Bump version and soname for 5.8.0
    
    Also remove the LZMA_UNSTABLE macro.

 src/liblzma/Makefile.am         | 2 +-
 src/liblzma/api/lzma/bcj.h      | 2 --
 src/liblzma/api/lzma/version.h  | 6 +++---
 src/liblzma/common/common.h     | 2 --
 src/liblzma/liblzma_generic.map | 2 +-
 src/liblzma/liblzma_linux.map   | 2 +-
 6 files changed, 6 insertions(+), 10 deletions(-)

commit bfb752a38f89ed03fc93d54f11c09f43fda64bc2
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-03-25 15:18:32 +0200

    Add NEWS for 5.8.0

 NEWS | 62 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 62 insertions(+)

commit 6ccbb904da851eb0c174c8dbd43e84da31739720
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-03-25 15:18:31 +0200

    Translations: Run "make -C po update-po"
    
    POT-Creation-Date is set to match the timestamp in 5.7.2beta which
    in the Translation Project is known as 5.8.0-pre1. The strings
    haven't changed since 5.7.1alpha but a few comments have.
    
    This is a very noisy commit, but this helps keeping the PO files
    similar between the Git repository and stable release tarballs.

 po/ca.po    | 964 ++++++++++++++++++++++++++++++++++++++++++++---------------
 po/cs.po    | 935 ++++++++++++++++++++++++++++++++++++++++++----------------
 po/da.po    | 663 ++++++++++++++++++++++++++++++-----------
 po/de.po    |   7 +-
 po/eo.po    | 966 +++++++++++++++++++++++++++++++++++++++++++++---------------
 po/es.po    |   7 +-
 po/fi.po    |   2 +-
 po/fr.po    | 916 +++++++++++++++++++++++++++++++++++++++++---------------
 po/hu.po    | 966 +++++++++++++++++++++++++++++++++++++++++++++---------------
 po/ka.po    |   7 +-
 po/ko.po    |   7 +-
 po/nl.po    |   7 +-
 po/pl.po    |   7 +-
 po/pt_BR.po | 962 ++++++++++++++++++++++++++++++++++++++++++++---------------
 po/sr.po    |   2 +-
 po/sv.po    |   7 +-
 po/tr.po    |   7 +-
 po/uk.po    |   7 +-
 po/vi.po    | 948 +++++++++++++++++++++++++++++++++++++++++++---------------
 po/zh_CN.po | 940 ++++++++++++++++++++++++++++++++++++++++++++--------------
 po/zh_TW.po |   2 +-
 21 files changed, 6209 insertions(+), 2120 deletions(-)

commit 891a5f057a6bb2dd2e3ce5e3bdd7a1f1ee03b800
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-03-25 15:18:31 +0200

    Translations: Run po4a/update-po
    
    Also remove the trivial obsolete messages like man page dates.
    
    This is a noisy commit, but this helps keeping the PO files similar
    between the Git repository and stable release tarballs.

 po4a/fr.po    | 82 +++++++++++++++++++++++++++++++++++++------------------
 po4a/pt_BR.po | 88 +++++++++++++++++++++++++++++++++++++++++------------------
 po4a/sr.po    | 79 ++++++++++++++++++++++++++++++++++-------------------
 3 files changed, 167 insertions(+), 82 deletions(-)

commit 4f52e7387012cb3510b01c937dd9b3a0c6a3ac6c
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-03-25 15:18:31 +0200

    Translations: Partially fix overtranslation in Serbian man pages
    
    Names of environment variables and some other strings must be present
    in the original form. The translator couldn't be reached so I'm
    changing some of the strings myself. In the "Robot mode" section,
    occurrences in the middle of sentences weren't changed to reduce
    the chance of grammar breakage, but I kept the translated strings in
    parenthesis in the headings. It's not ideal, but now people shouldn't
    need to look at the English man page to find the English strings.

 po4a/sr.po | 66 ++++++++++++++++++++++++++++++++++++++++++--------------------
 1 file changed, 45 insertions(+), 21 deletions(-)

commit ff5d944749b99eb5ab35e2ebaf01d05a59e7169b
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-03-25 15:18:31 +0200

    liblzma: Count the extra bytes in LZMA/LZMA2 decoder memory usage

 src/liblzma/lz/lz_decoder.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 943b012d09f717f7b44284c4e4976ea41264c731
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-03-25 15:18:31 +0200

    liblzma: Use SSE2 intrinsics instead of memcpy() in dict_repeat()
    
    SSE2 is supported on every x86-64 processor. The SSE2 code is used on
    32-bit x86 if compiler options permit unconditional use of SSE2.
    
    dict_repeat() copies short random-sized unaligned buffers. At least
    on glibc, FreeBSD, and Windows (MSYS2, UCRT, MSVCRT), memcpy() is
    clearly faster than byte-by-byte copying in this use case. Compared
    to the memcpy() version, the new SSE2 version reduces decompression
    time by 0-5 % depending on the machine and libc. It should never be
    slower than the memcpy() version.
    
    However, on musl 1.2.5 on x86-64, the memcpy() version is the slowest.
    Compared to the memcpy() version:
    
      - The byte-by-version takes 6-7 % less time to decompress.
      - The SSE2 version takes 16-18 % less time to decompress.
    
    The numbers are from decompressing a Linux kernel source tarball in
    single-threaded mode on older AMD and Intel systems. The tarball
    compresses well, and thus dict_repeat() performance matters more
    than with some other files.

 src/liblzma/lz/lz_decoder.c | 14 ++++++--
 src/liblzma/lz/lz_decoder.h | 87 ++++++++++++++++++++++++++++++++++++++++-----
 2 files changed, 90 insertions(+), 11 deletions(-)

commit bc14e4c94e788d42eeab984298391fc0ca46f969
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-03-25 15:18:31 +0200

    liblzma: Add "restrict" to a few functions in lz_decoder.h
    
    This doesn't make any difference in practice because compilers can
    already see that writing through the dict->buf pointer cannot modify
    the contents of *dict itself: The LZMA decoder makes a local copy of
    the lzma_dict structure, and even if it didn't, the pointer to
    lzma_dict in the LZMA decoder is already "restrict".
    
    It's nice to add "restrict" anyway. uint8_t is typically unsigned char
    which can alias anything. Without the above conditions or "restrict",
    compilers could need to assume that writing through dict->buf might
    modify *dict. This would matter in dict_repeat() because the loops
    refer to dict->buf and dict->pos instead of making local copies of
    those members for the duration of the loops. If compilers had to
    assume that writing through dict->buf can affect *dict, then compilers
    would need to emit code that reloads dict->buf and dict->pos after
    every write through dict->buf.

 src/liblzma/lz/lz_decoder.h | 7 ++++---
 1 file changed, 4 insertions(+), 3 deletions(-)

commit e82ee090c567e560f51a056775a17f534d159d65
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-03-25 15:18:30 +0200

    liblzma: Define LZ_DICT_INIT_POS for initial dictionary position
    
    It's more readable.

 src/liblzma/lz/lz_decoder.c | 4 ++--
 src/liblzma/lz/lz_decoder.h | 9 ++++++---
 2 files changed, 8 insertions(+), 5 deletions(-)

commit 8e7cd0091e5239334437decbe1989662d45a2f47
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-03-25 15:18:30 +0200

    Windows: Update README-Windows.txt about UCRT

 windows/README-Windows.txt | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 2c24292d341e505e5579fccac3bce5bc71d839ef
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-03-25 15:18:15 +0200

    Update THANKS

 THANKS | 1 +
 1 file changed, 1 insertion(+)

commit 48053c90898fa191a216aefca01626520a7413f4
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-03-17 15:33:25 +0200

    Translations: Update the Italian translation

 po/it.po | 32 ++++++++++++++++----------------
 1 file changed, 16 insertions(+), 16 deletions(-)

commit 8d6f06a65f50358fad13567f5dd8af41ef1d2b58
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-03-17 15:28:56 +0200

    Translations: Update the Portuguese translation
    
    The language tag in the Translation Project is pt, not pt_PT,
    thus I changed the "Language:" line to pt.

 po/pt.po | 1045 +++++++++++++++++++++++++++++++-------------------------------
 1 file changed, 526 insertions(+), 519 deletions(-)

commit c3439b039f46fe547ad603e16dc3bd63c1ca9b0c
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-03-14 13:02:21 +0200

    Translations: Update the Italian translation

 po/it.po | 1020 +++++++++++++++++++++++++++++++-------------------------------
 1 file changed, 516 insertions(+), 504 deletions(-)

commit 79b4ab8d79528dd633a84df2d29e63f5d13ccbdf
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-03-12 20:48:39 +0200

    Translations: Update the Italian man page translations
    
    Only trivial additions but this keeps the file in sync with the TP.

 po4a/it.po | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 515b6fc8557825e1335012b3b1c8cf71e2c38775
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-03-12 19:38:54 +0200

    Translations: Update the Italian man page translations

 po4a/it.po | 129 ++++++++++++++++++++++++++++++++++++-------------------------
 1 file changed, 77 insertions(+), 52 deletions(-)

commit 333b7c0b776295f0941269b4e6cdb1a0ba5f6218
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-03-10 21:00:31 +0200

    Translations: Update the Korean man page translations

 po4a/ko.po | 139 +++++++++++++++++++++++++++++++++++--------------------------
 1 file changed, 80 insertions(+), 59 deletions(-)

commit ae52ebd27dc0be5e1ba62fb0c45255d8563fcd88
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-03-10 20:56:57 +0200

    Translations: Update the German man page translations

 po4a/de.po | 102 ++++++++++++++++++++++++++++++++++++++-----------------------
 1 file changed, 63 insertions(+), 39 deletions(-)

commit 1028e52c93d2292b44ff7bae8e721025d2f2c94d
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-03-10 13:13:30 +0200

    CMake: Fix tuklib_use_system_extensions
    
    Revert back to a macro so that list(APPEND CMAKE_REQUIRED_DEFINITIONS)
    will affect the calling scope. I had forgotten that while CMake
    functions inherit the variables from the parent scope, the changes
    to them are local unless using set(... PARENT_SCOPE).
    
    This also means that the commit message in 5bb77d0920dc is wrong. The
    commit itself is still fine, making it clearer that -DHAVE_SYS_PARAM_H
    is only needed for specific check_c_source_compiles() calls.
    
    Fixes: c1ea7bd0b60eed6ebcdf9a713ca69034f6f07179

 cmake/tuklib_common.cmake | 7 +++++--
 1 file changed, 5 insertions(+), 2 deletions(-)

commit 80e48836024ec2d7cbd557575be6da3d1f055cba
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-03-10 11:38:55 +0200

    INSTALL: Document -bmaxdata on AIX
    
    This is based on a pull request and AIX docs. I haven't tested the
    instructions myself.
    
    Closes: https://github.com/tukaani-project/xz/pull/137

 INSTALL | 5 +++++
 1 file changed, 5 insertions(+)

commit ab319186b6d0454285ff4941a777ac95e580f60f
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-03-10 11:37:19 +0200

    Update THANKS

 THANKS | 1 +
 1 file changed, 1 insertion(+)

commit 4434671a04436038f88ab0feaa251cc8d7abb683
Author: Collin Funk <collin.funk1@gmail.com>
Date:   2025-03-09 19:14:31 -0700

    tuklib_physmem: Silence -Wsign-conversion on AIX
    
    Closes: https://github.com/tukaani-project/xz/pull/168

 src/common/tuklib_physmem.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 18bcaa4fafc935d89ffde94301fa6427907306bf
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-03-09 22:10:38 +0200

    Translations: Update the Romanian man page translations

 po4a/ro.po | 110 ++++++++++++++++++++++++++++++++++++-------------------------
 1 file changed, 66 insertions(+), 44 deletions(-)

commit 1e17b7f42fe2f9df279f44ad7043d3753cd00363
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-03-09 21:28:15 +0200

    Translations: Update the Croatian translation

 po/hr.po | 19 +++++++++++--------
 1 file changed, 11 insertions(+), 8 deletions(-)

commit ff85e6130d5940896915cdbb99aa9ece9d41240b
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-03-09 21:23:34 +0200

    Translations: Update the Romanian translation

 po/ro.po | 24 +++++++++++++-----------
 1 file changed, 13 insertions(+), 11 deletions(-)

commit a5bfb33f30f77e656723d365db8b06e089d3de61
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-03-09 21:11:34 +0200

    Translations: Update the Ukrainian man page translations

 po4a/uk.po | 107 ++++++++++++++++++++++++++++++++++++-------------------------
 1 file changed, 64 insertions(+), 43 deletions(-)

commit 5bb77d0920dcf949d8eb04eb19204b7b199e42df
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-03-09 14:43:07 +0200

    CMake: Use cmake_push_check_state in tuklib_cpucores and tuklib_physmem
    
    Now the changes to CMAKE_REQUIRED_DEFINITIONS are temporary and don't
    leak to the calling code.

 cmake/tuklib_cpucores.cmake | 3 +++
 cmake/tuklib_physmem.cmake  | 4 +++-
 2 files changed, 6 insertions(+), 1 deletion(-)

commit c1ea7bd0b60eed6ebcdf9a713ca69034f6f07179
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-03-09 14:06:35 +0200

    CMake: Revise tuklib_use_system_extensions
    
    Define NetBSD and Darwin/macOS feature test macros. Autoconf defines
    these too (and a few others).
    
    Define the macros on Windows except with MSVC. The _GNU_SOURCE macro
    makes a difference with mingw-w64.
    
    Use a function instead of a macro. Don't take the TARGET_OR_ALL argument
    because there's always global effect because the global variable
    CMAKE_REQUIRED_DEFINITIONS is modified.

 CMakeLists.txt            |  2 +-
 cmake/tuklib_common.cmake | 27 +++++++++++++++------------
 2 files changed, 16 insertions(+), 13 deletions(-)

commit 4243c45a48ef8c103d77b75d9f93d48adcb631db
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-03-08 14:54:29 +0200

    doc/SHA256SUMS: Add 5.7.2beta

 doc/SHA256SUMS | 3 +++
 1 file changed, 3 insertions(+)

commit cc7f2fc1cf9f3c63cbce90ee92bfbb004f98140b
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-03-08 14:29:57 +0200

    Bump version and soname for 5.7.2beta

 src/liblzma/Makefile.am         | 2 +-
 src/liblzma/api/lzma/version.h  | 4 ++--
 src/liblzma/liblzma_generic.map | 2 +-
 src/liblzma/liblzma_linux.map   | 2 +-
 4 files changed, 5 insertions(+), 5 deletions(-)

commit 62e44b36167de27541776dcf677ed04077c9fd19
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-03-08 14:24:38 +0200

    Add NEWS for 5.7.2beta

 NEWS | 35 +++++++++++++++++++++++++++++++++++
 1 file changed, 35 insertions(+)

commit 70f1f203789433b5d7b8b22e1655abc465d659f7
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-03-08 14:23:00 +0200

    COPYING: Remove the note about old releases

 COPYING | 19 -------------------
 1 file changed, 19 deletions(-)

commit db9827dc38ff79de747a6fc7a99619e961dbc5e6
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-03-08 14:22:28 +0200

    xz: Update the man page about the environment variables again

 src/xz/xz.1 | 22 +++++++++++-----------
 1 file changed, 11 insertions(+), 11 deletions(-)

commit 99c584891bd1d946561cebded2226df9b83f1efb
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-03-06 19:26:09 +0200

    liblzma: Edit spelling in a comment
    
    It was found with codespell.

 src/liblzma/api/lzma/container.h | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 7a234c8c05a8f64efde013cd6a6d31a90b7d0d28
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-03-06 19:14:23 +0200

    xz: Update the man page about the environment variables

 src/xz/xz.1 | 26 ++++++++++++++++++++++++--
 1 file changed, 24 insertions(+), 2 deletions(-)

commit 808f05af3ef40730d40b3798666757bd866484f1
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-03-06 17:37:39 +0200

    Docs: Add a few TRANSLATORS comments to man pages
    
    All translators know that --command-line-options must not be translated.
    With some other strings it's not obvious when the untranslated string
    must be preserved. These comments hopefully help.

 src/scripts/xzmore.1 |  2 ++
 src/xz/xz.1          | 22 ++++++++++++++++++++++
 2 files changed, 24 insertions(+)

commit 051de255f00dda331e2a6fa189a6e7fe56a7c69b
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-03-06 16:34:32 +0200

    Scripts: Mark the LZMA Utils script aliases as deprecated
    
    The deprecated aliases are lzcmp, lzdiff, lzless, lzmore,
    lzgrep, lzegrep, and lzfgrep. The commands that start with
    the xz prefix have identical behavior, for example, both
    lzgrep and xzgrep handle all supported file formats.
    
    This doesn't affect lzma, unlzma, lzcat, lzmadec, or lzmainfo.
    The last release of LZMA Utils was made in 2008, but the lzma
    compatibility alias for the gzip-like tool is still in common use.
    Deprecating it would cause unnecessary breakage.

 src/scripts/xzdiff.1 | 5 ++++-
 src/scripts/xzgrep.1 | 6 +++++-
 src/scripts/xzless.1 | 4 +++-
 src/scripts/xzmore.1 | 4 +++-
 4 files changed, 15 insertions(+), 4 deletions(-)

commit 4941ea454c02cf15a64d6434a0778fc2a81282fc
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-03-02 21:13:04 +0200

    Translations: Add Serbian man page translations

 po4a/po4a.conf |    2 +-
 po4a/sr.po     | 3892 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 3893 insertions(+), 1 deletion(-)

commit d142d96f24daa451edaabfca8594e202932b3c0b
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-03-02 20:42:14 +0200

    Translations: Update Georgian translation

 po/ka.po | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 9b7e45d841195c8fd8d286e26f810df28c53dd16
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-02-28 21:07:21 +0200

    Update THANKS

 THANKS | 1 +
 1 file changed, 1 insertion(+)

commit 9351592710e0df3238b09d39c545a643c50ac88f
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-02-22 16:04:58 +0200

    Update THANKS

 THANKS | 1 +
 1 file changed, 1 insertion(+)

commit 9023be7831faca2f28def55e16c39e3a42e1e262
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-02-19 16:33:52 +0200

    Translations: Update the Croatian translation

 po/hr.po | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 2eaf242c56e8c65db83d48b018fa44aeafeb33a5
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-02-17 21:46:15 +0200

    Build: Fix out-of-tree builds when using the replacement getopt_long
    
    Nowaways $(top_builddir)/lib/getopt.h depends on headers in
    $(top_srcdir)/lib, so both have to be in the include path.
    CMake-based build already did this.
    
    Fixes: 7e884c00d0093c38339f17fb1d280eec493f42ca

 src/lzmainfo/Makefile.am | 6 ++++--
 src/xz/Makefile.am       | 6 ++++--
 src/xzdec/Makefile.am    | 6 ++++--
 3 files changed, 12 insertions(+), 6 deletions(-)

commit 41322b2c60cd2c67a1053cb40d27e573420185b7
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-02-17 18:25:52 +0200

    m4/getopt.m4: Remove an outdated comment

 m4/getopt.m4 | 3 ---
 1 file changed, 3 deletions(-)

commit 03c23a4952bce1b50a1d213ca2d1c15acd76a489
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-02-17 18:11:58 +0200

    Build: Allow forcing the use of the replacement getopt_long
    
    Now one can pass gl_replace_getopt=yes to configure to force the use
    of GNU getopt_long from the lib directory. This only checks that the
    value of gl_replace_getopt is non-empty, so one cannot force the
    replacement to be disabled.
    
    Closes: https://github.com/tukaani-project/xz/pull/166

 m4/getopt.m4 | 5 +++--
 1 file changed, 3 insertions(+), 2 deletions(-)

commit c23b837d15960ecc0d537f0260f389904e1e7f02
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-02-17 18:11:42 +0200

    Update THANKS

 THANKS | 1 +
 1 file changed, 1 insertion(+)

commit 2672a38f1159babf9ba3cca429f644bb823a8bdd
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-02-12 19:23:31 +0200

    Update THANKS

 THANKS | 2 ++
 1 file changed, 2 insertions(+)

commit 4fdcbfaf3f222299747c6a815762a74eeb1b0b23
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-02-11 12:13:41 +0200

    Update THANKS

 THANKS | 3 +++
 1 file changed, 3 insertions(+)

commit 0d553568f1af9a35779ecac41392a6c871786930
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-02-08 11:39:08 +0200

    Translations: Update the Polish translation

 po/pl.po | 802 ++++++++++++++++++++++++++++++++++++---------------------------
 1 file changed, 464 insertions(+), 338 deletions(-)

commit 9f165076aebb3b5115d2b6520529db8fa11a6bdd
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-02-07 19:12:03 +0200

    Docs: Update TODO a little

 TODO | 22 ++++------------------
 1 file changed, 4 insertions(+), 18 deletions(-)

commit f5aa292c534f87b9dd588e667d1c65ed31e5f289
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-02-07 18:50:56 +0200

    Add researcher credits of CVE-2022-1271 and CVE-2024-47611 to THANKS
    
    These are specific phrases that were included in the advisories and
    NEWS. It's nice to have them in THANKS as well.

 THANKS | 4 ++++
 1 file changed, 4 insertions(+)

commit 7cf463b5add70e3fb48a10de3965c8beb6c01ad9
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-02-07 18:43:00 +0200

    Update THANKS

 THANKS | 5 +++++
 1 file changed, 5 insertions(+)

commit 6b7fe7e27b77038592e2c2e31df955059dda7d1d
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-02-04 14:12:46 +0200

    Docs: Update the "Translations" section in README
    
    Make it clearer that translations cannot be accepted if they don't
    come via the Translation Project.
    
    Column headings have been handled automatically for years and now --help
    is autowrapped too, so the related instructions can be removed.

 README | 107 ++++++++++++++++++++++++-----------------------------------------
 1 file changed, 39 insertions(+), 68 deletions(-)

commit 2c7aee94936babf84b61b55420e503a0b2629ec1
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-02-04 13:23:53 +0200

    debug/translations.bash: Revise a little
    
    Make it work for out-of-tree builds without requiring one to specify
    the location of the xz executable.
    
    Add xz --filters-help.
    
    Make the output shorter by reducing the number of xz -lvv test files.
    
    Show the value of LANGUAGE environment variable.
    
    Show the xz.git version using git describe --abbrev=8 instead of =4.

 debug/translation.bash | 24 +++++++++++-------------
 1 file changed, 11 insertions(+), 13 deletions(-)

commit c6b15e7045209002bbbf4979c48072af01c20d8d
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-02-04 13:20:52 +0200

    Build: Use "git describe --abbrev=8" in snapshot tarball names
    
    8 is more likely to be reproducible than the old 4 without being
    excessively long for a small repository like this.

 Makefile.am | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 0ce97987c5b27cfb6f98984e5fd7477880e0cf33
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-02-04 19:37:17 +0200

    Update THANKS

 THANKS | 2 ++
 1 file changed, 2 insertions(+)

commit 353c33355cb12e5016d49052fd1e90d15568aa37
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-02-03 16:29:31 +0200

    Translations: Update the Serbian translation

 po/sr.po | 805 ++++++++++++++++++++++++++++++++++++---------------------------
 1 file changed, 458 insertions(+), 347 deletions(-)

commit 887dc281885052bced32b3aa309506ea58a2e78e
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-02-03 16:15:38 +0200

    Translations: Update Chinese (traditional) translation
    
    Since there are no spaces between words, the unsophisticated automatic
    word wrapping code needs some help. Compared to the version in the
    Translation Project, I added a few \t characters which the word
    wrapping code interprets as zero width spaces (hopefully they are
    placed correctly). These edits can be seen with this command:
    
        grep -v ^# po/zh_TW.po | grep --color -F '\t'

 po/zh_TW.po | 843 +++++++++++++++++++++++++++++++++---------------------------
 1 file changed, 471 insertions(+), 372 deletions(-)

commit 0f1454cf5f460a4095f47f8f73f5a290e9777d7f
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-02-03 16:12:44 +0200

    Update THANKS

 THANKS | 2 ++
 1 file changed, 2 insertions(+)

commit 23ea031820086d302a213be005a091df763b8a7b
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-02-02 14:15:07 +0200

    Build: Update posix-shell.m4 from Gnulib
    
    Tabs have been converted to spaces and a "serial" number has been
    added. The previous version was from 2008/2009. There are no functional
    changes since then but now it's clearer that the copy in XZ Utils
    isn't outdated.
    
    The new file was picked from the Gnulib commit
    81a4c1e3b7692e95c0806d948cbab9148ad85ef2. A later commit adds
    a warranty disclaimer to the license, which obviously is fine,
    but I didn't find a SPDX license identifier for the new license,
    so for simplicity I used the earlier commit.

 m4/posix-shell.m4 | 31 ++++++++++++++++---------------
 1 file changed, 16 insertions(+), 15 deletions(-)

commit 84c33c0384aa4604ff7956f2fae6f83ea60ba96b
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-02-02 12:51:03 +0200

    Build: Check for -fsanitize= also in $CC
    
    People may put -fsanitize in CC instead of CFLAGS so check both.
    Landlock sandbox isn't compatible with sanitizers so it's nice
    to catch the incompatible options at configure time.
    
    Don't attempt to do the same in CMakeLists.txt; the check for
    CMAKE_C_FLAGS / CFLAGS shall be enough there. The extra flags from
    the CC environment variable go into the undocumented internal variable
    CMAKE_C_COMPILER_ARG1 (all flags from CC go into that same variable).
    Peeking the internal variable merely for improved diagnostics isn't
    worth it.
    
    Fixes: 88588b1246d8c26ffbc138b3e5c413c5f14c3179

 configure.ac | 5 +++--
 1 file changed, 3 insertions(+), 2 deletions(-)

commit a7304ea4a7daede9789a8fe422b714e372737120
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2023-09-26 19:11:20 +0300

    Build: Remove the FIXME about -Werror checks

 configure.ac | 7 -------
 1 file changed, 7 deletions(-)

commit 1780bba74075da5e7764615bd323e95e19057dee
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2023-09-26 19:10:51 +0300

    Build: If using a GCC compatible compiler, ensure that -Werror works
    
    The check can be skipped by passing SKIP_WERROR_CHECK=yes to configure.
    It won't be documented anywhere else than in the error message.
    
    Ways to test:
    
        ./configure CC=gcc CFLAGS=-Wunused-macros
        ./configure CC=clang CFLAGS=-Weverything
        ./configure CC=clang CFLAGS=-Weverything SKIP_WERROR_CHECK=yes

 configure.ac | 26 ++++++++++++++++++++++++++
 1 file changed, 26 insertions(+)

commit 3aca2daefbdedd7cc0fb75ddde6b714273b1cc1d
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-02-02 14:30:15 +0200

    Update THANKS

 THANKS | 4 ++++
 1 file changed, 4 insertions(+)

commit 186ff78ab40ceb07cde139506cab42a927ca99d2
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-02-01 12:49:09 +0200

    Translations: Update Romanian translation

 po/ro.po | 12 ++++++------
 1 file changed, 6 insertions(+), 6 deletions(-)

commit 40a8ce3e10747ca5233610cc2cb704fc303c48e4
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-30 18:16:43 +0200

    Translations: Update Korean man page translations

 po4a/ko.po | 146 ++++++++++++++++++++++++-------------------------------------
 1 file changed, 56 insertions(+), 90 deletions(-)

commit 1787f9bd18ea8798d64b636cdefe6d0fda9b8f72
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-30 18:15:52 +0200

    Translations: Add Italian man page translations

 po4a/it.po     | 3876 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 po4a/po4a.conf |    2 +-
 2 files changed, 3877 insertions(+), 1 deletion(-)

commit 9b9182e561787a811fc0178489589f28c3e0174c
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-29 22:18:29 +0200

    Translations: Update the Finnish translation

 po/fi.po | 13 +++++++------
 1 file changed, 7 insertions(+), 6 deletions(-)

commit 7d73ff7a9d8eab6270f0b1ff7d10c0aa6f5ba53f
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-29 20:50:03 +0200

    lzmainfo: Use tuklib_mbstr_wrap for --help text
    
    Some languages have so long strings that they need to be wrapped.

 CMakeLists.txt           |  4 ++++
 src/lzmainfo/Makefile.am |  2 ++
 src/lzmainfo/lzmainfo.c  | 36 ++++++++++++++++++++++++++----------
 3 files changed, 32 insertions(+), 10 deletions(-)

commit c56eb4707627d700695813fccdddd1483eac4f21
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-29 20:00:06 +0200

    Translations: Update the Croatian translation

 po/hr.po | 926 ++++++++++++++++++++++++++++++++++++---------------------------
 1 file changed, 529 insertions(+), 397 deletions(-)

commit 69f4aec0a2442ab81f9ab66e5871a6546aefb0fc
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-29 19:56:01 +0200

    Translations: Update the Finnish translation

 po/fi.po | 911 +++++++++++++++++++++++++++++++++------------------------------
 1 file changed, 483 insertions(+), 428 deletions(-)

commit d49dde33cf5f488bb38b1f57e172c4e3343fb383
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-29 19:55:27 +0200

    Translations: Update the German man page translations

 po4a/de.po | 147 +++++++++++++++++++++++--------------------------------------
 1 file changed, 55 insertions(+), 92 deletions(-)

commit 23b99fc4a1f35bec5d63ffd02b14cacbdce9fe3c
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-29 19:55:17 +0200

    Translations: Update the German translation

 po/de.po | 825 +++++++++++++++++++++++++++++++++++----------------------------
 1 file changed, 460 insertions(+), 365 deletions(-)

commit 7edab2bde0606b42229d9c04fe664069e38de3fb
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-29 19:55:05 +0200

    Translations: Update the Turkish translation

 po/tr.po | 892 +++++++++++++++++++++++++++++++++++----------------------------
 1 file changed, 490 insertions(+), 402 deletions(-)

commit fac4d0fa5277d7a1f621707621ee9516f0bdbac5
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-29 19:54:36 +0200

    Translations: Add the Dutch translation

 po/LINGUAS |    1 +
 po/nl.po   | 1268 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 1269 insertions(+)

commit abe5092f24b55dde9f7f78fac1bf810bce173273
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-29 19:53:50 +0200

    Translations: Update the Georgian translation

 po/ka.po | 153 +++++++++++++++++++++++++++++++++++++++++++++++----------------
 1 file changed, 115 insertions(+), 38 deletions(-)

commit b97b23c78d8100eec363c3e999c511560366d347
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-29 19:53:21 +0200

    Translations: Update the Spanish translation

 po/es.po | 824 ++++++++++++++++++++++++++++++++++-----------------------------
 1 file changed, 450 insertions(+), 374 deletions(-)

commit c68318cb49e0562bd22e88724ce85e76c6789a3a
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-29 19:53:06 +0200

    Translations: Update the Korean translation

 po/ko.po | 785 +++++++++++++++++++++++++++++++++++++--------------------------
 1 file changed, 460 insertions(+), 325 deletions(-)

commit 153ee17f635962a474499f786ea1de1e1a2bb276
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-29 19:52:42 +0200

    Translations: Update the Romanian man page translations

 po4a/ro.po | 141 +++++++++++++++++++++++--------------------------------------
 1 file changed, 54 insertions(+), 87 deletions(-)

commit 6ed308197e1f9d6c7a5cfe5aae301e75544017c4
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-29 19:51:59 +0200

    Translations: Update the Romanian translation

 po/ro.po | 818 +++++++++++++++++++++++++++++++++++----------------------------
 1 file changed, 461 insertions(+), 357 deletions(-)

commit 06028803e19219f642aa9abddd3525c43594ec6c
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-29 19:50:50 +0200

    Translations: Update the Ukrainian man page translations

 po4a/uk.po | 142 +++++++++++++++++++++++--------------------------------------
 1 file changed, 54 insertions(+), 88 deletions(-)

commit 8cbaf896a65a53c1d1e7e2ffc80d6ea216b1e8df
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-29 19:50:26 +0200

    Translations: Update the Ukrainian translation

 po/uk.po | 813 ++++++++++++++++++++++++++++++++++++---------------------------
 1 file changed, 460 insertions(+), 353 deletions(-)

commit 81c352907b8048b97d9868947026701a49f377ef
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-29 19:48:43 +0200

    Translations: Update the Swedish translation

 po/sv.po | 847 ++++++++++++++++++++++++++++++++++-----------------------------
 1 file changed, 462 insertions(+), 385 deletions(-)

commit 999ce263718a52ba74245c3e2a416ab11494d1b1
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-28 16:33:32 +0200

    tuklib_physmem: Clean up disabled code

 src/common/tuklib_physmem.c | 9 +--------
 1 file changed, 1 insertion(+), 8 deletions(-)

commit 4d7e7c9d94f7a5ad4931a5bbd6ed9d00173fa1ab
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-28 16:28:18 +0200

    Windows: Avoid an error message on broken pipe
    
    Also make xz not process more input files after a broken pipe has
    been detected. This matches the behavior on POSIX. If all files
    are being written to standard output, trying with the next file is
    pointless when it's known that standard output won't accept more data.
    
    xzdec already stopped after the first error. It does so with all
    errors, so it differs from xz:
    
        $ xz -dc not_found_1 not_found_2
        xz: not_found_1: No such file or directory
        xz: not_found_2: No such file or directory
    
        $ xzdec not_found_1 not_found_2
        xzdec: not_found_1: No such file or directory
    
    Reported-by: Vincent Torri

 src/xz/file_io.c  | 13 +++++++++++++
 src/xzdec/xzdec.c | 11 ++++++++++-
 2 files changed, 23 insertions(+), 1 deletion(-)

commit 95b638480aa8203e547c709c651f421c22db1718
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-23 19:59:17 +0200

    doc/SHA256SUMS: Add 5.6.4 and 5.7.1alpha

 doc/SHA256SUMS | 9 +++++++++
 1 file changed, 9 insertions(+)

commit cdae0df31e4c2dfb1e885941cd1998e5a2b6e39d
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-23 11:50:42 +0200

    Bump version and soname for 5.7.1alpha

 src/liblzma/Makefile.am         | 2 +-
 src/liblzma/api/lzma/version.h  | 2 +-
 src/liblzma/liblzma_generic.map | 2 +-
 src/liblzma/liblzma_linux.map   | 2 +-
 4 files changed, 4 insertions(+), 4 deletions(-)

commit 4d2af2c43bae25ef4ef9cd88304471d4859aa322
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-23 11:48:43 +0200

    Translations: Run po4a/update-po

 po4a/de.po    | 64 +++++++++++++++++++++++++++++++++++++++++++++++++----------
 po4a/fr.po    | 57 +++++++++++++++++++++++++++++++++++++++++++++++-----
 po4a/ko.po    | 64 +++++++++++++++++++++++++++++++++++++++++++++++++----------
 po4a/pt_BR.po | 57 +++++++++++++++++++++++++++++++++++++++++++++++-----
 po4a/ro.po    | 64 +++++++++++++++++++++++++++++++++++++++++++++++++----------
 po4a/uk.po    | 64 +++++++++++++++++++++++++++++++++++++++++++++++++----------
 6 files changed, 320 insertions(+), 50 deletions(-)

commit ff0b825505e60e21b32e33c42f551c8f34ba393f
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-23 11:40:46 +0200

    Add NEWS for 5.7.1alpha

 NEWS | 107 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 107 insertions(+)

commit f6cd3e3bfc8d1f5a76dd55170968bf4582b95baf
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-23 11:40:46 +0200

    Add NEWS for 5.6.4

 NEWS | 45 +++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 45 insertions(+)

commit b3af3297e4d6cf0eafb48155aa97bb06c82a9228
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-23 11:40:46 +0200

    NEWS: The security fix in 5.6.3 is known as CVE-2024-47611

 NEWS | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit a04b9dd0c7c74fabd8c393d2dc68a221276d6e29
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-22 16:55:09 +0200

    windows/build.bash: Fix error message
    
    Fixes: 1ee716f74085223c8fbcae1d5a384e6bf53c0f6a

 windows/build.bash | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 4eae859ae8ad7072eaa74aeaee79a2c3c12c55cb
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-22 15:03:55 +0200

    Windows: Disable MinGW-w64's stdio functions in size-optimized builds
    
    This only affects builds with UCRT. With legacy MSVCRT, the replacement
    functions are always enabled.
    
    Omitting the MinGW-w64 replacements saves over 20 KiB per executable.
    The downside is that --enable-small or XZ_SMALL=ON disables thousand
    separator support in xz messages. If someone is OK with the slower
    speed of slightly smaller builds, lack of thousand separators won't
    matter.
    
    Don't override __USE_MINGW_ANSI_STDIO if it is already defined (via
    CPPFLAGS or such method).

 src/common/sysdefs.h | 30 +++++++++++++++++++++---------
 src/xz/util.c        |  6 +++++-
 2 files changed, 26 insertions(+), 10 deletions(-)

commit a831bc185bdd44c06847eae8df2d35cc281f65da
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-20 16:44:27 +0200

    liblzma: Add raw ARM64, RISC-V, and x86 BCJ filter APIs
    
    Put them behind the LZMA_UNSTABLE macro for now.
    
    These low-level special APIs might become useful in erofs-utils.

 src/liblzma/api/lzma/bcj.h      | 99 +++++++++++++++++++++++++++++++++++++++++
 src/liblzma/common/common.h     |  2 +
 src/liblzma/liblzma_generic.map | 10 +++++
 src/liblzma/liblzma_linux.map   | 10 +++++
 src/liblzma/simple/arm64.c      | 18 ++++++++
 src/liblzma/simple/riscv.c      | 18 ++++++++
 src/liblzma/simple/x86.c        | 24 ++++++++++
 7 files changed, 181 insertions(+)

commit 6f5cdd4534faf7db4b6c123651d6a606bc59b98c
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-20 16:31:49 +0200

    xz: Unify a few strings with liblzma
    
    Avoid having both "%s: foo" and "foo" as translatable strings
    so that translators don't need to handle it twice.

 src/xz/options.c | 11 ++++++-----
 src/xz/util.c    |  4 ++--
 2 files changed, 8 insertions(+), 7 deletions(-)

commit 713fdaa8b06a83f18b06811aba7b9bd7b7cbf1cb
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-20 16:31:49 +0200

    xz: Translate error messages from lzma_str_to_filters()
    
    liblzma doesn't use gettext but the messages are included in xz.pot,
    so xz can translate the messages.

 src/xz/coder.c | 9 +++------
 1 file changed, 3 insertions(+), 6 deletions(-)

commit f2e2b267cab8d7aa0b0a58c325546ee5070c0028
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-20 16:31:49 +0200

    liblzma: Mark string conversion messages as translatable

 po/POTFILES.in                         |  1 +
 src/liblzma/common/string_conversion.c | 96 ++++++++++++++++++++--------------
 2 files changed, 59 insertions(+), 38 deletions(-)

commit f49d7413d9a0d480ded6d448c1ef7475ae6cd1c9
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-20 16:31:35 +0200

    liblzma: Tweak a few error messages in lzma_str_to_filters()

 src/liblzma/common/string_conversion.c | 9 +++++----
 1 file changed, 5 insertions(+), 4 deletions(-)

commit da359c360e986b21cd8d7b888c6a80f56b9d49c7
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-19 20:11:54 +0200

    Update THANKS

 THANKS | 1 +
 1 file changed, 1 insertion(+)

commit f032373561cefaf07f92ffe3fbc471ec6770456e
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-19 19:40:32 +0200

    Update THANKS

 THANKS | 1 +
 1 file changed, 1 insertion(+)

commit 51f038f8cbd5d8a95954c05bfcbbc32f2a313615
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-13 08:44:58 +0200

    liblzma: memcmplen.h: Use 8-byte method on 64-bit unaligned archs
    
    Previously it was enabled only on x86-64 and ARM64 when also support
    for unaligned access was detected or manually enabled at built time.
    
    In the default build configuration, the 8-byte method is now enabled
    also on 64-bit RISC-V and 64-bit PowerPC (both endiannesses). It was
    reported that on big endian POWER9, encoding time may reduce 12-13 %.
    
    This change only affects builds with GCC and Clang because the code
    uses __builtin_ctzll or __builtin_clzll.
    
    Thanks to Marcus Comstedt for testing on POWER9.

 src/liblzma/common/memcmplen.h | 3 +--
 1 file changed, 1 insertion(+), 2 deletions(-)

commit 96336b0110d47756a9fd2a103fbf0a99e905fbed
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-12 13:06:17 +0200

    Update THANKS

 THANKS | 1 +
 1 file changed, 1 insertion(+)

commit 150356207c8d6a3e0af465b676430d19d62f884c
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-12 12:59:20 +0200

    liblzma: Fix the encoder breakage on big endian ARM64
    
    When the 8-byte method was enabled for ARM64, a check for endianness
    wasn't added. This broke the LZMA/LZMA2 encoder. Test suite caught it.
    
    Fixes: cd64dd70d5665b6048829c45772d08606f44672e
    Co-authored-by: Marcus Comstedt <marcus@mc.pp.se>

 src/liblzma/common/memcmplen.h | 9 +++++++--
 1 file changed, 7 insertions(+), 2 deletions(-)

commit b01b0958025a2da284b53a583f313f8140636cb5
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-12 11:04:27 +0200

    Windows: Update manifest comments about long UTF-8 filenames

 src/common/w32_application.manifest.comments.txt | 23 +++++++++++++++--------
 1 file changed, 15 insertions(+), 8 deletions(-)

commit 0dfc67d37ebb038be8a9b17b536d1b561d52e81a
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-12 10:47:58 +0200

    Windows: Update build.bash and its README-Windows.txt to UCRT
    
    While MSVCRT builds are possible, UCRT works better with UTF-8.
    A 32-bit build is included still but hopefully it's not actually
    needed anymore.

 windows/README-Windows.txt | 17 ++++++++---------
 windows/build.bash         | 20 ++++++++++++++------
 2 files changed, 22 insertions(+), 15 deletions(-)

commit 7b3eb2db6c4ba24b5eb438e58ab1ca57e14e59c2
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-10 13:11:40 +0200

    Translations: Update Serbian translation
    
    I rewrapped a few overlong lines. Those edits aren't in the
    Translation Project. Automatic wrapping in the master branch
    means that these strings need to be updated soon anyway.

 po/sr.po | 346 ++++++++++++++++++++++-----------------------------------------
 1 file changed, 121 insertions(+), 225 deletions(-)

commit 950da11ce09c90412dcbca29689575037640667a
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-08 19:26:29 +0200

    Build: Use --sort=name in TAR_OPTIONS
    
    Use also LC_COLLATE=C to make the sorting locale-independent.
    Sorting makes the file order reproducible.

 Makefile.am | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 75d91d6b39ea3e2fae8f027dcec01be2dca9594d
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-08 19:08:08 +0200

    xz: Workaround broken O_SEARCH in musl
    
    Testing with musl 1.2.5 and Linux 6.12, O_SEARCH doesn't result
    in a file descriptor that works with fsync() although it should work.
    See the added comment.
    
    The same issue affected gzip --synchronous:
    
        https://bugs.gnu.org/75405
    
    Thanks to Paul Eggert.

 src/xz/file_io.c | 11 +++++++++++
 1 file changed, 11 insertions(+)

commit ea92eae122a3ccefa61087f84fd99b417fc9ee3c
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-07 21:34:33 +0200

    Revert "xz: O_SEARCH cannot be used for fsync()"
    
    This reverts commit 4014e2479c7b0273f15bd0c9c017c5fe859b0d8f.
    
    POSIX-conforming O_SEARCH should allow fsync().

 src/xz/file_io.c | 21 +++++++++++----------
 1 file changed, 11 insertions(+), 10 deletions(-)

commit 4014e2479c7b0273f15bd0c9c017c5fe859b0d8f
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-05 21:43:11 +0200

    xz: O_SEARCH cannot be used for fsync()
    
    Opening a directory with O_SEARCH results in a file descriptor that can
    be used with functions like openat(). Such a file descriptor cannot be
    used with fsync(). Use O_RDONLY instead.
    
    In musl, O_SEARCH becomes Linux-specific O_PATH. A file descriptor
    from O_PATH doesn't allow fsync().
    
    Seems that it's not possible to fsync() a directory that has write
    and search permissions but not read permission.
    
    Fixes: 2a9e91d796d091740489d951fa7780525e4275f1

 src/xz/file_io.c | 21 ++++++++++-----------
 1 file changed, 10 insertions(+), 11 deletions(-)

commit ad2b57cb477b753293c25a01fc24c7f84ee523c2
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-05 20:48:28 +0200

    CI: Make ctest show errors from failed tests

 build-aux/ci_build.bash | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit c405264c031aceaf68dfd1546d6337afcebd48e5
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-05 20:14:49 +0200

    tuklib_mbstr_nonprint: Preserve the value of errno
    
    A typical use case is like this:
    
        printf("%s: %s\n", tuklib_mask_nonprint(filename), strerror(errno));
    
    tuklib_mask_nonprint() may call mbrtowc() and malloc() which may modify
    errno. If errno isn't preserved, the error message might be wrong if
    a compiler decides to call tuklib_mask_nonprint() before strerror().
    
    Fixes: 40e573305535960574404d2eae848b248c95ea7e

 src/common/tuklib_mbstr_nonprint.c | 17 ++++++++++++++---
 src/common/tuklib_mbstr_nonprint.h |  4 +++-
 2 files changed, 17 insertions(+), 4 deletions(-)

commit 2a9e91d796d091740489d951fa7780525e4275f1
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-05 20:14:49 +0200

    xz: Use fsync() before deleting the input file, and add --no-sync
    
    xz's default behavior is to delete the input file after successful
    compression or decompression (unless writing to standard output).
    If the system crashes soon after the deletion, it is possible that
    the newly written file has not yet hit the disk while the previous
    delete operation might have. In that case neither the original file
    nor the written file is available.
    
    Call fsync() on the file. On POSIX systems, sync also the directory
    where the file was created.
    
    Add a new option --no-sync which disables fsync() usage. It can avoid
    a (possibly significant) performance penalty when processing many
    small files. It's fine to use --no-sync when one knows that the files
    are easy to recreate or restore after a system crash.
    
    Using fsync() after every flush initiated by --flush-timeout was
    considered. It wasn't implemented at least for now.
    
      - --flush-timeout is typically used when writing to stdout. If stdout
        is a file, xz cannot (portably) sync the directory of the file.
        One would need to create the output file first, sync the directory,
        and then run xz with fsync() enabled.
    
      - If xz --flush-timeout output goes to a file, it's possible to use
        a separate script to sync the file, for example, once per minute
        while telling xz to flush more frequently.
    
      - Not supporting syncing with --flush-timeout was simpler.
    
    Portability notes:
    
      - On systems that lack O_SEARCH (like Linux), "xz dir/file" will now
        fail if "dir" cannot be opened for reading. If "dir" still has
        write and search permissions (like d-wx------ in "ls -l"),
        previously xz would have been able to compress "dir/file" still.
        Now it only works if using --no-sync (or --keep or --stdout).
    
      - <libgen.h> and dirname() should be available on all POSIX systems,
        and aren't needed on non-POSIX systems.
    
      - fsync() is available on all POSIX systems. The directory syncing
        could be changed to fdatasync() although at least on ext4 it
        doesn't seem to make a performance difference in xz's usage.
        fdatasync() would need a build system check to support (old)
        special cases, for example, MINIX 3.3.0 doesn't have fdatasync()
        and Solaris 10 needs -lrt.
    
      - On native Windows, _commit() is used to replace fsync(). Directory
        syncing isn't done and shouldn't be needed. (In Cygwin, fsync() on
        directories is a no-op.)
    
      - DJGPP has fsync() for files. ;-)
    
    Using fsync() was considered somewhere around 2009 and again in 2016 but
    those times the idea was rejected. For comparison, GNU gzip 1.7 (2016)
    added the option --synchronous which enables fsync().
    
    Co-authored-by: Sebastian Andrzej Siewior <sebastian@breakpoint.cc>
    Fixes: https://bugs.debian.org/814089
    Link: https://www.mail-archive.com/xz-devel@tukaani.org/msg00282.html
    Closes: https://github.com/tukaani-project/xz/pull/151

 src/xz/args.c    |  14 ++++++
 src/xz/args.h    |   2 +-
 src/xz/file_io.c | 129 +++++++++++++++++++++++++++++++++++++++++++++++++++++--
 src/xz/file_io.h |   6 +++
 src/xz/message.c |   3 ++
 src/xz/sandbox.c |   5 ++-
 src/xz/xz.1      |  24 ++++++++++-
 7 files changed, 177 insertions(+), 6 deletions(-)

commit 2e28c7145747b3287283f13c9d2becd73a7c4a1f
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-12-27 09:15:50 +0200

    xz: Use "goto" for error handling in io_open_dest_real()

 src/xz/file_io.c | 20 +++++++++-----------
 1 file changed, 9 insertions(+), 11 deletions(-)

commit 75107217670a97b7b772833669d88c3c2f188e37
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-05 12:10:05 +0200

    liblzma: Always validate the first digit of a preset string
    
    lzma_str_to_filters() may call parse_lzma12_preset() in two ways. The
    call from str_to_filters() detects the string type from the first
    character(s) and as a side-effect it validates the first digit of
    the preset string. So this change makes no difference there.
    
    However, the call from parse_options() doesn't pre-validate the string.
    parse_lzma12_preset() will return an invalid value which is passed to
    lzma_lzma_preset() which safely rejects it. The bug still affects the
    the error message:
    
        $ xz --filters=lzma2:preset=X
        xz: Error in --filters=FILTERS option:
        xz: lzma2:preset=X
        xz:               ^
        xz: Unsupported preset
    
    After the fix:
    
        $ xz --filters=lzma2:preset=X
        xz: Error in --filters=FILTERS option:
        xz: lzma2:preset=X
        xz:              ^
        xz: Unsupported preset
    
    The ^ now correctly points to the X and not past it because the X itself
    is the problematic character.
    
    Fixes: cedeeca2ea6ada5b0411b2ae10d7a859e837f203

 src/liblzma/common/string_conversion.c | 4 ++++
 1 file changed, 4 insertions(+)

commit 52ff32433734d03befd85a5bf00fba77d6501455
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-05 11:40:34 +0200

    xz: Fix getopt_long argument type in --filters*
    
    Forgetting the argument (or not using = to separate the option from
    the argument) resulted in lzma_str_to_filters() being called with NULL
    as input string argument. The function handles it fine but xz passes
    the NULL to printf() too:
    
        $ xz --filters
        xz: Error in --filters=FILTERS option:
        xz: (null)
        xz: ^
        xz: Unexpected NULL pointer argument(s) to lzma_str_to_filters()
    
    Now it's correct:
    
        $ xz --filters
        xz: option '--filters' requires an argument
    
    The --filters-help option doesn't take any arguments.
    
    Fixes: 9ded880a0221f4d1256845fc4ab957ffd377c760
    Fixes: d6af7f347077b22403133239592e478931307759
    Fixes: a165d7df1964121eb9df715e6f836a31c865beef

 src/xz/args.c | 22 +++++++++++-----------
 1 file changed, 11 insertions(+), 11 deletions(-)

commit 2655c81b5e92278b0fd51f6537c1116f8349b02a
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-04 20:04:56 +0200

    xzdec: Don't leave Landlock file descriptor open for no reason
    
    This fix is similar to 48ff3f06521ca326996ab9a04d1b342098960427.
    
    Fixes: d74fb5f060b76db709b50f5fd37490394e52f975

 src/xzdec/xzdec.c | 2 ++
 1 file changed, 2 insertions(+)

commit 35df4c2bc0500e60ba9d0d163d37a6d110d6841e
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-04 20:02:18 +0200

    xz: Make --single-stream imply --keep
    
    Suggested by xx on #tukaani on 2024-04-12.

 src/xz/args.c | 3 +++
 src/xz/xz.1   | 9 ++++++++-
 2 files changed, 11 insertions(+), 1 deletion(-)

commit 6f412814a8019700248229ce972530159a0d9872
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-04 19:57:07 +0200

    Update AUTHORS
    
    The contributions have been rewritten.

 AUTHORS                         | 2 +-
 src/liblzma/check/crc32_arm64.h | 1 -
 src/liblzma/check/crc32_fast.c  | 1 -
 src/liblzma/check/crc_common.h  | 1 -
 4 files changed, 1 insertion(+), 4 deletions(-)

commit 5651d153031a7ee2581cdba9bff658031826cb50
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-04 15:02:16 +0200

    xz: Avoid printf formats like %2$s
    
    It's a POSIX feature that isn't in standard C. It's not available on
    Windows. Even MinGW-w64 with __USE_MINGW_ANSI_STDIO doesn't support
    it even though it supports POSIX %'d for thousand separators.
    
    Gettext's <libintl.h> provides overrides for printf and other functions
    which do support the %2$s formats. Translations use them. But xz should
    work on Windows without <libintl.h> too.
    
    Fixes: 3e9177fd206d20d6d8acc7d203c25a9ae0549229

 src/xz/message.c | 51 ++++++++++++++++++++++++++++++++-------------------
 1 file changed, 32 insertions(+), 19 deletions(-)

commit 63b246c90e7677c617faab1d3f6fc5c643b5e7cf
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-04 14:41:37 +0200

    tuklib_mbstr_wrap: Add printf format attribute
    
    It's supported by GCC 3.x already.

 src/common/tuklib_common.h     | 7 +++++++
 src/common/tuklib_mbstr_wrap.h | 1 +
 2 files changed, 8 insertions(+)

commit a7313c01d9b8db71ffb61dc1dd7c4ea928824b4b
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-04 13:44:12 +0200

    xz: Translate a Windows-specific string
    
    Originally I thought that native Windows builds wouldn't be translated
    but nowadays at least MSYS2 ships such binaries.

 src/xz/file_io.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 00eb6073c088be9e7516dfc00a13ef520827b57c
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-02 15:32:10 +0200

    xz: Use my_landlock.h
    
    A slightly silly thing is that xz may now query the ABI version up to
    three times. We could call my_landlock_ruleset_attr_forbid_all() only
    once and cache the result but it didn't seem worth doing.

 CMakeLists.txt   |  1 +
 src/xz/sandbox.c | 72 ++++++++++----------------------------------------------
 2 files changed, 13 insertions(+), 60 deletions(-)

commit 0fc5a625d7cc4ad51fde9367de088b9ad3bd40f6
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-02 15:32:10 +0200

    xzdec: Use my_landlock.h

 CMakeLists.txt    |  1 +
 src/xzdec/xzdec.c | 34 ++++++----------------------------
 2 files changed, 7 insertions(+), 28 deletions(-)

commit 38cb8ec9fd70d25fca6b473de44cf61586238552
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-02 15:32:10 +0200

    Add my_landlock.h with helper functions to use Linux Landlock
    
    This supports up to Landlock ABI version 6. The current code in
    xz and xzdec only support up to ABI version 4.

 src/Makefile.am          |   1 +
 src/common/my_landlock.h | 141 +++++++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 142 insertions(+)

commit 672da29bb3a209a727ae46c0df948d7eea69f2e2
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-01 18:46:50 +0200

    liblzma: Silence warnings from "clang -Wimplicit-fallthrough"

 src/liblzma/lzma/lzma_decoder.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 1a8a1ad9a1e3179ce267baa551fb17b30624b4dd
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-01 15:34:51 +0200

    Build: Use -Wimplicit-fallthrough=5 when supported
    
    Now that we have the FALLTHROUGH macro, use the strictest mode with
    GCC so that comment-based fallthrough markings are no longer accepted.
    
    In GCC, -Wextra includes -Wimplicit-fallthrough=3 and
    -Wimplicit-fallthrough is the same as -Wimplicit-fallthrough=3.
    Thus, the strict mode requires specifying -Wimplicit-fallthrough=5.
    
    Clang has -Wimplicit-fallthrough which is *not* enabled by -Wextra.
    Clang doesn't have a variant that takes an argument. Thus we need
    to check for -Wimplicit-fallthrough. Do it before checking for
    -Wimplicit-fallthrough=5 so that the latter overrides the former
    when using GCC.

 CMakeLists.txt | 2 ++
 configure.ac   | 2 ++
 2 files changed, 4 insertions(+)

commit 94adc996e45cc5cad9352cc3271d3a1a2f5c4c22
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-01 15:30:50 +0200

    Replace "Fall through" comments with FALLTHROUGH

 src/liblzma/common/alone_decoder.c     |  3 +--
 src/liblzma/common/auto_decoder.c      |  5 ++---
 src/liblzma/common/block_decoder.c     |  6 ++----
 src/liblzma/common/block_encoder.c     |  6 ++----
 src/liblzma/common/common.c            |  2 +-
 src/liblzma/common/file_info.c         | 22 +++++++++-------------
 src/liblzma/common/index_decoder.c     |  9 +++------
 src/liblzma/common/index_encoder.c     |  6 ++----
 src/liblzma/common/index_hash.c        |  7 +++----
 src/liblzma/common/lzip_decoder.c      | 14 +++++---------
 src/liblzma/common/stream_decoder.c    | 16 ++++++----------
 src/liblzma/common/stream_decoder_mt.c | 25 +++++++++----------------
 src/liblzma/common/stream_encoder_mt.c | 10 ++++------
 src/liblzma/lzma/lzma2_encoder.c       |  9 +++------
 src/xz/args.c                          |  2 +-
 src/xz/list.c                          |  3 +--
 16 files changed, 54 insertions(+), 91 deletions(-)

commit f31c3a6647b5a5d056324a9c83e6b2c940ebec22
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-01 15:08:51 +0200

    sysdefs.h: Add FALLTHROUGH macro

 src/common/sysdefs.h | 9 +++++++++
 1 file changed, 9 insertions(+)

commit e34dbd6a0ae7a560a5508d51fc0bd142c5a320dc
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-01 15:06:15 +0200

    xzdec: Fix language in a comment

 src/xzdec/xzdec.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 16821252c504071f5c2012e415e59cbf5fb79820
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-02 13:35:48 +0200

    Windows: Make NLS require UCRT and gettext-runtime >= 0.23.1
    
    Also remove the recently-added workaround from tuklib_gettext.h.
    Requiring a new enough gettext-runtime is cleaner. I guess it's
    mostly MSYS2 where xz is built with translation support, so once
    MSYS2 has Gettext >= 0.23.1, this requirement shouldn't be a problem
    in practice.

 CMakeLists.txt              | 29 ++++++++++++++++++++++++++
 configure.ac                | 29 ++++++++++++++++++++++++++
 src/common/tuklib_gettext.h | 51 ---------------------------------------------
 3 files changed, 58 insertions(+), 51 deletions(-)

commit aa1807ed942579f700a08ab091b796cf04e31aec
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2025-01-02 11:52:17 +0200

    windows/build-with-cmake.bat: Fix ENABLE_NLS to XZ_NLS
    
    Fixes: 29f77c7b707f2458fb047e77497354b195e05b14

 windows/build-with-cmake.bat | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit ea21c76aa2406ba06ac154fe57741734c04f260f
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-12-30 11:21:57 +0200

    Build: Use git log --pretty=medium when creating ChangeLog
    
    It's the default in git-log. Specifying it explicitly is good in case
    a user has set format.pretty to a different value.

 Makefile.am | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 08050c0788ce5bac0ffd572e9784a2749c4a13df
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-12-30 10:51:33 +0200

    Windows: Update MinGW-w64 + CMake instructions to recommend UCRT

 windows/INSTALL-MinGW-w64_with_CMake.txt | 38 +++++++++++++++++++-------------
 1 file changed, 23 insertions(+), 15 deletions(-)

commit 653732bd6f06d8f465bf353bf6e1c16f1405b906
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-12-30 10:51:26 +0200

    xz man page: Describe the source file deletion in -z and -d options
    
    The DESCRIPTION section always explained it, and the OPTIONS section
    only described the differences to the default behavior. However, new
    users in a hurry may skip reading DESCRIPTION. The default behavior
    is a bit dangerous, thus it's good to repeat in --compress and
    --decompress docs that source file is removed after successful operation.
    
    Fixes: https://github.com/tukaani-project/xz/issues/150

 src/xz/xz.1 | 17 ++++++++++++++++-
 1 file changed, 16 insertions(+), 1 deletion(-)

commit bb79f79b278fd4fb06a0bcd5ab3445c468f9baaf
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-12-27 21:52:28 +0200

    Build: Set libtool -version-info so that it matches with CMake
    
    In the past, they haven't been in sync in development versions
    although they (of course) have been in stable releases.

 src/liblzma/Makefile.am | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit cf54f70e14c218faf5019ffa2fa769ed73772ee8
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-12-28 18:28:56 +0200

    CMake/macOS: Use GNU Libtool compatible shared library versioning
    
    Because this increases the Mach-O compatibility_version, this commit
    shouldn't cause any ABI compatibility trouble for existing CMake users
    on macOS. This is assuming that they won't later downgrade to an older
    liblzma version that was built with CMake before this commit.
    
    Meson allows customising the Mach-O versioning too. So the three
    build systems can be configured to be compatible.

 CMakeLists.txt | 51 ++++++++++++++++++++++++++++++++++++++++++++++++---
 1 file changed, 48 insertions(+), 3 deletions(-)

commit 94e17916689d38bc09bf35e602ed6f6276034b59
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-12-28 14:49:45 +0200

    CMake: Edit a comment

 CMakeLists.txt | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 6b50590725aeae8a2aed06faa3238cb9f8771c1b
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-12-28 20:39:49 +0200

    version.sh: Omit an unwanted dot from development versions
    
    It printed 5.7.0.alpha instead of 5.7.0alpha.
    
    Fixes: e7a42cda7c827e016619e8cab15e2faf5d4181ae

 build-aux/version.sh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit f7a248f56e94310a080051c4a709c08514fa48b1
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-12-27 16:25:07 +0200

    CMake: Remove a duplicate word from a comment

 CMakeLists.txt | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 8b7c55d148f4a9b3702207164e862437ddffad33
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-12-27 16:23:12 +0200

    INSTALL: Document CMAKE_DLL_NAME_WITH_SOVERSION

 INSTALL | 19 +++++++++++++++++++
 1 file changed, 19 insertions(+)

commit 260d5d36203955a7148ae1ab05d0931c942028d5
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-12-26 21:27:18 +0200

    xz: Fix comments

 src/xz/file_io.c | 4 ++--
 src/xz/file_io.h | 4 ++--
 2 files changed, 4 insertions(+), 4 deletions(-)

commit bf6da9a573a780cd1a7fb1728ef55d09e58dad11
Author: Dexter Castor Döpping <dexter.c.dopping@gmail.com>
Date:   2024-12-22 13:44:03 +0100

    CMake: Disable unity builds project-wide
    
    liblzma and xz can't be compiled as a unity/jumbo build because of
    redeclarations and type name reuse. The CMake documentation recommends
    setting UNITY_BUILD to false in this case.
    
    This is especially important if we're compiled as a subproject and the
    consumer wants to use CMAKE_UNITY_BUILD=ON for the rest of their code
    base.
    
    Closes: https://github.com/tukaani-project/xz/pull/158

 CMakeLists.txt | 6 ++++++
 1 file changed, 6 insertions(+)

commit f8c328eed1bf0a0168132025a52116b7735f894c
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-12-20 08:51:18 +0200

    Windows: Workaround a UTF-8 issue in Gettext's libintl_setlocale()
    
    See the comment. In this package, locale is set at program startup and
    not changed later, so the point (2) in the comment isn't a problem.
    
    Fixes: 46ee0061629fb075d61d83839e14dd193337af59

 src/common/tuklib_gettext.h | 51 +++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 51 insertions(+)

commit 03533906093529701ba91081907d8977991997de
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-12-20 06:50:36 +0200

    Revert "Windows: Use UTF-8 locale when active code page is UTF-8"
    
    This reverts commit 0d0b574cc45045d6150d397776340c068df59e2a.

 src/common/tuklib_gettext.h | 32 ++------------------------------
 1 file changed, 2 insertions(+), 30 deletions(-)

commit 4b319e05afef4eab2fbafb6223f25d128ec99fce
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-12-19 18:31:09 +0200

    xzdec: Use setlocale() instead of tuklib_gettext_setlocale()
    
    xzdec isn't translated and doesn't need libintl on Windows even
    when NLS is enabled, thus libintl_setlocale() cannot interfere
    with the locale settings. Thus, standard setlocale() works perfectly.
    
    In the commit 78868b6e, the explanation in the commit message is wrong.
    
    Fixes: 78868b6ed63fa4c89f73e3dfed27abfb8b0d46db

 src/xzdec/xzdec.c | 9 +++------
 1 file changed, 3 insertions(+), 6 deletions(-)

commit 34b80e282ea76ec793eaedaef58a36c3913dec78
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-12-19 19:36:15 +0200

    Windows: Revert the setlocale(LC_ALL, ".UTF8") documentation
    
    Only leave the FindFileFirstA() notes from 20dfca81, reverting
    the incorrect setlocale() notes. On Windows, Gettext's <libintl.h>
    overrides setlocale() with libintl_setlocale() wrapper. I hadn't
    noticed this, and thus my conclusions were wrong.
    
    Fixes: 20dfca8171dad4c64785ac61d5b68972c444877b

 src/common/w32_application.manifest.comments.txt | 21 +--------------------
 1 file changed, 1 insertion(+), 20 deletions(-)

commit 5794cda064ce980450eaa5a4e2c71bd317168ce4
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-12-18 17:49:05 +0200

    tuklib_mbstr_wrap: Silence a warning from Clang
    
    Fixes: ca529c3f41a4a19a59e2e252e6dd9255f130c634

 src/common/tuklib_mbstr_wrap.c | 9 +++++++++
 1 file changed, 9 insertions(+)

commit 16c9796ef970ae349c54fef9a346e394d7cc4c75
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-12-18 14:00:09 +0200

    Update THANKS

 THANKS | 2 ++
 1 file changed, 2 insertions(+)

commit 3b5c8a1fcab385eed9cc95684223fddd7cf5a053
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-12-18 14:00:09 +0200

    Update TODO
    
    Fixes: 5f6dddc6c911df02ba660564e78e6de80947c947

 TODO | 3 ---
 1 file changed, 3 deletions(-)

commit 22a35e64ce3d331b668f15f858a7bb3da3acc78e
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-12-18 14:00:09 +0200

    lzmainfo: Use tuklib_mbstr_nonprint

 CMakeLists.txt           |  3 +++
 src/lzmainfo/Makefile.am |  1 +
 src/lzmainfo/lzmainfo.c  | 16 ++++++++++------
 3 files changed, 14 insertions(+), 6 deletions(-)

commit 03111595ee713e0f94fb4f4a19a15594d5149347
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-12-18 14:00:09 +0200

    xzdec: Use tuklib_mbstr_nonprint

 CMakeLists.txt        |  3 +++
 src/xzdec/Makefile.am |  2 ++
 src/xzdec/xzdec.c     | 15 +++++++++++----
 3 files changed, 16 insertions(+), 4 deletions(-)

commit d22f96921fd2f94d842f3cc2e5f729cb3cca5122
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-12-18 14:00:09 +0200

    xz: Use tuklib_mbstr_nonprint
    
    Call tuklib_mask_nonprint() on filenames and also on a few other
    strings from the command line too.
    
    The filename printed by "xz --robot --list" (in list.c) is also masked.
    It's good to get rid of tabs and newlines which would desync the output
    but masking other chars wouldn't be strictly necessary. It might matter
    with sensible filenames if LC_CTYPE is "C" (when iswprint() might reject
    non-ASCII chars) and a script wants to read a filename from xz's output.
    Hopefully it's an unusual enough corner case to not be a real problem.

 CMakeLists.txt     |  2 ++
 src/xz/Makefile.am |  1 +
 src/xz/coder.c     | 19 ++++++++-----
 src/xz/file_io.c   | 81 ++++++++++++++++++++++++++++++++++--------------------
 src/xz/list.c      | 32 +++++++++++++--------
 src/xz/main.c      | 10 +++++--
 src/xz/message.c   |  8 ++++--
 src/xz/options.c   | 10 ++++---
 src/xz/private.h   |  1 +
 src/xz/suffix.c    | 12 ++++----
 10 files changed, 113 insertions(+), 63 deletions(-)

commit 40e573305535960574404d2eae848b248c95ea7e
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-12-18 14:00:09 +0200

    Add tuklib_mbstr_nonprint to mask non-printable characters
    
    Malicious filenames or other untrusted strings may affect the state of
    the terminal when such strings are printed as part of (error) messages.
    Add functions that mask such characters.
    
    It's not enough to handle only single-byte control characters.
    In multibyte locales, some control characters are multibyte too, for
    example, terminals interpret C1 control characters (U+0080 to U+009F)
    that are two bytes as UTF-8.
    
    Instead of checking for control characters with iswcntrl(), this
    uses iswprint() to detect printable characters. This is much stricter.
    On Windows it's actually too strict as it rejects some characters that
    definitely are printable.
    
    Gnulib's quotearg would do a lot more but I hope this simpler method
    is good enough here.
    
    Thanks to Ryan Colyer for the discussion about the problems of
    the earlier single-byte-only method.
    
    Thanks to Christian Weisgerber for reporting a bug in an earlier
    version of this code.
    
    Thanks to Jeroen Roovers for a typo fix.
    
    Closes: https://github.com/tukaani-project/xz/pull/118

 src/Makefile.am                    |   2 +
 src/common/tuklib_mbstr_nonprint.c | 151 +++++++++++++++++++++++++++++++++++++
 src/common/tuklib_mbstr_nonprint.h |  69 +++++++++++++++++
 3 files changed, 222 insertions(+)

commit 36190c8c4bb13d1eab84a30f3650a5ec5ff0e402
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-12-18 11:33:09 +0200

    Translations: Add preliminary Georgian translation
    
    Most of the auto-wrapped strings are translated already. A few
    strings have changed since this was created though. This file
    isn't in the Translation Project *yet* because these strings
    are still very new.
    
    Closes: https://github.com/tukaani-project/xz/pull/145

 po/LINGUAS |    1 +
 po/ka.po   | 1186 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 1187 insertions(+)

commit 4a0c4f92b820b84ace625a95305a9d56cb662f4e
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-10-30 20:50:20 +0200

    xz: Make one string simpler for translators
    
    Leading spaces in the string can get miscounted by translators.

 src/xz/list.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 3fcf547e926f6c0414b23459f7b43164f7e8c378
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-12-17 10:26:10 +0200

    lzmainfo: Sync the translatable strings with xz

 src/lzmainfo/lzmainfo.c | 20 ++++++++++++--------
 1 file changed, 12 insertions(+), 8 deletions(-)

commit 3e9177fd206d20d6d8acc7d203c25a9ae0549229
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-12-17 10:26:10 +0200

    xz: Use automatic word wrapping for help texts
    
    --long-help is now one line longer because --lzma1 is now on its
    own line.

 CMakeLists.txt     |   2 +
 src/xz/Makefile.am |   3 +-
 src/xz/message.c   | 482 ++++++++++++++++++++++++++++++++++-------------------
 3 files changed, 313 insertions(+), 174 deletions(-)

commit a0eecc9eb23ac583ccf442de3f5c106d4b09482d
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-12-16 18:46:45 +0200

    po/Makevars: Add --keyword=W_:... to XGETTEXT_OPTIONS
    
    The text was copied from tuklib_gettext.h.
    
    Also rearrange the --keyword options to be last on the line.

 po/Makevars | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit ca529c3f41a4a19a59e2e252e6dd9255f130c634
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-12-16 18:43:52 +0200

    Add tuklib_mbstr_wrap for automatic word wrapping
    
    Automatic word wrapping makes translators' work easier and reduces
    errors like misaligned columns or overlong lines. Right-to-left
    languages and languages that don't use spaces between words will
    still need extra effort. (xz hasn't been translated to any RTL
    language so far.)

 cmake/tuklib_mbstr.cmake       |   4 +
 m4/tuklib_mbstr.m4             |   2 +-
 src/Makefile.am                |   2 +
 src/common/tuklib_gettext.h    |  11 ++
 src/common/tuklib_mbstr_wrap.c | 285 +++++++++++++++++++++++++++++++++++++++++
 src/common/tuklib_mbstr_wrap.h | 203 +++++++++++++++++++++++++++++
 6 files changed, 506 insertions(+), 1 deletion(-)

commit 314b83cebad0244a0015a8abc6d8d086b581c215
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-12-17 17:57:18 +0200

    Build: Sort filenames to ASCII order in Makefile.am

 src/Makefile.am | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit df399c52554dfdf60259ca2cce97adbcfff39dc0
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-10-21 18:51:24 +0300

    tuklib_mbstr_width: Add tuklib_mbstr_width_mem()
    
    It's a new function split from tuklib_mbstr_width().
    It's useful with partial strings that aren't terminated with \0.

 src/common/tuklib_mbstr.h       | 17 +++++++++++++++++
 src/common/tuklib_mbstr_width.c |  8 ++++++++
 2 files changed, 25 insertions(+)

commit 51081efae4c52c226e96da95313916eba99f885f
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-12-16 20:08:27 +0200

    tuklib_mbstr_width: Update a comment about shift states

 src/common/tuklib_mbstr_width.c | 11 ++++++++---
 1 file changed, 8 insertions(+), 3 deletions(-)

commit 7ff1b0ac53866877bdfd79acf5fee0269058c58b
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-10-21 18:47:56 +0300

    tuklib_mbstr_width: Don't mention shift states in the API docs
    
    It is assumed that this code won't be used with charsets that use
    locking shift states.

 src/common/tuklib_mbstr.h | 8 ++------
 1 file changed, 2 insertions(+), 6 deletions(-)

commit 3c16105936320e4095dbe84fa9a33a4a6d46a597
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-10-21 18:41:41 +0300

    tuklib_mbstr_width: Use stricter return value checking
    
    This should make no difference in practice (at least if mbrtowc()
    isn't broken).

 src/common/tuklib_mbstr_width.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit b797c44c42ea54fe1c52722a2fca0c9618575598
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-12-16 20:06:07 +0200

    tuklib_mbstr_width: Change the behavior when wcwidth() is not available
    
    If wcwidth() isn't available (Windows), previously it was assumed
    that one byte == one column in the terminal. Now it is assumed that
    one multibyte character == one column. This works better with UTF-8.
    Languages that only use single-width characters without any combining
    characters should work correctly with this.
    
    In xz, none of po/*.po contain combining characters and only ko.po,
    zh_CN.po, and zh_TW.po contain fullwidth characters. Thus, "only"
    those three translations in xz are broken on Windows with the
    UTF-8 code page. Broken means that column headings in xz -lvv and
    (only in the master branch) strings in --long-help are misaligned,
    so it's not a huge problem. I don't know if those three languages
    displayed perfectly before the UTF-8 change because I hadn't tested
    translations with native Windows builds before.
    
    Fixes: 46ee0061629fb075d61d83839e14dd193337af59

 src/common/tuklib_mbstr_width.c | 13 +++++++++++--
 1 file changed, 11 insertions(+), 2 deletions(-)

commit 78868b6ed63fa4c89f73e3dfed27abfb8b0d46db
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-12-18 14:23:13 +0200

    xzdec: Use setlocale() via tuklib_gettext_setlocale()
    
    xzdec isn't translated and didn't have locale-specific behavior
    in the past. On Windows with UTF-8 in the application manifest,
    setting the locale makes a difference though:
    
      - Without any setlocale() call, non-ASCII filenames don't display
        properly in Command Prompt unless one first uses "chcp 65001"
        to set the console code page to UTF-8.
    
      - setlocale(LC_ALL, "") is enough to make non-ASCII filenames
        print correctly in Command Prompt without using "chcp 65001",
        assuming that the non-UTF-8 code page (like 850) supports
        those non-ASCII characters.
    
      - setlocale(LC_ALL, ".UTF8") is even better because then mbrtowc() and
        such functions use an UTF-8 locale instead of a legacy code page.
        The tuklib_gettext_setlocale() macro takes care of this (without
        enabling any translations).
    
    Fixes: 46ee0061629fb075d61d83839e14dd193337af59

 src/xzdec/xzdec.c | 12 ++++++++++++
 1 file changed, 12 insertions(+)

commit 0d0b574cc45045d6150d397776340c068df59e2a
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-12-17 14:59:37 +0200

    Windows: Use UTF-8 locale when active code page is UTF-8
    
    XZ Utils 5.6.3 set the active code page to UTF-8 to fix CVE-2024-47611.
    This wasn't paired with UCRT-specific setlocale(LC_ALL, ".UTF8"), thus
    non-ASCII characters from translations became mojibake.
    
    Fixes: 46ee0061629fb075d61d83839e14dd193337af59

 src/common/tuklib_gettext.h | 32 ++++++++++++++++++++++++++++++--
 1 file changed, 30 insertions(+), 2 deletions(-)

commit 20dfca8171dad4c64785ac61d5b68972c444877b
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-12-17 15:01:29 +0200

    Windows: Document the need for setlocale(LC_ALL, ".UTF8")
    
    Also warn about unpaired surrogates and (somewhat UTF-8-specific)
    MAX_PATH issue in FindFirstFileA().
    
    Fixes: 46ee0061629fb075d61d83839e14dd193337af59

 src/common/w32_application.manifest.comments.txt | 28 +++++++++++++++++++++++-
 1 file changed, 27 insertions(+), 1 deletion(-)

commit 4e936f234056e5831013ed922145b666b04bb1e3
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-12-18 14:12:22 +0200

    xzdec: Call tuklib_progname_init() early enough
    
    If the early pledge() call on OpenBSD fails, it calls my_errorf()
    which requires the "progname" variable.
    
    Fixes: d74fb5f060b76db709b50f5fd37490394e52f975

 src/xzdec/xzdec.c | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 61feaf681bd793dc5c919732b44bca7dcf2ed1b8
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-12-15 19:08:32 +0200

    CMake: Bump maximum policy version to 3.31
    
    With CMake 3.31, there were a few warnings from
    CMP0177 "install() DESTINATION paths are normalized".
    These occurred because the install(FILES) command in
    my_install_man_lang() is called with a DESTINATION path
    that contains two consecutive slashes, for example,
    "share/man//man1". Such a path is for the English man pages.
    With translated man pages, the language code goes between
    the slashes. The warning was probably triggered because the
    extra slash gets removed by the normalization.

 CMakeLists.txt | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit b0bb84dd7bbdcc85243386a0051c7b2cb5fc6a18
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-12-15 18:35:27 +0200

    Update THANKS

 THANKS | 1 +
 1 file changed, 1 insertion(+)

commit bee0c044d30a6ad3b3d94901c27e7519f6f46e27
Author: Dexter Castor Döpping <dexter.c.dopping@gmail.com>
Date:   2024-12-08 18:24:29 +0100

    liblzma: Fix incorrect macro name in a comment
    
    Fixes: 33b8a24b6646a9dbfd8358405aec466b13078559
    Closes: https://github.com/tukaani-project/xz/pull/155

 src/liblzma/api/lzma/lzma12.h | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 2cfa1ad0a9eb62b1847cf13f9aee290158978a3a
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-12-17 10:36:43 +0200

    license-check.sh: Add an exception for doc/SHA256SUMS
    
    Fixes: 36b531022f24a2ab57a2dfb9e5052f1c176e9d9a

 build-aux/license-check.sh | 1 +
 1 file changed, 1 insertion(+)

commit 36b531022f24a2ab57a2dfb9e5052f1c176e9d9a
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-12-01 21:38:17 +0200

    doc/SHA256SUMS: Add the list of SHA-256 hashes of release files
    
    The release files are signed but verifying the signatures cannot
    catch certain types of attacks:
    
    1. A malicious maintainer could make more than one variant of
       a package. One could be for general distribution. Another
       with malicious content could be targeted to specific users,
       for example, distributing the malicious version on a mirror
       controlled by the attacker.
    
    2. If the signing key of an honest maintainer was compromised
       without being detected, a similar situation as described
       above could occur.
    
    SHA256SUMS could be put on the project website but having it in
    the Git repository makes it obvious that old lines aren't modified
    when the file is updated.
    
    Hashes of uncompressed files are included too. This way tarballs
    can be recompressed and the hashes can still be verified.

 .gitattributes |   1 +
 doc/SHA256SUMS | 218 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 219 insertions(+)

commit fe9e66993fdbcc2981c7361b9b034a451eb0fc42
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-11-30 12:05:59 +0200

    Docs: Remove .github/SECURITY.md
    
    One of the reasons to have this file in the xz repository was to
    show vulnerability reporting info in the Security section on GitHub.
    On 2024-11-25, I added SECURITY.md to the tukaani-project organization
    on GitHub:
    
        https://github.com/tukaani-project/.github/blob/main/SECURITY.md
    
    GitHub shows that file in all projects in the organization unless
    overridden by a project-specific SECURITY.md. Thus, removing
    the file from the xz repo makes GitHub show the organization-wide
    text instead.
    
    Maintaining a single copy for the whole GitHub organization makes
    things simpler. It's also nicer to have fewer GitHub-specific files
    in the xz repo. Information how to report bugs (including security
    issues) is available in README and on the home page too.
    
    The OpenSSF Scorecard tool didn't find .github/SECURITY.md from the
    xz repository. There was a suggestion to move the file to the top-level
    directory where Scorecard should find it. However, Scorecard does find
    the organization-wide SECURITY.md. Thus, the file isn't needed in the
    xz repository to score points in the Scorecard game:
    
        https://scorecard.dev/viewer/?uri=github.com/tukaani-project/xz
    
    Closes: https://github.com/tukaani-project/xz/issues/148
    Closes: https://github.com/tukaani-project/xz/pull/149

 .github/SECURITY.md | 14 --------------
 1 file changed, 14 deletions(-)

commit b36177273602ebc83e9cc58517f63a7b6af33f70
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-11-30 10:27:14 +0200

    Translations: Update the Chinese (traditional) translation

 po/zh_TW.po | 201 +++++++++++++++++++++++++-----------------------------------
 1 file changed, 84 insertions(+), 117 deletions(-)

commit c15115f7ede492f20c91b08ba485f9426f60233f
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-10-30 19:54:34 +0200

    liblzma: Optimize the loop conditions in BCJ filters
    
    Compilers cannot optimize the addition "i + 4" away since theoretically
    it could overflow.

 src/liblzma/simple/arm.c      | 4 +++-
 src/liblzma/simple/arm64.c    | 4 +++-
 src/liblzma/simple/armthumb.c | 7 ++++++-
 src/liblzma/simple/ia64.c     | 4 +++-
 src/liblzma/simple/powerpc.c  | 4 +++-
 src/liblzma/simple/sparc.c    | 5 +++--
 6 files changed, 21 insertions(+), 7 deletions(-)

commit 9f69e71e78621fd056f5eaaad7cdcd9279310fb5
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-11-25 16:26:54 +0200

    Update THANKS

 THANKS | 1 +
 1 file changed, 1 insertion(+)

commit 48ff3f06521ca326996ab9a04d1b342098960427
Author: Mark Wielaard <mark@klomp.org>
Date:   2024-11-25 12:28:44 +0200

    xz: Landlock: Fix a file descriptor leak

 src/xz/sandbox.c | 1 +
 1 file changed, 1 insertion(+)

commit dbca3d078ec581600600abebbb18769d3d713914
Author: Sam James <sam@gentoo.org>
Date:   2024-10-02 03:04:03 +0100

    CI: update FreeBSD, NetBSD, OpenBSD, Solaris actions
    
    Checked the changes and they're all innocuous. This should hopefully
    fix the "externally managed" pip error in these jobs that started
    recently.

 .github/workflows/freebsd.yml | 2 +-
 .github/workflows/netbsd.yml  | 2 +-
 .github/workflows/openbsd.yml | 2 +-
 .github/workflows/solaris.yml | 2 +-
 4 files changed, 4 insertions(+), 4 deletions(-)

commit a94b85bea3f04d8c1f4e2e6f648a9a15bc6ce58f
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-10-01 12:17:39 +0300

    Add NEWS for 5.6.3

 NEWS | 125 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 125 insertions(+)

commit be4bf94446b6286a5dffdde85fc1d21448f4edff
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-10-01 14:49:41 +0300

    cmake/tuklib_large_file_support.cmake: Add a missing include
    
    v5.2 didn't build with CMake. Other branches had
    include(CMakePushCheckState) in top-level CMakeLists.txt
    which made the build work.
    
    Fixes: 597f49b61475438a43a417236989b2acc968a686

 cmake/tuklib_large_file_support.cmake | 1 +
 1 file changed, 1 insertion(+)

commit 1ebbe915d4e0d877154261b5f8103719a6722975
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-10-01 12:10:23 +0300

    Update THANKS

 THANKS | 2 ++
 1 file changed, 2 insertions(+)

commit 74702ee00ecfd080d8ab11118cd25dbe6c437ec0
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-10-01 12:10:23 +0300

    Tests/Windows: Add the application manifest to the test programs
    
    This ensures that the test programs get executed the same way as
    the binaries that are installed.

 CMakeLists.txt        | 14 ++++++++++----
 tests/Makefile.am     | 10 ++++++++++
 tests/tests.cmake     | 33 ++++++++++++++++++++++++++++++++-
 tests/tests_w32res.rc | 18 ++++++++++++++++++
 4 files changed, 70 insertions(+), 5 deletions(-)

commit 7ddf2273e0e4654582ee65db19d44431bfdb5791
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-10-01 12:10:23 +0300

    license-check.sh: Add an exception for w32_application.manifest
    
    The file gets embedded as is into executables, thus it cannot
    hold a license identifier.

 build-aux/license-check.sh | 1 +
 1 file changed, 1 insertion(+)

commit 46ee0061629fb075d61d83839e14dd193337af59
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-10-01 12:10:23 +0300

    Windows: Embed an application manifest in the EXE files
    
    IMPORTANT: This includes a security fix to command line tool
               argument handling.
    
    Some toolchains embed an application manifest by default to declare
    UAC-compliance. Some also declare compatibility with Vista/8/8.1/10/11
    to let the app access features newer than those of Vista.
    
    We want all the above but also two more things:
    
      - Declare that the app is long path aware to support paths longer
        than 259 characters (this may also require a registry change).
    
      - Force the code page to UTF-8. This allows the command line tools
        to access files whose names contain characters that don't exist
        in the current legacy code page (except unpaired surrogates).
        The UTF-8 code page also fixes security issues in command line
        argument handling which can be exploited with malicious filenames.
        See the new file w32_application.manifest.comments.txt.
    
    Thanks to Orange Tsai and splitline from DEVCORE Research Team
    for discovering this issue.
    
    Thanks to Vijay Sarvepalli for reporting the issue to me.
    
    Thanks to Kelvin Lee for testing with MSVC and helping with
    the required build system fixes.

 CMakeLists.txt                                   |  18 +++
 src/Makefile.am                                  |   4 +-
 src/common/common_w32res.rc                      |   5 +
 src/common/w32_application.manifest              |  28 ++++
 src/common/w32_application.manifest.comments.txt | 178 +++++++++++++++++++++++
 5 files changed, 232 insertions(+), 1 deletion(-)

commit dad153091552b52a41b95ec4981c6951f1cae487
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-09-29 14:46:52 +0300

    Windows: Set DLL name accurately in StringFileInfo on Cygwin and MSYS2
    
    Now the information in the "Details" tab in the file properties
    dialog matches the naming convention of Cygwin and MSYS2. This
    is only a cosmetic change.

 src/liblzma/liblzma_w32res.rc | 10 +++++++++-
 1 file changed, 9 insertions(+), 1 deletion(-)

commit 8940ecb96fe9f0f2a9cfb8b66fe9ed31ffbea904
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-09-25 15:47:55 +0300

    common_w32res.rc: White space edits
    
    LANGUAGE and VS_VERSION_INFO begin new statements so put an empty line
    between them.

 src/common/common_w32res.rc | 15 ++++++++-------
 1 file changed, 8 insertions(+), 7 deletions(-)

commit c3b9dad07d3fd9319f88386b7095019bcea45ce1
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-09-28 20:09:50 +0300

    CMake: Add the resource files to the Cygwin and MSYS2 builds
    
    Autotools-based build has always done this so this is for consistency.
    
    However, the CMake build won't create the DEF file when building
    for Cygwin or MSYS2 because in that context it should be useless.
    (If Cygwin or MSYS2 is used to host building of normal Windows
    binaries then the DEF file is still created.)

 CMakeLists.txt | 16 ++++++++++------
 1 file changed, 10 insertions(+), 6 deletions(-)

commit da4f275bd1c18b897e5c2dd0043546de3accce0a
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-09-28 15:19:14 +0300

    CMake: Fix Windows resource file dependencies
    
    If common_w32res.rc is modified, the resource files need to be rebuilt.
    In contrast, the liblzma*.map files truly are link dependencies.

 CMakeLists.txt | 17 +++++++++--------
 1 file changed, 9 insertions(+), 8 deletions(-)

commit 1c673c0aac7f7dee8dda2c1140351c8417a71e47
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-09-29 01:20:03 +0300

    CMake: Checking for CYGWIN covers MSYS2 too
    
    On MSYS2, both CYGWIN and MSYS are set.

 CMakeLists.txt | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 6aaa0173b839e28429d43a8b62d257ad2f3b4521
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-09-28 09:37:30 +0300

    Translations: Add the SPDX license identifier to pt_BR.po

 po/pt_BR.po | 2 ++
 1 file changed, 2 insertions(+)

commit dc7b9f24b737e4e55bcbbdde6754883f991c2cfb
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-09-25 16:41:37 +0300

    Windows/CMake: Use the correct resource file for lzmadec.exe
    
    CMakeLists.txt was using xzdec_w32res.rc for both xzdec and lzmadec.
    
    Fixes: 998d0b29536094a89cf385a3b894e157db1ccefe

 CMakeLists.txt | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit b834ae5f80911a3819d6cdb484f61b257174c544
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-09-25 21:29:59 +0300

    Translations: Update the Brazilian Portuguese translation

 po/pt_BR.po | 144 ++++++++++++++++++++++--------------------------------------
 1 file changed, 53 insertions(+), 91 deletions(-)

commit eceb023d4c129fd63ee881a2d8696eaf52ad1532
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-09-17 01:21:15 +0300

    Update THANKS

 THANKS | 1 +
 1 file changed, 1 insertion(+)

commit 76cfd0a9bb33ae8e534b1f73f6359dc825589f2f
Author: Tobias Stoeckmann <tobias@stoeckmann.org>
Date:   2024-09-16 23:19:46 +0200

    lzmainfo: Avoid integer overflow
    
    The MB output can overflow with huge numbers. Most likely these are
    invalid .lzma files anyway, but let's avoid garbage output.
    
    lzmadec was adapted from LZMA Utils. The original code with this bug
    was written in 2005, over 19 years ago.
    
    Co-authored-by: Lasse Collin <lasse.collin@tukaani.org>
    Closes: https://github.com/tukaani-project/xz/pull/144

 src/lzmainfo/lzmainfo.c | 5 ++---
 1 file changed, 2 insertions(+), 3 deletions(-)

commit 78355aebb7fb654302e5e33692ba109909dacaff
Author: Tobias Stoeckmann <tobias@stoeckmann.org>
Date:   2024-09-16 22:04:40 +0200

    xzdec: Remove unused short option -M
    
    "xzdec -M123" exited with exit status 1 without printing
    any messages. The "M:" entry should have been removed when
    the memory usage limiter support was removed from xzdec.
    
    Fixes: 792331bdee706aa852a78b171040ebf814c6f3ae
    Closes: https://github.com/tukaani-project/xz/pull/143
    [ Lasse: Commit message edits ]

 src/xzdec/xzdec.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit e5758db7bd75587a2499e0771907521a4aa86908
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-09-10 13:54:47 +0300

    Update THANKS

 THANKS | 1 +
 1 file changed, 1 insertion(+)

commit 80ffa38f56657257ed4d90d76f6bd2f2bcb8163c
Author: Firas Khalil Khana <firasuke@gmail.com>
Date:   2024-09-10 12:30:32 +0300

    Build: Fix a typo in autogen.sh
    
    Fixes: e9be74f5b129fe8a5388d588e68b1b7f5168a310
    Closes: https://github.com/tukaani-project/xz/pull/141

 autogen.sh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 68c54e45d042add64a4cb44bfc87ca74d29b87e2
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-09-02 20:08:40 +0300

    Translations: Update Chinese (simplified) translation
    
    Differences to the zh_CN.po file from the Translation Project:
    
      - Two uses of \v were fixed.
    
      - Missing "OPTS" translation in --riscv[=OPTS] was copied from
        previous lines.
    
      - "make update-po" was run to remove line numbers from comments.

 po/zh_CN.po | 102 ++++++++++++++++++++++++------------------------------------
 1 file changed, 40 insertions(+), 62 deletions(-)

commit 2230692aa1bcebb586100183831e3daf1714d60a
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-09-02 19:40:50 +0300

    Translations: Update the Catalan translation
    
    Differences to the ca.po file from the Translation Project:
    
      - An overlong line translating --filters-help was wrapped.
    
      - "make update-po" was used to remove line numbers from the comments
        to match the changes in fccebe2b4fd513488fc920e4dac32562ed3c7637
        and 093490b58271e9424ce38a7b1b38bcf61b9c86c6. xz.pot in the TP
        is older than these commits.

 po/ca.po | 171 ++++++++++++++++++++++++++-------------------------------------
 1 file changed, 69 insertions(+), 102 deletions(-)

commit 3e7723ce26f74c71919984a6180504b4548cbb7e
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-08-22 14:06:16 +0300

    Update THANKS

 THANKS | 1 +
 1 file changed, 1 insertion(+)

commit d3e0e679b2b8b428598bb8ba56a17715190814db
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-08-22 14:06:16 +0300

    CMake: Don't install lzmadec.1 symlinks if XZ_TOOL_LZMADEC=OFF
    
    Thanks-to: 榆柳松 (ZhengSen Wang) <wzhengsen@gmail.com>
    Fixes: fb50c6ba1d4c9405e5b12b5988b01a3002638c5d
    Closes: https://github.com/tukaani-project/xz/pull/134

 CMakeLists.txt | 12 ++++++++++--
 1 file changed, 10 insertions(+), 2 deletions(-)

commit acdf21033abe347d9a279e9fe757f90ed16c1dbb
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-08-22 14:06:16 +0300

    CMake: Fix the build when XZ_TOOL_LZMADEC=OFF
    
    Co-developed-by: 榆柳松 (ZhengSen Wang) <wzhengsen@gmail.com>
    Fixes: fb50c6ba1d4c9405e5b12b5988b01a3002638c5d
    Fixes: https://github.com/tukaani-project/xz/pull/134

 CMakeLists.txt | 6 ++++--
 1 file changed, 4 insertions(+), 2 deletions(-)

commit 5e375987509fab484b7bef0b90be92f241c58c91
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-08-22 11:01:07 +0300

    Update THANKS

 THANKS | 1 +
 1 file changed, 1 insertion(+)

commit 6cd7c8607843c337edfe2c472aa316602a393754
Author: Yifeng Li <tomli@tomli.me>
Date:   2024-08-22 02:18:49 +0000

    liblzma: Fix x86-64 movzw compatibility in range_decoder.h
    
    Support for instruction "movzw" without suffix in "GNU as" was
    added in commit [1] and stabilized in binutils 2.27, released
    in August 2016. Earlier systems don't accept this instruction
    without a suffix, making range_decoder.h's inline assembly
    unable to build on old systems such as Ubuntu 16.04, creating
    error messages like:
    
        lzma_decoder.c: Assembler messages:
        lzma_decoder.c:371: Error: no such instruction: `movzw 2(%r11),%esi'
        lzma_decoder.c:373: Error: no such instruction: `movzw 4(%r11),%edi'
        lzma_decoder.c:388: Error: no such instruction: `movzw 6(%r11),%edx'
        lzma_decoder.c:398: Error: no such instruction: `movzw (%r11,%r14,4),%esi'
    
    Change "movzw" to "movzwl" for compatibility.
    
    [1] https://sourceware.org/git/?p=binutils-gdb.git;a=commit;h=c07315e0c610e0e3317b4c02266f81793df253d2
    
    Suggested-by: Lasse Collin <lasse.collin@tukaani.org>
    Tested-by: Yifeng Li <tomli@tomli.me>
    Signed-off-by: Yifeng Li <tomli@tomli.me>
    Fixes: 3182a330c1512cc1f5c87b5c5a272578e60a5158
    Fixes: https://github.com/tukaani-project/xz/issues/121
    Closes: https://github.com/tukaani-project/xz/pull/136

 src/liblzma/rangecoder/range_decoder.h | 24 ++++++++++++------------
 1 file changed, 12 insertions(+), 12 deletions(-)

commit bf901dee5d4c46609645e50311c0cb2dfdcf9738
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-07-19 20:02:43 +0300

    Build: Comment that elf_aux_info(3) will be available on OpenBSD >= 7.6

 CMakeLists.txt |  2 +-
 configure.ac   | 17 +++++++++++------
 2 files changed, 12 insertions(+), 7 deletions(-)

commit f7103c2c2a8fa51d1f308ba7387beeff20a0d4dd
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-07-19 19:42:26 +0300

    Revert "liblzma: Add ARM64 CRC32 instruction support detection on OpenBSD"
    
    This reverts commit dc03f6290f5b9bd3d50c7e12e58dee870889d599.
    
    OpenBSD 7.6 will support elf_aux_info(3), and the detection code used
    on FreeBSD will work on OpenBSD 7.6 too. Keep things simpler and drop
    the OpenBSD-specific sysctl() method.
    
    Thanks to Christian Weisgerber.

 CMakeLists.txt                  |  6 ------
 configure.ac                    |  9 ---------
 src/liblzma/check/crc32_arm64.h | 15 ---------------
 src/liblzma/check/crc_common.h  |  1 -
 4 files changed, 31 deletions(-)

commit 7c292dd0bf23cefcdf4b1509f3666322e08a7ede
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-07-13 22:10:37 +0300

    liblzma: Tweak a comment

 src/liblzma/simple/arm64.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 6408edac5529d6ec0abf52794074f229c8362303
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-07-11 22:17:56 +0300

    CMake: Bump maximum policy version to 3.30

 CMakeLists.txt | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 9231c39ffb518196d6664a86e5325e744621a21b
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-07-06 15:13:19 +0300

    CMake: Require CMake 3.20 or later
    
    This allows a few cleanups.

 CMakeLists.txt | 78 ++++++++++++++++++++--------------------------------------
 1 file changed, 27 insertions(+), 51 deletions(-)

commit 028185dd4889e3d6235ff13560160ebca6985021
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-07-09 14:27:51 +0300

    Update THANKS

 THANKS | 1 +
 1 file changed, 1 insertion(+)

commit baecfa142644eb5f5c6dd6f8e2f531c362fa3747
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-07-06 14:04:48 +0300

    xz: Remove the TODO comment about --recursive
    
    It won't be implemented. find + xargs is more flexible, for example,
    it allows compressing small files in parallel. An example for that
    has been included in the xz man page since 2010.

 src/xz/args.c | 1 -
 1 file changed, 1 deletion(-)

commit f691d58fae82bd815c5f86ffad10fe9b6b59dad8
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-07-06 14:04:16 +0300

    Document --disable-loongarch-crc32 in INSTALL

 INSTALL | 8 ++++++++
 1 file changed, 8 insertions(+)

commit b3e53122f42796aaebd767bab920cf7bedf69966
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-07-03 20:45:48 +0300

    CMake: Link xz against Threads::Threads if using pthreads
    
    The liblzma target was recently changed to link against Threads::Threads
    with the PRIVATE keyword. I had forgotten that xz itself depends on
    pthreads too due to pthread_sigmask(). Thus, the build broke when
    building shared liblzma and pthread_sigmask() wasn't in libc.
    
    Thanks to Peter Seiderer for the bug report.
    
    Fixes: ac05f1b0d7cda1e7ae79775a8dfecc54601d7f1c
    Fixes: https://github.com/tukaani-project/xz/issues/129#issuecomment-2204522994

 CMakeLists.txt | 13 +++++++++++++
 1 file changed, 13 insertions(+)

commit 5742ec1fc7f2cf1c82cfe3477bb90594a4658374
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-07-02 22:49:33 +0300

    Update THANKS

 THANKS | 1 +
 1 file changed, 1 insertion(+)

commit 2d13d10357ecad243d7e4ff1de0e6b437c38a47a
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-07-02 20:23:35 +0300

    CMake: Improve NLS error messages

 CMakeLists.txt | 11 +++++++----
 1 file changed, 7 insertions(+), 4 deletions(-)

commit 628d8d2c4fdf9e6a91c7bba7a743f400a94c2909
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-07-02 20:19:47 +0300

    CMake: Update the comment at the top of CMakeLists.txt
    
    While po/*.gmo files won't be used from the release tarball,
    the generated translated man pages will be used still. Those
    are text files and po4a has slightly more dependencies than
    gettext tools so installing po4a might be a bit more challenging
    in some situations.

 CMakeLists.txt | 17 +++++++----------
 1 file changed, 7 insertions(+), 10 deletions(-)

commit b4b23c94fd4429abc663ced28d5cdc9cf7eb7507
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-07-02 20:12:40 +0300

    CMake: Drop support for pre-generated po/*.gmo files
    
    When a release tarball is created using Autotools, the tarball includes
    po/*.gmo files which are binary files generated from po/*.po. Other
    tarball creation methods don't and won't create the .gmo files.
    
    It feels clearer if CMake will never install pre-generated binary files
    from the source package. If people are able to install CMake, they
    likely are able to install gettext tools as well (assuming they want
    translations).

 CMakeLists.txt | 66 +++++++++++++++++++---------------------------------------
 1 file changed, 21 insertions(+), 45 deletions(-)

commit fb99f8e8c50171b898cb79fe1dc703d5f91e4f0a
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-07-02 19:14:50 +0300

    CMake: Make XZ_NLS handling more robust
    
    If a user set XZ_NLS=ON but find_package(Intl) failed or CMake version
    wasn't at least 3.20, the configuration would fail in a cryptic way.
    
    If XZ_NLS is enabled, require that CMake is new enough and that either
    gettext tools or pre-generated .gmo files are available. Otherwise fail
    the configuration. Previously missing gettext tools and .gmo files would
    only result in a warning.
    
    Missing man page translations are still only a warning.
    
    Thanks to Peter Seiderer for the bug report.
    
    Fixes: https://github.com/tukaani-project/xz/issues/129
    Closes: https://github.com/tukaani-project/xz/pull/130

 CMakeLists.txt | 82 ++++++++++++++++++++++++++++++++--------------------------
 1 file changed, 46 insertions(+), 36 deletions(-)

commit ec6157570ea8a8e38158894e530d35416ff6a0f8
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-07-02 19:39:05 +0300

    CI: Add gettext as a dependency to CMake builds

 .github/workflows/ci.yml | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 24f0f7e399de03bb2ff675d97b723d14f17ed6ac
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-07-02 18:43:56 +0300

    CMake: Fix ENABLE_NLS comment too
    
    Fixes: 29f77c7b707f2458fb047e77497354b195e05b14

 CMakeLists.txt | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit a0df0676130bc565af0ec911e68a1d0fbc3ed0fb
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-07-02 18:02:50 +0300

    CMake: The compile definition is ENABLE_NLS, not XZ_NLS
    
    The CMake variables were renamed and accidentally also
    the compile definition was renamed. As a result, translation
    support wasn't actually enabled in the executables.
    
    Fixes: 29f77c7b707f2458fb047e77497354b195e05b14

 CMakeLists.txt | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 45d08abc33ccc52d2f050dcec458badc2ce59d0b
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-07-01 17:33:20 +0300

    Update AUTHORS and THANKS

 AUTHORS | 2 +-
 THANKS  | 1 +
 2 files changed, 2 insertions(+), 1 deletion(-)

commit 7baf6835cfbf9c85ba37f9ffb7d4f87fb86a474e
Author: Xi Ruoyao <xry111@xry111.site>
Date:   2024-06-28 13:36:43 +0300

    liblzma: Speed up CRC32 calculation on 64-bit LoongArch
    
    The crc.w.{b/h/w/d}.w instructions in LoongArch can calculate the CRC32
    result for 1/2/4/8 bytes in a single operation. Using these is much
    faster compared to the generic method.
    
    Optimized CRC32 is enabled unconditionally on 64-bit LoongArch because
    the LoongArch specification says that CRC32 instructions shall be
    implemented for 64-bit processors. Optimized CRC32 isn't enabled for
    32-bit LoongArch processors because not enough information is available
    about them.
    
    Co-authored-by: Lasse Collin <lasse.collin@tukaani.org>
    
    Closes: https://github.com/tukaani-project/xz/pull/86

 CMakeLists.txt                      | 25 ++++++++++++++
 configure.ac                        | 40 +++++++++++++++++++++++
 src/liblzma/check/Makefile.inc      |  3 +-
 src/liblzma/check/crc32_fast.c      |  2 ++
 src/liblzma/check/crc32_loongarch.h | 65 +++++++++++++++++++++++++++++++++++++
 src/liblzma/check/crc_common.h      | 15 +++++++++
 6 files changed, 149 insertions(+), 1 deletion(-)

commit 0ed893668554fb0758003289f8a6af9bd08b89d1
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-28 14:20:49 +0300

    liblzma: ARM64 CRC32: Align the buffer faster
    
    Instead of doing it byte by byte, use the 1/2/4-byte CRC32 instructions.

 src/liblzma/check/crc32_arm64.h | 54 ++++++++++++++++++++++++++++++-----------
 1 file changed, 40 insertions(+), 14 deletions(-)

commit 7e99856f66c07852c4e0de7aa01951e9147d86b0
Author: Sam James <sam@gentoo.org>
Date:   2024-06-28 14:18:35 +0300

    CI: Speed up Valgrind job by using --trace-children-skip-by-arg=...
    
    This addresses the issue I mentioned in
    6c095a98fbec70b790253a663173ecdb669108c4 and speeds up the Valgrind
    job a bit, because non-xz tools aren't run unnecessarily with
    Valgrind by the script tests.

 .github/workflows/ci.yml | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 2402e8a1ae92676fa0d4cb1b761d7f62f005c098
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-25 16:00:22 +0300

    Build: Prepend, not append, PTHREAD_CFLAGS to LIBS
    
    It shouldn't make any difference because LIBS should be empty
    at that point in configure. But prepending is the correct way
    because in general the libraries being added might require other
    libraries that come later on the command line.

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 7bb46f2b7b3989c1b589a247a251470f65e91cda
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-25 14:24:29 +0300

    Build: Use AC_LINK_IFELSE to handle implicit function declarations
    
    It's more robust in case the compiler allows pre-C99 implicit function
    declarations. If an x86 intrinsic is missing and gets treated as
    implicit function, the linking step will very probably fail. This
    isn't the only way to workaround implicit function declarations but
    it might be the simplest and cleanest.
    
    The problem hasn't been observed in the wild.
    
    There are a couple more AC_COMPILE_IFELSE uses in configure.ac.
    Of these, Landlock check calls prctl() and in theory could have
    the same problem. In practice it doesn't as the check program
    looks for several other things too. However, it was changed to
    AC_LINK_IFELSE still to look more correct.
    
    Similarly, m4/tuklib_cpucores.m4 and m4/tuklib_physmem.m4 were
    updated although they haven't given any trouble either. They
    have worked all these years because those check programs rely
    on specific headers and types: if headers or types are missing,
    compilation will fail. Using the linker makes these checks more
    similar to the ones in cmake/tuklib_*.cmake which always link.

 configure.ac          |  8 ++++++--
 m4/tuklib_cpucores.m4 |  8 ++++----
 m4/tuklib_physmem.m4  | 17 +++++++++++------
 3 files changed, 21 insertions(+), 12 deletions(-)

commit 35eb57355ad1c415a838d26192d5af84abb7cf39
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-24 23:35:59 +0300

    Build: Use AC_LINK_IFELSE instead of -Werror
    
    AC_COMPILE_IFELSE needed -Werror because Clang <= 14 would merely
    warn about the unsupported attribute and implicit function declaration.
    Changing to AC_LINK_IFELSE handles the implicit declaration because
    the symbol __crc32d is unlikely to exist in libc.
    
    Note that the other part of the check is that #include <arm_acle.h>
    must work. If the header is missing, most compilers give an error
    and the linking step won't be attempted.
    
    Avoiding -Werror makes the check more robust in case CFLAGS contains
    warning flags that break -Werror anyway (but this isn't the only check
    in configure.ac that has this problem). Using AC_LINK_IFELSE also makes
    the check more similar to how it is done in CMakeLists.txt.

 configure.ac | 12 +-----------
 1 file changed, 1 insertion(+), 11 deletions(-)

commit 5a728813c378cc3c4c9c95793762452418d08f1b
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-24 23:34:34 +0300

    Build: Sync the compile check changes from CMakeLists.txt
    
    It's nice to keep these in sync. The use of main() will later allow
    AC_LINK_IFELSE usage too which may avoid the more fragile -Werror.

 configure.ac | 15 ++++++++-------
 1 file changed, 8 insertions(+), 7 deletions(-)

commit 5279828635a95abdef82e691fc4979d362780e63
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-24 20:14:43 +0300

    CMake: Not experimental anymore
    
    While the CMake support has gotten a lot less testing than
    the Autotools-based build, the supported features should now
    be equal. The output may differ slightly, for example,
    liblzma.pc may have
    
        Libs.private: -pthread -lpthread
    
    with Autotools on GNU/Linux. CMake doesn't put any options
    in Libs.private because on modern glibc the pthread functions
    are in libc. The options options aren't required to link static
    liblzma into an application.
    
    Autotools-based build doesn't generate or install
    lib/cmake/liblzma-*.cmake files. This means that on most
    platforms one cannot rely on
    
        find_package(liblzma 5.2.5 REQUIRED CONFIG)
    
    or such finding those files.

 CMakeLists.txt | 9 ++++++---
 1 file changed, 6 insertions(+), 3 deletions(-)

commit de215a0517645d16343f3a5336d3df884a4f665f
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-25 16:11:13 +0300

    CMake: Use configure_file() to copy a file
    
    I had missed this simpler method before. It does create a dependency
    so that if .in.h changes the copying is done again.

 CMakeLists.txt | 17 +++++++----------
 1 file changed, 7 insertions(+), 10 deletions(-)

commit e620f35097c0ad20cd76d8258750aa706758ced9
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-25 15:51:48 +0300

    CMake: Always add pthread flags into CMAKE_REQUIRED_LIBRARIES
    
    It was weird to add CMAKE_THREAD_LIBS_INIT in CMAKE_REQUIRED_LIBRARIES
    only if CLOCK_MONOTONIC is available. Alternative would be to remove
    the thread libs from CMAKE_REQUIRED_LIBRARIES after the check for
    pthread_condattr_setclock() but keeping the libs should be fine too.
    Then it's ready in case more pthread functions were wanted some day.

 CMakeLists.txt | 6 ++++--
 1 file changed, 4 insertions(+), 2 deletions(-)

commit 068a70e54932ca32ca2922aff5a67a62615c650b
Author: Sam James <sam@gentoo.org>
Date:   2024-06-24 19:25:30 +0100

    CMake: Tweak comments
    
    Co-authored-by: Lasse Collin <lasse.collin@tukaani.org>

 CMakeLists.txt | 15 +++++++--------
 1 file changed, 7 insertions(+), 8 deletions(-)

commit 3c95c93bca593bdd54ac5cc01526b12c82c78faa
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-24 22:42:01 +0300

    CMake: Edit white space for consistency

 CMakeLists.txt | 26 +++++++++++++-------------
 1 file changed, 13 insertions(+), 13 deletions(-)

commit 114cba69dbb96003e676c8c87a2e9943b12d065f
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-24 22:41:10 +0300

    CMake: Fix three checks if building with -flto
    
    In CMake, check_c_source_compiles() always links too. With
    link-time optimization, unused functions may get omitted if
    main() doesn't depend on them. Consider the following which
    tries to check if somefunction() is available when <someheader.h>
    has been included:
    
        #include <someheader.h>
        int foo(void) { return somefunction(); }
        int main(void) { return 0; }
    
    LTO may omit foo() completely because the program as a whole doesn't
    need it and then the program will link even if the symbol somefunction
    isn't available in libc or other library being linked in, and then
    the test may pass when it shouldn't.
    
    What happens if <someheader.h> doesn't declare somefunction()?
    Shouldn't the test fail in the compilation phase already? It should
    but many compilers don't follow the C99 and later standards that
    prohibit implicit function declarations. Instead such compilers
    assume that somefunction() exists, compilation succeeds (with a
    warning), and then linker with LTO omits the call to somefunction().
    
    Change the tests so that they are part of main(). If compiler accepts
    implicitly declared functions, LTO cannot omit them because it has to
    assume that they might have side effects and thus linking will fail.
    On the other hand, if the functions/intrinsics being used are supported,
    they might get optimized away but in that case it's fine because they
    really are supported.
    
    It is fine to use __attribute__((target(...))) for main(). At least
    it works with GCC 4.9 to 14.1 on x86-64.
    
    Reported-by: Sam James <sam@gentoo.org>

 CMakeLists.txt | 19 ++++++++-----------
 1 file changed, 8 insertions(+), 11 deletions(-)

commit 78e882205e1f1e91df2af2cb7da00fe205dede99
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-24 21:19:14 +0300

    CMake: Use MATCHES instead of multiple STREQUAL

 CMakeLists.txt | 11 ++++-------
 1 file changed, 4 insertions(+), 7 deletions(-)

commit d3f20382fc1bd865eb70a65455d5022ed05caac8
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-24 21:06:18 +0300

    CMake: Improve the comment about LIBS

 CMakeLists.txt | 6 ++++++
 1 file changed, 6 insertions(+)

commit 33ec377729a3889e58d98934b2777b2754a3e045
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-24 20:01:25 +0300

    CMake: Fix a typo in a message
    
    It was spotted with codespell.

 CMakeLists.txt | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 2a47be823cd6c717bc91fa29c7710c9b1ae0331f
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-24 19:58:54 +0300

    Document CMake options in INSTALL

 INSTALL | 115 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++-----
 1 file changed, 106 insertions(+), 9 deletions(-)

commit 3faf4e8079a46bd46e05cd1234365724a6a33802
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-24 17:18:44 +0300

    CI: Don't omit crc32 from the list with CMake anymore
    
    XZ_CHECKS accepts it but works without too.

 build-aux/ci_build.bash | 10 +---------
 1 file changed, 1 insertion(+), 9 deletions(-)

commit 1bf83cded2955282fe1a868f08c83d4e5d6dca4a
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-24 17:39:54 +0300

    CI: Workaround buggy config.guess on Ubuntu 22.04LTS and 24.04LTS
    
    Check for the wrong triplet from config.guess and override it with
    the --build option on the configure command line. Then i386 assembly
    autodetection will work.
    
    These Ubuntu versions (and as of writing, also Debian unstable)
    ship config.guess version 2022-01-09 which contains a bug that
    was fixed in version 2022-05-08. It results in a wrong configure
    triplet when using CC="gcc -m32" to build i386 binaries.
    
    Upstream fix:
    https://git.savannah.gnu.org/cgit/config.git/commit/?id=f56a7140386d08a531bcfd444d632b28c61a6329
    
    More information:
    https://mail.gnu.org/archive/html/config-patches/2022-05/msg00003.html

 build-aux/ci_build.bash | 9 +++++++++
 1 file changed, 9 insertions(+)

commit dbcdabf68fee9ed694b68c3a82e6adbeff20b679
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-24 15:24:52 +0300

    CI: Use CC="gcc -m32" to get i386 compiler on x86-64
    
    The old method put it in CFLAGS which is a wrong place because
    config.guess doesn't read CFLAGS.

 .github/workflows/ci.yml | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 0c1e6d900bac127464fb30a854776e1810ab5f16
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-24 14:54:17 +0300

    CI: Let CMake use the CC environment variable
    
    CC from environment is used to initialize CMAKE_C_COMPILER so
    setting CMAKE_C_COMPILER explicitly isn't needed.
    
    The syntax in ci_build.bash was broken in case one wished to put
    spaces in CC.

 build-aux/ci_build.bash | 4 ----
 1 file changed, 4 deletions(-)

commit a3d6eb797c1bd9b0425ef6754e475e43e62bf075
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-20 23:25:42 +0300

    CMake: Add autodetection for 32-bit x86 CRC assembly usage

 CMakeLists.txt | 33 ++++++++++++++++++---------------
 1 file changed, 18 insertions(+), 15 deletions(-)

commit dbc14f213e5cf866f1f42b7c6381a91e1189908c
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-20 23:00:59 +0300

    CMake: Move option(XZ_ASM_I386) downwards a few lines

 CMakeLists.txt | 16 ++++++++--------
 1 file changed, 8 insertions(+), 8 deletions(-)

commit e5c2b07b489b155c1bebd5cb5e5b94325c2fef1a
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-20 18:45:41 +0300

    DOS: Update Makefile and config.h for the CRC changes

 dos/Makefile | 4 ++--
 dos/config.h | 3 +++
 2 files changed, 5 insertions(+), 2 deletions(-)

commit fe77c4e130d62dc3f9c1de40a18c0c6caa5a4d88
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-23 15:35:35 +0300

    liblzma: Tidy up crc_common.h
    
    Prefix ARM64_RUNTIME_DETECTION with CRC_ and reorder it to be with
    the other ARM64-specific lines. That macro isn't used outside this
    file.
    
    ARM64 CLMUL implementation doesn't exist yet and thus CRC64_ARM64_CLMUL
    isn't used anywhere yet.
    
    It's not ideal that the single-letter CRC utility macros are here
    as they pollute the namespace of the LZ encoder files. Those could
    be moved their own crc_macros.h like they were in 5.2.x but in practice
    this is fine enough already.

 src/liblzma/check/crc_common.h | 62 ++++++++++++++++++++++++++++--------------
 1 file changed, 42 insertions(+), 20 deletions(-)

commit 7484d375384f551d475ff44a93590a225e0cb8f6
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-23 14:22:08 +0300

    liblzma: Move lzma_crcXX_table[][] declarations to crc_common.h
    
    LZ encoder needs lzma_crc32_table[0] but otherwise those tables
    are private to the CRC code. In contrast, the other things in
    check.h are needed in several places.

 src/liblzma/check/check.h        | 18 ------------------
 src/liblzma/check/crc32_small.c  |  3 +++
 src/liblzma/check/crc_common.h   | 18 ++++++++++++++++++
 src/liblzma/lz/lz_encoder_hash.h |  4 ++--
 4 files changed, 23 insertions(+), 20 deletions(-)

commit 85b081f5d4598342b8c155a2c08697fb2adc372c
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-19 18:38:22 +0300

    liblzma: Make 32-bit x86 CRC assembly co-exist with CLMUL
    
    Now runtime detection of CLMUL support can pick between the CLMUL and
    the generic assembly implementations. Whatever overhead this has for
    builds that omit CLMUL completely isn't important because builds for
    any non-ancient system is likely to include the CLMUL code too.
    
    Handle the CRC tables in crcXX_fast.c files because now these files
    are built even when assembly code is used.
    
    If 32-bit x86 assembly is enabled then it will always be built even
    if compiler flags were such that CLMUL would be allowed unconditionally.
    That is, runtime detection will be used anyway. This keeps the build
    rules simpler.
    
    In LZ encoder, build and use lzma_lz_hash_table[256] if CLMUL CRC
    is used without runtime detection. Previously this wasn't needed
    because crc32_table.c included the lzma_crc32_table[][] in the build
    unless encoder support had been disabled. Including an 8 KiB table
    was silly when only 1 KiB is actually used. So now liblzma is 7 KiB
    smaller if CLMUL is enabled without runtime detection.

 CMakeLists.txt                    |  8 ++------
 src/liblzma/check/Makefile.inc    |  8 ++------
 src/liblzma/check/crc32_fast.c    | 14 ++++++++++++-
 src/liblzma/check/crc32_table.c   | 42 ---------------------------------------
 src/liblzma/check/crc32_x86.S     | 14 +++++--------
 src/liblzma/check/crc64_fast.c    | 18 +++++++++++++----
 src/liblzma/check/crc64_table.c   | 37 ----------------------------------
 src/liblzma/check/crc64_x86.S     | 14 +++++--------
 src/liblzma/check/crc_common.h    | 18 +++++++++--------
 src/liblzma/check/crc_x86_clmul.h |  5 -----
 src/liblzma/lz/lz_encoder.c       |  2 +-
 src/liblzma/lz/lz_encoder_hash.h  | 30 ++++++++++++++++++++--------
 12 files changed, 74 insertions(+), 136 deletions(-)

commit 6667d503b5dc9826654e3d9ad505e1883ff6c388
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-19 17:44:41 +0300

    liblzma: CRC: Rename crcXX_generic to lzma_crcXX_generic
    
    This prepares for the possibility that lzma_crc32_generic and
    lzma_crc64_generic are extern functions.

 src/liblzma/check/crc32_fast.c | 6 +++---
 src/liblzma/check/crc64_fast.c | 6 +++---
 2 files changed, 6 insertions(+), 6 deletions(-)

commit 1dca581ff20aa1cde61e9e5267d3aeb0af9b6845
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-20 22:55:22 +0300

    CMake: Define HAVE_CRC_X86_ASM when 32-bit x86 CRC assembly is used

 CMakeLists.txt | 3 +++
 1 file changed, 3 insertions(+)

commit f76837acb65676e541d8ee79cd62dbbf27280a62
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-05-10 16:00:26 +0300

    Build: Define HAVE_CRC_X86_ASM when 32-bit x86 CRC assembly is used
    
    This makes it easier to determine when the CRC tables are needed.

 configure.ac | 9 +++++++--
 1 file changed, 7 insertions(+), 2 deletions(-)

commit 9ce0866b070850da4dc837741ff055faa218bdd6
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-21 00:46:09 +0300

    CI: Update to the new renamed options in CMakeLists.txt

 build-aux/ci_build.bash | 10 +++++-----
 1 file changed, 5 insertions(+), 5 deletions(-)

commit 0232e66d5bc5b01a25a447c657e51747626488ab
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-20 18:12:22 +0300

    CMake: Add XZ_EXTERNAL_SHA256

 CMakeLists.txt | 121 ++++++++++++++++++++++++++++++++++++++++++++++++++++++---
 1 file changed, 116 insertions(+), 5 deletions(-)

commit 4535b80caead82a7ddf7feb988b8fbc773152522
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-20 18:12:21 +0300

    CMake: Move threading detection a few lines up
    
    It feels clearer this way, and when support for external SHA-256
    is added, this will keep the order of the library detection the
    same as in configure.ac (check for pthreads before libmd) although
    it shouldn't matter in practice.

 CMakeLists.txt | 176 ++++++++++++++++++++++++++++-----------------------------
 1 file changed, 88 insertions(+), 88 deletions(-)

commit 94d062dbac34d366eb26625034200cc3457e6645
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-20 18:12:21 +0300

    CMake: Move the sandbox code out of the liblzma section
    
    Sandboxing is for the command line tools, not liblzma.
    No functional changes.

 CMakeLists.txt | 214 ++++++++++++++++++++++++++++-----------------------------
 1 file changed, 107 insertions(+), 107 deletions(-)

commit 75ce4797d49621710e6da95d8cb91541028c6d68
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-20 18:12:21 +0300

    CMake: Keep existing options in LIBS when adding -lrt
    
    This makes no difference yet because -lrt is currently the only option
    that might be added to LIBS.

 CMakeLists.txt | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 47aaa92516fd9609821d04e5e94ca6558e56d62b
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-15 18:07:04 +0300

    CMake: Don't install scripts if the xz tool isn't built
    
    The scripts need the xz tool.

 CMakeLists.txt    | 11 +++++++++--
 tests/tests.cmake |  2 +-
 2 files changed, 10 insertions(+), 3 deletions(-)

commit fb50c6ba1d4c9405e5b12b5988b01a3002638c5d
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-15 18:07:04 +0300

    CMake: Add XZ_TOOL_XZDEC and XZ_TOOL_LZMADEC

 CMakeLists.txt | 15 ++++++++++++++-
 1 file changed, 14 insertions(+), 1 deletion(-)

commit def767f7d18ccbd81cd5e5b46c8b6031f3a1de34
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-15 18:07:04 +0300

    CMake: Add XZ_TOOL_LZMAINFO

 CMakeLists.txt | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit 5600e370fb7e11eafabc6c3ef5bf6510e859f4f0
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-15 18:07:04 +0300

    CMake: Add XZ_TOOL_XZ

 CMakeLists.txt | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit 6a3c4aaa43a90da441e1156c5ffd2e6098f5521f
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-15 18:07:04 +0300

    Windows: Drop Visual Studio 2013 support
    
    This simplifies things a little. Building liblzma with VS2013 probably
    still worked but building the command line tools was not supported.
    
    Microsoft ended support for VS2013 on 2024-04.

 CMakeLists.txt           | 9 +++++++--
 src/common/sysdefs.h     | 6 +-----
 windows/INSTALL-MSVC.txt | 8 ++------
 3 files changed, 10 insertions(+), 13 deletions(-)

commit 5d5c92b26246936461a635dda1f95740d7de2058
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-15 18:07:04 +0300

    CMake: Add XZ_TOOL_SCRIPTS

 CMakeLists.txt | 44 +++++++++++++++++++++++++++++---------------
 1 file changed, 29 insertions(+), 15 deletions(-)

commit d274a2bc00d235f07e96aaf82c149794cfe82b12
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-15 18:07:04 +0300

    CMake: Add XZ_DOC

 CMakeLists.txt | 45 ++++++++++++++++++++++++---------------------
 1 file changed, 24 insertions(+), 21 deletions(-)

commit 188143a50ade67253ed256608f50f78aa1380403
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-20 21:53:03 +0300

    CMake: Refactor XZ_SYMBOL_VERSIONING to match configure.ac
    
    Make the available options and their behavior match
    --enable-symbol-versions in configure.ac.
    
    Don't enable symbol versions on Linux if not using glibc. Previously
    the generic variant was selected on Microblaze or if using NVHPC
    without checking that libc is glibc.
    
    Leave the cache variable to "auto" or "yes" if that was specified
    instead of setting it to the autodetected value by default. A downside
    is that one cannot easily see which variant the autodetection code
    has selected. The same applies to XZ_SANDBOX and XZ_THREADS though.

 CMakeLists.txt | 125 ++++++++++++++++++++++++++++++++++-----------------------
 1 file changed, 75 insertions(+), 50 deletions(-)

commit cc52ef8ed3b75a581262c587f6c06c213a550f86
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-15 18:07:04 +0300

    CMake: Use the same option list for XZ_THREADS as in configure.ac
    
    Also clarify that "yes" will fail if no threading support is found.
    If no threading is wanted, it has to be disabled manually.
    
    configure.ac doesn't behave this way at the moment. Instead it
    assumes pthreads to be present if not targeting Windows. If pthreads
    actually are missing, the build fails later.

 CMakeLists.txt | 18 ++++++++++--------
 1 file changed, 10 insertions(+), 8 deletions(-)

commit 37f7af3452bab0a34ce320c2ad532835f18752d9
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-15 18:07:04 +0300

    CMake: Use the same option list for XZ_SANDBOX as in configure.ac
    
    It's simpler to document this way.

 CMakeLists.txt | 20 ++++++++++----------
 1 file changed, 10 insertions(+), 10 deletions(-)

commit c715dec8e800b65145918cfb0ee9bbc90faa8aad
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-15 18:07:04 +0300

    CMake: Fix indentation

 CMakeLists.txt | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit ea379f2f180befabd2039342db8eaeb757fdd2b7
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-15 18:07:04 +0300

    CMake: Add warning options for GCC and Clang
    
    The list was copied from configure.ac and should be kept in sync.
    (Pretend that the deleted comment in CMakeLists.txt didn't exist.)
    
    There is no need to add equivalent of --enable-werror as CMake >= 3.24
    supports -DCMAKE_COMPILE_WARNING_AS_ERROR=ON.

 CMakeLists.txt | 64 +++++++++++++++++++++++++++++++++++++++++++++++++++++-----
 1 file changed, 59 insertions(+), 5 deletions(-)

commit 74223338197b7dfcd69f56df78b6502805a75f23
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-15 18:07:04 +0300

    CMake: Use \040 instead of \x20 for a space
    
    This is for consistency with 4c81c9611f8b2e1ad65eb7fa166afc570c58607e
    where \040 has to be used because \0x20F gets interpret at three hex
    digits. Octals escapes are never longer than three digits.

 CMakeLists.txt | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit e8854b6bdc956c46dc4232bd07c17163034a00f2
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-15 18:07:04 +0300

    CMake: Add XZ_ASSUME_RAM

 CMakeLists.txt | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit e1127e75cb82e0385f02c995771d6fe1420f43c5
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-15 18:07:04 +0300

    CMake: Rename liblzma_INSTALL_CMAKEDIR to XZ_INSTALL_CMAKEDIR

 CMakeLists.txt | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 96abfe98c15e431a50a6a31015c5bb05540ab2ff
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-15 18:07:04 +0300

    CMake: Refactor ADDITIONAL_CHECK_TYPES to XZ_CHECKS
    
    Now "crc32" is in the list too for completeness but it doesn't
    actually have any effect. The description of the cache variable
    says that "crc32 is always built" so it should be clear enough.

 CMakeLists.txt    | 14 +++++++-------
 tests/tests.cmake | 17 ++++++++---------
 2 files changed, 15 insertions(+), 16 deletions(-)

commit 679500ffe00ecb4f02292129e7529ab7392f3943
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-15 18:07:04 +0300

    CMake: Rename the cache variable POSIX_SHELL to XZ_POSIX_SHELL
    
    We still need the variable POSIX_SHELL for configure_file()
    but it doesn't need to be a cache variable.

 CMakeLists.txt | 7 ++++---
 1 file changed, 4 insertions(+), 3 deletions(-)

commit e5c0eb2e50e5522a0a55e7ba83fe49b04c8a6eef
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-15 18:07:04 +0300

    CMake: Rename ENCODERS and DECODERS to use XZ_ prefix

 CMakeLists.txt    | 34 +++++++++++++++++-----------------
 tests/tests.cmake |  4 ++--
 2 files changed, 19 insertions(+), 19 deletions(-)

commit e7785e2061f95d44aa6c0856b09cc0fbad7d6154
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-15 18:07:04 +0300

    CMake: Rename MATCH_FINDERS to XZ_MATCH_FINDERS

 CMakeLists.txt | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 63294806b488a27a28a0960f6a257695dd2b569a
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-15 18:07:04 +0300

    CMake: Rename SYMBOL_VERSIONING to XZ_SYMBOL_VERSIONING

 CMakeLists.txt | 9 +++++----
 1 file changed, 5 insertions(+), 4 deletions(-)

commit ad245b133675d285bca5d48123062e9d1e3f747e
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-15 18:07:04 +0300

    CMake: Rename ENABLE_THREADS to XZ_THREADS

 CMakeLists.txt | 24 +++++++++++-------------
 1 file changed, 11 insertions(+), 13 deletions(-)

commit 4250d4de32e66e558cc2ebe73b05255633c933ed
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-15 18:07:04 +0300

    CMake: Rename ENABLE_SANDBOX to XZ_SANDBOX

 CMakeLists.txt | 23 +++++++++++------------
 1 file changed, 11 insertions(+), 12 deletions(-)

commit 0fdcd0c582f1a38542cd647dde449d9447d5888d
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-15 18:07:04 +0300

    CMake: Rename ENABLE_X86_ASM to XZ_ASM_I386

 CMakeLists.txt | 10 +++++-----
 1 file changed, 5 insertions(+), 5 deletions(-)

commit e017d5526e316003fdb2a3f76acbb83443f14ddf
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-15 18:07:04 +0300

    CMake: Rename CREATE_XZ_SYMLINKS to XZ_TOOL_SYMLINKS
    
    This only affects the names unxz and xzcat. The xz-prefixed script
    symlinks (xzfgrep and such) are always created if scripts are enabled.

 CMakeLists.txt | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 04cac14fcb9fb302c24e90b04ca4b77d3717b50c
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-15 18:07:04 +0300

    CMake: Rename CREATE_LZMA_SYMLINKS to XZ_TOOL_LZMA_SYMLINKS
    
    Update the description too.
    
    It affects creation of not only the legacy lzma, unlzma, lzcat symlinks
    but also lzgrep and other legacy names for the scripts. The last
    LZMA Utils release was made in 2008 but these names are still used
    in some places to handle .lzma files.

 CMakeLists.txt | 7 ++++---
 1 file changed, 4 insertions(+), 3 deletions(-)

commit 612ccebf884eb1a9b6848e230c24f97a03fe917a
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-15 18:07:04 +0300

    CMake: Rename ALLOW_ARM64_CRC32 to XZ_ARM64_CRC32
    
    Update description too.

 CMakeLists.txt | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 3dcc12290d6dffbe7f10f501c141d325bad65901
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-15 18:07:04 +0300

    CMake: Rename ALLOW_CLMUL_CRC to XZ_CLMUL_CRC
    
    Update description too.

 CMakeLists.txt | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 4b8faa72442da9aa1a356f5848aae798d8588a7d
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-15 18:07:04 +0300

    CMake: Rename ENABLE_DOXYGEN to XZ_DOXYGEN

 CMakeLists.txt | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit b56273ae575bac350e50b0c689269dcab04b04b3
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-15 18:07:04 +0300

    CMake: Rename LZIP_DECODER to XZ_LZIP_DECODER

 CMakeLists.txt    | 4 ++--
 tests/tests.cmake | 2 +-
 2 files changed, 3 insertions(+), 3 deletions(-)

commit 2343992fcbe8b436da6df888be37713cccaff0ab
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-15 18:07:04 +0300

    CMake: Rename MICROLZMA_ENCODER/DECODER to XZ_MICROLZMA_ENCODER/DECODER

 CMakeLists.txt    | 8 ++++----
 tests/tests.cmake | 2 +-
 2 files changed, 5 insertions(+), 5 deletions(-)

commit 96f0a6632cc0598a26d93255b0c444df18dc7891
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-15 18:07:04 +0300

    CMake: Rename ENABLE_SMALL to XZ_SMALL

 CMakeLists.txt | 14 +++++++-------
 1 file changed, 7 insertions(+), 7 deletions(-)

commit 29f77c7b707f2458fb047e77497354b195e05b14
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-15 18:07:04 +0300

    CMake: Rename ENABLE_NLS to XZ_NLS
    
    Also update the description to mention that this affects installation
    of translated man pages too.
    
    Prefixing the cache variables with the project name helps if
    the package is used as a subproject in another package.
    It also makes the package-specific options group more nicely
    in ccmake and cmake-gui.

 CMakeLists.txt | 28 +++++++++++++++-------------
 1 file changed, 15 insertions(+), 13 deletions(-)

commit ac05f1b0d7cda1e7ae79775a8dfecc54601d7f1c
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-15 23:34:29 +0300

    CMake: Link Threads::Threads as PRIVATE to liblzma
    
    This way pthread options aren't passed to the linker when linking
    against shared liblzma but they are still passed when linking against
    static liblzma. (Also, one never needs the include path of the
    threading library to use liblzma since liblzma's API headers
    don't #include <pthread.h>. But <pthread.h> tends to be in the
    default include path so here this change makes no difference.)
    
    One cannot mix target_link_libraries() calls that use the scope
    (PRIVATE, PUBLIC, or INTERFACE) keyword and calls that don't use it.
    The calls without the keyword are like PUBLIC except perhaps when
    they aren't, or something like that... It seems best to always
    specify a scope keyword as the meanings of those three keywords
    at least are clear.

 CMakeLists.txt | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 82986d8c691a294c78b48d8391303e5c428b5437
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-16 19:39:32 +0300

    CMake: Add empty lines

 CMakeLists.txt | 2 ++
 1 file changed, 2 insertions(+)

commit 2aecffe0f0e14f3ef635e8cd7b405420f2385de2
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-16 19:37:36 +0300

    CMake: Use CMAKE_THREAD_LIBS_INIT in liblzma.pc only with pthreads
    
    This shouldn't make much difference in practice as on Windows
    no flags are needed anyway and unitialized variable (when threading
    is disabled) expands to empty. But it's clearer this way.

 CMakeLists.txt | 8 +++++++-
 1 file changed, 7 insertions(+), 1 deletion(-)

commit 664918bd3635ea8e773f06022286ecb0c485166c
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-17 18:20:14 +0300

    Update THANKS

 THANKS | 3 +++
 1 file changed, 3 insertions(+)

commit 5ca96a93488d0f5a530c78b274cac317453807ff
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-16 19:25:07 +0300

    CMake: Use native newlines in liblzma.pc
    
    vcpkg doesn't specify the newline type so it should be fine to
    use native newlines in liblzma.pc on Windows.

 CMakeLists.txt | 4 +---
 1 file changed, 1 insertion(+), 3 deletions(-)

commit ebd155c3a1b87411edae06d3bdaa9659ec057522
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-16 19:18:56 +0300

    CMake: Use relative paths in liblzma.pc if possible
    
    Now liblzma.pc can be relocatable only if using CMake >= 3.20
    but that should be OK as now we shouldn't get broken liblzma.pc
    if CMAKE_INSTALL_LIBDIR or CMAKE_INSTALL_INCLUDEDIR contain an
    absolute path.
    
    Thanks to Eli Schwartz.

 CMakeLists.txt | 18 ++++++++++++++----
 1 file changed, 14 insertions(+), 4 deletions(-)

commit 7a366d93cfd74ce10201db400be8836199944e36
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-16 18:33:08 +0300

    Revert "CMake: Set only "prefix" as an absolute path in liblzma.pc"
    
    This reverts commit 5d1c649ba9eb7a5b9371252ebfbc2911dc774e69.
    
    While CMAKE_INSTALL_<dir> tend to be relative paths, they don't need
    to be. Thus the commit was broken. A fancier method is required.
    
    Thanks to Eli Schwartz for the bug report and explanation.

 CMakeLists.txt | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 30a2d5d51006301a3ddab5ef1f5ff0a9d74dce6f
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-16 13:39:37 +0300

    liblzma: CRC CLMUL: Omit is_arch_extension_supported() when not needed
    
    On E2K the function compiles only due to compiler emulation but the
    function is never used. It's cleaner to omit the function when it's
    not needed even though it's a "static inline" function.
    
    Thanks to Ilya Kurdyukov.

 src/liblzma/check/crc_x86_clmul.h | 4 ++++
 1 file changed, 4 insertions(+)

commit 54eaea5ea49bb8bca4286d4412f19ac73187489e
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-16 13:21:34 +0300

    liblzma: x86 CLMUL CRC: Rewrite
    
    It's faster with both tiny and large buffers and doesn't require
    disabling any sanitizers. With large buffers the extra speed is
    from folding four 16-byte chunks in parallel.
    
    The 32-bit x86 with MSVC reportedly still needs a workaround.
    Now the simpler "__asm mov ebx, ebx" trick is enough but it
    needs to be in lzma_crc64() instead of crc64_arch_optimized().
    Thanks to Iouri Kharon for testing and the fix.
    
    Thanks to Ilya Kurdyukov for testing the speed with aligned and
    unaligned buffers on a few x86 processors and on E2K v6.
    
    Thanks to Sam James for general feedback.
    
    Fixes: https://github.com/tukaani-project/xz/issues/112
    Fixes: https://github.com/tukaani-project/xz/issues/122

 src/liblzma/check/crc64_fast.c    |   8 +
 src/liblzma/check/crc_x86_clmul.h | 437 ++++++++++++++++++++------------------
 2 files changed, 237 insertions(+), 208 deletions(-)

commit c0e7eaae8d6eef1e313c9d0da20ccf126ec61f38
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-01 14:44:04 +0300

    sysdefs.h: Add alignas

 src/common/sysdefs.h | 11 +++++++++++
 1 file changed, 11 insertions(+)

commit 20014c261451381d5e2f58e63e7b1fbefd4df4bf
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-11 12:47:59 +0300

    liblzma: Use a single macro to select CLMUL CRC to build
    
    This way it's clearer that two things cannot be selected
    at the same time.

 src/liblzma/check/crc32_fast.c    |  2 +-
 src/liblzma/check/crc64_fast.c    |  2 +-
 src/liblzma/check/crc_x86_clmul.h | 18 ++++++++++--------
 3 files changed, 12 insertions(+), 10 deletions(-)

commit d8fb0986171bd6a3066b236fc9a6b3d573c8e441
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-10 15:31:01 +0300

    liblzma: CRC32 CLMUL: Refactor the constants and simplify
    
    By using modulus scaled constants, the final reduction can
    be simplified.

 src/liblzma/check/crc_x86_clmul.h | 52 +++++++--------------------------------
 1 file changed, 9 insertions(+), 43 deletions(-)

commit ef652ac391ff7e8cda656238dc5b5f83bc1554c2
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-10 15:12:48 +0300

    liblzma: CRC64 CLMUL: Refactor the constants
    
    Now it refers to crc_clmul_consts_gen.c. vfold8 was renamed to mu_p
    and the p no longer has the lowest bit set (it makes no difference
    as the output bits it affects are ignored).

 src/liblzma/check/crc_x86_clmul.h | 43 +++++++--------------------------------
 1 file changed, 7 insertions(+), 36 deletions(-)

commit 9f5fc17e32bf5c7c6cfadf40c29a1dedb4cc03ac
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-10 14:45:44 +0300

    liblzma: Add crc_clmul_consts_gen.c
    
    It's a standalone program that prints the required constants.
    It's won't be a part of the normal build of the package.

 src/liblzma/check/Makefile.inc           |   1 +
 src/liblzma/check/crc_clmul_consts_gen.c | 160 +++++++++++++++++++++++++++++++
 2 files changed, 161 insertions(+)

commit 71b147aab7fe4a60ed57b697d5bb490f099894be
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-05-09 21:44:03 +0300

    liblzma: Remove CRC_USE_GENERIC_FOR_SMALL_INPUTS
    
    It was already commented out.

 src/liblzma/check/crc32_fast.c    | 21 ---------------------
 src/liblzma/check/crc64_fast.c    |  5 -----
 src/liblzma/check/crc_common.h    | 14 --------------
 src/liblzma/check/crc_x86_clmul.h |  9 +--------
 4 files changed, 1 insertion(+), 48 deletions(-)

commit f99a7be40645f86959a5b180dfae948dd165e07c
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-05-09 21:03:39 +0300

    liblzma: Remove crc_attr_no_sanitize_address
    
    It's not enough to silence the address sanitizer. Also memory and
    thread sanitizers would need to be silenced. They, at least currently,
    aren't smart enough to see that the extra bytes are discarded from
    the xmm registers by later instructions.
    
    Valgrind is smarter, possibly because this kind of code isn't weird
    to write in assembly. Agner Fog's optimizing_assembly.pdf even mentions
    this idea of doing an aligned read and then discarding the extra
    bytes. The sanitizers don't instrument assembly code but Valgrind
    checks all code.
    
    It's better to change the implementation to avoid the sanitization
    attributes which also look scary in the code. (Somehow they can look
    more scary than __asm__ which is implictly unsanitized.)
    
    See also:
    https://github.com/tukaani-project/xz/issues/112
    https://github.com/tukaani-project/xz/issues/122

 src/liblzma/check/crc_common.h    | 9 ---------
 src/liblzma/check/crc_x86_clmul.h | 3 ---
 2 files changed, 12 deletions(-)

commit ead4d151996f8a18bf9b07eb1e175c0a1590e562
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-10 15:37:49 +0300

    Revert "Build: Temporarily disable CRC CLMUL to silence OSS Fuzz"
    
    This reverts commit 9f1a6d6f9a258886933a22239a5b81af34b28199.

 configure.ac | 4 +---
 1 file changed, 1 insertion(+), 3 deletions(-)

commit 2178acf8a4d40a93e970cfcf9b807d5ef6c8da92
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-12 14:26:44 +0300

    CMake: Prefer C11 with a fallback to C99
    
    There is no need to make a similar change in configure.ac.
    With Autoconf 2.72, the deprecated macro AC_PROG_CC_C99
    is an alias for AC_PROG_CC which prefers a C11 compiler.

 CMakeLists.txt | 17 +++++++++++------
 1 file changed, 11 insertions(+), 6 deletions(-)

commit c97e9c12fef4d1093ee2a75236742481361f50f5
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-12 14:20:21 +0300

    Update THANKS

 THANKS | 4 ++++
 1 file changed, 4 insertions(+)

commit 89e9f12e03324b8a186e807b268f34f92d1b2f41
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-11 11:15:49 +0300

    Tests: Improve the CRC32 test
    
    A similar one was already there for CRC64 but nowadays also CRC32
    has a CLMUL implementation, so it's good to test it better too.

 tests/test_check.c | 17 +++++++++++++----
 1 file changed, 13 insertions(+), 4 deletions(-)

commit c7164b1927e3fe7cdba70ee4687e1a590a81043b
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-11 22:42:26 +0300

    xz: Fix white space

 src/xz/list.c | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 0a32d2072c598de281058b26dc08920fbf0cd2a1
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-11 21:59:09 +0300

    liblzma: Fix a typo in a comment
    
    Thanks to Sam James for spotting it.
    
    Fixes: f644473a211394447824ea00518d0a214ff3f7f2

 src/liblzma/check/crc_x86_clmul.h | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit afd9b4d282a10186808c3331dad4caf79c02d55f
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-05-10 15:52:26 +0300

    liblzma: Fix a comment indentation

 src/liblzma/check/crc_common.h | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 50e6bff274568c568930e15094da8217e7d47d28
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-05-09 22:09:12 +0300

    liblzma: Fix white space

 src/liblzma/check/crc32_table.c   | 10 +++++-----
 src/liblzma/check/crc_x86_clmul.h |  6 +++---
 src/liblzma/check/sha256.c        |  2 +-
 3 files changed, 9 insertions(+), 9 deletions(-)

commit caea7844d3824755d053b4743c4913d73ac2db3d
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-01 14:25:29 +0300

    tuklib: __STDC_VERSION__ in C23 is 202311

 src/common/tuklib_common.h | 4 +---
 1 file changed, 1 insertion(+), 3 deletions(-)

commit 9e73918a4f14be754a23f74dda45ca431939a4a0
Author: RainRat <rainrat78@yahoo.ca>
Date:   2024-06-05 15:21:49 -0700

    Fix typos
    
    Closes: https://github.com/tukaani-project/xz/pull/124

 INSTALL                           | 2 +-
 doc/examples/03_compress_custom.c | 2 +-
 src/common/tuklib_integer.h       | 2 +-
 src/liblzma/api/lzma/container.h  | 2 +-
 src/xz/mytime.c                   | 2 +-
 tests/test_filter_str.c           | 2 +-
 6 files changed, 6 insertions(+), 6 deletions(-)

commit 04b23addf3733873667675df2439725f076c2f36
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-07 15:47:20 +0300

    tuklib_integer: Fix building on OpenBSD/sparc64 that uses GCC 4.2
    
    GCC 4.2 doesn't have __builtin_bswap16() and friends so tuklib_integer.h
    tries to use OS-specific byte swap methods instead. On OpenBSD those
    macros are swap16/32/64 instead of bswap16/32/64 like on other *BSDs
    and Darwin.
    
    An alternative to "#ifdef __OpenBSD__" could be "#ifdef swap16" as it
    is a macro. But since OpenBSD seems to be a special case under this
    special case of "*BSDs and Darwin", checking for __OpenBSD__ seems
    the more conservative choice now.
    
    Thanks to Christian Weisgerber and Brad Smith who both submitted
    the same patch a few hours apart.
    
    Co-authored-by: Christian Weisgerber <naddy@mips.inka.de>
    Co-authored-by: Brad Smith <brad@comstyle.com>
    Closes: https://github.com/tukaani-project/xz/pull/126

 src/common/tuklib_integer.h | 12 +++++++++---
 1 file changed, 9 insertions(+), 3 deletions(-)

commit dc03f6290f5b9bd3d50c7e12e58dee870889d599
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-07 15:06:59 +0300

    liblzma: Add ARM64 CRC32 instruction support detection on OpenBSD
    
    The C code is from Christian Weisgerber, I merely reordered the OSes.
    Then I added the build system checks without testing them.
    
    Also thanks to Brad Smith who submitted a similar patch on GitHub
    a few hours after Christian had sent his via email.
    
    Co-authored-by: Christian Weisgerber <naddy@mips.inka.de>
    Closes: https://github.com/tukaani-project/xz/pull/125

 CMakeLists.txt                  |  6 ++++++
 configure.ac                    |  9 +++++++++
 src/liblzma/check/crc32_arm64.h | 15 +++++++++++++++
 src/liblzma/check/crc_common.h  |  1 +
 4 files changed, 31 insertions(+)

commit f5c2ae58ec68c665e62c790b842657afcb31474c
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-05 13:55:43 +0300

    Update THANKS

 THANKS | 2 ++
 1 file changed, 2 insertions(+)

commit e5491dfab9c54dc7078a8d3d07fabb91d6e06418
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-05 13:42:47 +0300

    CMake: Include the "alpha" or "beta" suffix in PACKAGE_VERSION
    
    This way the version string gets into xzgrep and other scripts
    in full and also into liblzma.pc.
    
    For the project() command, a suffixless string is required though.

 CMakeLists.txt | 16 +++++++++++++---
 1 file changed, 13 insertions(+), 3 deletions(-)

commit 1d3c61575fda0be6b2d50c9e32a343349d5cd5c0
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-05 13:30:28 +0300

    CMake: Fix wrong version variable
    
    liblzma_VERSION has never existed in the repository. xz_VERSION from
    the project() command was used for liblzma SOVERSION so use xz_VERSION
    here too.
    
    The wrong variable did no harm in practice as PROJECT_VERSION
    was used as the fallback. It has the same value as xz_VERSION.
    
    Fixes: 7e3493d40eac0c3fa3d5124097745a70e15c41f6

 CMakeLists.txt | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 5d1c649ba9eb7a5b9371252ebfbc2911dc774e69
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-05 12:59:59 +0300

    CMake: Set only "prefix" as an absolute path in liblzma.pc
    
    CMake provides variables that are relative to CMAKE_INSTALL_PREFIX
    so use them instead of repeating the full path.

 CMakeLists.txt | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit e0d6d05ce0d464e966c0669bbf869202a43cc2f7
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-04 23:59:29 +0300

    CMake: Fix liblzma filename in Windows environments
    
    This is a mess because liblzma DLL outside Cygwin and MSYS2
    is liblzma.dll instead of lzma.dll to avoid a conflict with
    lzma.dll from LZMA SDK.
    
    On Cygwin the name was "liblzma-5.dll" while "cyglzma-5.dll"
    would have been correct (and match what Libtool produces).
    MSYS2 likely was broken too as it uses the "msys-" prefix.
    
    This change has no effect with MinGW-w64 because with that
    the "lib" prefix was correct already.
    
    With MSVC builds this is a small breaking change that requires developers
    to adjust the library name when linking against liblzma. The liblzma.dll
    name is kept as is but the import library and static library are now
    lzma.lib instead of liblzma.lib. This is helpful when using pkgconf
    because "pkgconf --msvc-syntax --libs liblzma" outputs "lzma.lib"
    (it's converted from "-llzma" in liblzma.pc). It would be easy to
    keep the liblzma.lib naming but the pkgconf compatibility seems worth
    it in the long run. The lzma.lib name is compatible with MinGW-w64
    too as -llzma will find also lzma.lib.
    
    vcpkg had been patching CMakeLists.txt this way since 2022 but I
    learned this only recently. The reasoning for the patch makes sense,
    and while this is a small breaking change with MSVC, it seems like
    a decent compromise as it keeps the DLL name the same.
    
    2022 patch in vcpkg: https://github.com/microsoft/vcpkg/blob/0707a17ecf1466d64cf1a3c1ee18c8ff02aadb2d/ports/liblzma/win_output_name.patch
    See the discussion: https://github.com/microsoft/vcpkg/pull/39024
    
    Thanks to Vincent Torri for confirming the naming issue on Cygwin.

 CMakeLists.txt | 34 ++++++++++++++++++++++++++++++----
 1 file changed, 30 insertions(+), 4 deletions(-)

commit e7a42cda7c827e016619e8cab15e2faf5d4181ae
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-03 16:55:03 +0300

    Fix version.sh compatiblity with Solaris
    
    The ancient /bin/tr on Solaris doesn't support '\n'.
    With /usr/xpg4/bin/tr it works but it might not be in PATH.
    
    Another problem was that sed was given input that didn't have a newline
    at the end. Text files must end with a newline to be portable.
    
    Fix both problems:
    
      - Handle multiline input within sed itself to avoid one tr invocation.
        The default sed even on Solaris does understand \n.
    
      - Use octals in tr -d. \012 works for ASCII "line feed", it's even
        used as an example in the Solaris man page. But we must strip
        also ASCII "carriage return" \015 and EBCDIC "next line" \025.
        The EBCDIC case got handled with \n previously. Stripping \012
        and \015 on EBCDIC system won't matter as those control chars
        won't be present in the string in the first place.
    
    An awk-based solution could be an alternative but it might need
    special casing on Solaris to used nawk instead of awk. The changes
    in this commit are smaller and should have a smaller risk for
    regressions. It's also possible that version.sh will be dropped
    entirely at some point.

 build-aux/version.sh | 5 ++---
 1 file changed, 2 insertions(+), 3 deletions(-)

commit a61c9ab4751f2710dcd5459c7d74bbf20781f0f9
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-03 17:07:11 +0300

    CI: Don't require po4a on Solaris

 .github/workflows/solaris.yml | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 5229bdf5335ce18ed54beb7e646e39927663be86
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-03 15:08:15 +0300

    CI: Use set -e on Solaris too

 .github/workflows/solaris.yml | 1 +
 1 file changed, 1 insertion(+)

commit afa938e429c1ce07d26d02999352fb014b62ff3d
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-03 17:44:50 +0300

    CMake: Install liblzma.pc even with MSVC
    
    I had misunderstood that it wouldn't be useful with MSVC.
    vcpkg had been installing liblzma.pc with custom rules since 2020,
    years before liblzma.pc support was added to CMakeLists.txt.
    
    See:
    https://github.com/microsoft/vcpkg/blob/eb895b95aac6fd7485373702f29f508c42a180a0/ports/liblzma/portfile.cmake
    https://github.com/microsoft/vcpkg/pull/39024#issuecomment-2145064670

 CMakeLists.txt | 8 +++-----
 1 file changed, 3 insertions(+), 5 deletions(-)

commit 35f8649f08341639a627fd06350e938124ca3622
Author: Sam James <sam@gentoo.org>
Date:   2024-06-03 06:16:23 +0100

    ci: don't pin official GH actions via commit, just tag
    
    There's no real value in doing it via commit for official GH actions. We
    can keep using pinned commits for unofficial actions. It's hassle for no
    gain.
    
    Maybe going forward we can limit this further by only being paranoid
    for the jobs with any access to tokens.

 .github/workflows/ci.yml         | 4 ++--
 .github/workflows/freebsd.yml    | 2 +-
 .github/workflows/netbsd.yml     | 2 +-
 .github/workflows/openbsd.yml    | 2 +-
 .github/workflows/solaris.yml    | 2 +-
 .github/workflows/windows-ci.yml | 4 ++--
 6 files changed, 8 insertions(+), 8 deletions(-)

commit e885dae37ff5b1dbc760dabc1e03e866a7302ef2
Author: Christoph Junghans <christoph.junghans@gmail.com>
Date:   2024-04-30 07:49:26 -0600

    ci: set -e on openbsd
    
    Closes: https://github.com/tukaani-project/xz/pull/116

 .github/workflows/openbsd.yml | 1 +
 1 file changed, 1 insertion(+)

commit 21b02dd128cf9e8c76325ec124f70381862dcf19
Author: Christoph Junghans <christoph.junghans@gmail.com>
Date:   2024-04-30 07:48:58 -0600

    ci: set -e on netbsd

 .github/workflows/netbsd.yml | 1 +
 1 file changed, 1 insertion(+)

commit 8641f0c24c041136670c975b23408184b45431bc
Author: Christoph Junghans <christoph.junghans@gmail.com>
Date:   2024-04-25 14:56:06 -0700

    ci: actually fail on FreeBSD
    
    Without "set -e" the job will always be successful.
    
    See vmactions/freebsd-vm#72

 .github/workflows/freebsd.yml | 1 +
 1 file changed, 1 insertion(+)

commit ef616683ef11f11ffdfbe0624da33905e28a70f9
Author: Andrew Murray <radarhere@users.noreply.github.com>
Date:   2024-04-25 09:24:46 +1000

    Updated actions
    
    Closes: https://github.com/tukaani-project/xz/pull/115

 .github/workflows/ci.yml         | 4 ++--
 .github/workflows/windows-ci.yml | 6 +++---
 2 files changed, 5 insertions(+), 5 deletions(-)

commit 57b440d316da9ac9cb312ee7e6890f5382556f10
Author: Sam James <sam@gentoo.org>
Date:   2024-06-03 02:49:40 +0100

    ci: add po4a

 .github/workflows/netbsd.yml  | 2 +-
 .github/workflows/openbsd.yml | 3 ++-
 2 files changed, 3 insertions(+), 2 deletions(-)

commit 08cdf4be9a673d78efe393b53dd73bf43c81dd95
Author: Sam James <sam@gentoo.org>
Date:   2024-04-13 21:02:04 +0100

    ci: add Solaris
    
    Inspired by https://github.com/RsyncProject/rsync/commit/3f2a38b01184cae9a931280b534acf5a3dae2e94.
    
    It runs on Solaris 5.11 via a VirtualBox VM.

 .github/workflows/solaris.yml | 31 +++++++++++++++++++++++++++++++
 1 file changed, 31 insertions(+)

commit b69768c8bd1a34fde311935c551d061ba52d9a3f
Author: Sam James <sam@gentoo.org>
Date:   2024-04-14 08:08:00 +0100

    xz: list: suppress -Wformat-nonliteral for Solaris
    
    Solaris' GCC can't understand that our use is fine, unlike modern compilers:
    ```
    list.c: In function 'print_totals_basic':
    list.c:1191:4: error: format not a string literal, argument types not checked [-Werror=format-nonliteral]
      uint64_to_str(totals.files, 0));
      ^~~~~~~~~~~~~
    cc1: all warnings being treated as errors
    ```
    
    It's presumably because of older gettext missing format attributes.
    
    This is with `gcc (GCC) 7.3.0`.

 src/xz/list.c | 7 +++++++
 1 file changed, 7 insertions(+)

commit bb90e1f66d9beb490c4c99763e79519045968710
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-06-03 11:44:28 +0300

    license-check.sh: Fix reporting of unclear license info
    
    The main feature was broken because an old variable name hadn't
    been updated to match the rest of the script.

 build-aux/license-check.sh | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit b8d134e61ede9f4a296226d97f5c20721fb4e8e2
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-05-31 21:36:26 +0300

    Update THANKS

 THANKS | 3 +++
 1 file changed, 3 insertions(+)

commit 162587d3fb3fcedc6eee61eda3ccaaf60c80f0de
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-05-29 17:47:13 +0300

    Translations: Run po4a/update-po
    
    Now the files are in the new formatting without source file
    line numbers. Future updates should keep the diffs much smaller.

 po4a/de.po    | 1592 ++++++++++---------
 po4a/fr.po    | 4450 +++++++++++++++++-----------------------------------
 po4a/ko.po    | 1592 ++++++++++---------
 po4a/pt_BR.po | 4817 ++++++++++++++++++---------------------------------------
 po4a/ro.po    | 1592 ++++++++++---------
 po4a/uk.po    | 1592 ++++++++++---------
 6 files changed, 6114 insertions(+), 9521 deletions(-)

commit 50cd8ed002473c5cd53980e70a53e5e6ad646ffe
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-05-29 17:44:53 +0300

    Translations: Run "make -C po update-po"
    
    In the past this wasn't done before releases; the Git repository
    just contained the files from the Translation Project. But this
    way it is clearer when comparing release tarballs against the
    Git repository. In future releases this might no longer be necessary
    within a stable branch as the .po files won't change so easily anymore
    when creating a tarball.

 po/ca.po    | 567 +++++++++++++++++++++++++---------------
 po/cs.po    | 821 +++++++++++++++++++++++++++++++++++++--------------------
 po/da.po    | 809 +++++++++++++++++++++++++++++++++++---------------------
 po/de.po    | 403 ++++++++++++++--------------
 po/eo.po    | 403 ++++++++++++++--------------
 po/es.po    | 403 ++++++++++++++--------------
 po/fi.po    | 578 +++++++++++++++++++++++++---------------
 po/fr.po    | 538 +++++++++++++++++++++++---------------
 po/hr.po    | 403 ++++++++++++++--------------
 po/hu.po    | 403 ++++++++++++++--------------
 po/it.po    | 854 +++++++++++++++++++++++++++++++++++++++---------------------
 po/ko.po    | 403 ++++++++++++++--------------
 po/pl.po    | 403 ++++++++++++++--------------
 po/pt.po    | 842 +++++++++++++++++++++++++++++++++++++++--------------------
 po/pt_BR.po | 567 +++++++++++++++++++++++++---------------
 po/ro.po    | 403 ++++++++++++++--------------
 po/sr.po    | 838 ++++++++++++++++++++++++++++++++++++++--------------------
 po/sv.po    | 403 ++++++++++++++--------------
 po/tr.po    | 567 +++++++++++++++++++++++++---------------
 po/uk.po    | 403 ++++++++++++++--------------
 po/vi.po    | 403 ++++++++++++++--------------
 po/zh_CN.po | 417 +++++++++++++++--------------
 po/zh_TW.po | 558 ++++++++++++++++++++++++---------------
 23 files changed, 7257 insertions(+), 5132 deletions(-)

commit 16dbd865c8833462e1604a1e13f7effe55bb3fe6
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-05-29 18:03:04 +0300

    Add NEWS for 5.6.2

 NEWS | 130 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 130 insertions(+)

commit a0eeb5f9369c43508610dcf00140edb8e2be92a6
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-05-29 18:03:04 +0300

    Add NEWS for 5.4.7

 NEWS | 89 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 89 insertions(+)

commit 9b476fb93a9672f2e70b56e3e9c7e9cfedd6c162
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-05-29 18:03:04 +0300

    Add NEWS for 5.2.13

 NEWS | 115 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 115 insertions(+)

commit 9284f1aea31f0eb23e2ea72f7218b271e2234762
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-05-29 16:33:24 +0300

    Build: Update po/*.po files only when needed
    
    When po/xz.pot doesn't exist, running "make" or "make dist" will
    create it. Then the .po files will be updated but only if they
    actually would change more than the POT-Creation-Date line.
    Then the .gmo files would be generated from the .po files.
    This is the case before and after this commit.
    
    However, "make dist" and thus "make mydist" did a forced update
    to the files, updating them even if the only change was the
    POT-Creation-Date line. This had pros and cons: It made it clear
    that the .po file really is in sync with the recent strings in
    the package. On the other hand, it added noise in form of changed
    files in the source tree and distribution tarballs. It can be
    ignored with something like "diff -I'^"POT-Creation-Date: '" but
    it's still a minor annoyance *if* there's not enough value in
    having the most recent timestamp.
    
    Setting DIST_DEPENDS_ON_UPDATE_PO = no means that such forced
    update won't happen in "make dist" anymore. However, the "mydist"
    target will use xz.pot-update target which is the same target that
    is run when xz.pot doesn't exist at all yet. Thus "mydist" will
    ensure that the translations are up to date, without noise from
    changes that would affect only the POT-Creation-Date line.
    
    Note that po4a always uses msgmerge with --update, so POT-Creation-Date
    in the man page translations is never the only change in .po files.
    In that sense this commit makes the message translations behave more
    similarly to the man page translations.
    
    Distribution tarballs will still have non-reproducible POT-Creation-Date
    in po/xz.pot and po4a/xz-man.pot but those are just two files. Even they
    could be made reproducible from a Git timestamp if desired.

 Makefile.am | 3 ++-
 po/Makevars | 6 +++++-
 2 files changed, 7 insertions(+), 2 deletions(-)

commit 4beba1cd62d7f8f7a6f1e899b68292d94c53b599
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-05-28 21:10:33 +0300

    po4a/update-po: Disable wrapping in .pot and .po files
    
    The .po files from the Translation Project come with unwrapped
    strings so this matches it.
    
    This may reduce the noise in diffs too. When the beginning of
    a paragraph had changed, the rest of the lines got rewrapped
    in msgsid. Now it's just one very long line that changes when
    a paragraph has been edited.
    
    The --add-location=file option was removed as redundant. The line
    numbers don't exist in the .pot file due to --porefs file and thus
    they cannot get copied to the .po files either.

 po4a/update-po | 15 +++++++++++----
 1 file changed, 11 insertions(+), 4 deletions(-)

commit b14c130a58a649f9a73392eeb122cb252327c569
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-05-28 18:36:53 +0300

    Update contact info in README

 README | 12 +++++++++---
 1 file changed, 9 insertions(+), 3 deletions(-)

commit 75f5f2e014b0ee646963f36bc6a9c840fb272353
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-05-28 13:25:07 +0300

    Translations: Use --package-name=xz-man with po4a
    
    This is to match reality. See the added comment.

 po4a/update-po | 9 ++++++++-
 1 file changed, 8 insertions(+), 1 deletion(-)

commit eb217d016cfbbba1babc19a61095b3ea25898af6
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-05-28 13:03:40 +0300

    Translations: Omit --package-name from po/Makevars
    
    This is closer to the reality in the po/*.po files.

 po/Makevars | 3 +--
 1 file changed, 1 insertion(+), 2 deletions(-)

commit d28a4b2520adeeaa1b9e921bf42c7c1f36552c06
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-05-27 17:45:51 +0300

    license-check.sh: Use '--' with slightly untrusted filenames
    
    Names from git ls-files should be safe but if one runs it on
    a tree without the .git dir and there are extra files, it's
    safer to have the end of arguments marked with '--'.

 build-aux/license-check.sh | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit fda0ec862a34094cf23fc25d0e0a95858c3a3ab5
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-05-27 17:41:37 +0300

    license-check.sh: Use xargs -0 instead of -d
    
    Neither are in POSIX but -0 is much more portable in practice.
    
    Despite the old comment, the grep usage should be portable already.

 build-aux/license-check.sh | 11 ++++++-----
 1 file changed, 6 insertions(+), 5 deletions(-)

commit 9114267038deaecf4832a5cacb5acbe6591ac839
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-05-28 01:17:45 +0300

    Translations: Omit man page line numbers from .pot and .po files

 po4a/update-po | 5 +++++
 1 file changed, 5 insertions(+)

commit 093490b58271e9424ce38a7b1b38bcf61b9c86c6
Author: Lasse Collin <lasse.collin@tukaani.org>
Date:   2024-05-28 01:06:30 +0300

